; codecaddy v2.10x - EJN (blueznl)
; multifunctional plugin for the purebasic IDE
; bluez@xs4all.nl
;
#codecaddy_version = "v2.10x"
#codecaddy_copyright = "c2005..2015 EJN"
;
; uncomment next four lines if you're not using codecaddy yet (in which case you will also have to remove
; all line continuation characters _ and subsequent cr's which can be done by codecaddy's 'flatten / remove multiline' function)
;
; #codecaddy_compilerun = #false
; #codecaddy_build_nr = 0
; #codecaddy_build_date = 0
; #codecaddy_save_nr = 0
;
EnableExplicit
IncludeFile("..\x_lib\x_lib.pb")
Declare main()
Declare init()
Declare clear_codearray()
Declare draw()
Declare reflect_settings()
;
x_init()
init()
main()
x_end()
End

Procedure history()
  ;
  ; planned
  ;
  ; - regexp support in search strings
  ; - command line parameter 'filesync' to sync specified folders
  ; - auto scroll list view window on codesync (sure?)
  ; - fix some screen update issues with windows 7
  ;
  ; current
  ;
  ; - nothing yet
  ;
  ; 2.10x
  ;
  ; - bugfix to detect modules ::
  ; - minor modifications caused by updated x_lib.pb
  ;
  ; 2.09x
  ;
  ; - change in (calling) the redraw routine to handle pb 5.30 changed resize message handling
  ; - changed default keywords for formatting to reflect 4.60's formatting
  ; - compiled with 5.20b7
  ; - doing a websearch on a url opens that url instead of searching for it
  ;
  ; 2.04x
  ;
  ; - compiled with pb 4.60rc1
  ;
  ; 2.03x
  ;
  ; - number of rewrites in x_lib, none of them should affect codecaddy though
  ;
  ; 2.01x
  ;
  ; - change in multiline character detection: multiline character must be preceeded by a space
  ;
  ; 2.00
  ;
  ; - recompile to check changed library
  ;
  ; 1.99
  ;
  ; - create a tools.prefs file if there wasn't one yet
  ;
  ; 1.98
  ;
  ; - corrected wrong version number
  ; - minor fix in displayed filename of last build
  ; - option to add whitespace after procedure declarations for easier commenting
  ; - bugfix thinner, i missed a nested foreach / next due to recursion, fixed (well, more like hacked actually)
  ;
  ; 1.93
  ;
  ; - compiled with 4.50 rc2
  ;
  ; 1.90
  ;
  ; - compiled with pb 4.50b2
  ; - added some support for unc paths (not extensively tested)
  ; - small fix preparing for x64 version
  ; - bugfix in thinner, it missed some procedure names that contained mixed upper/lowercase
  ; - thinner now also strips out unused declare statements
  ; - reorganized x_lib with some minor bugfixes
  ; - additional search paths for web search
  ; - bugfixes codesync (would not create paths as the used winapi was not supporting unicode)
  ;
  ; 1.71z
  ;
  ; - bugfix in PB IDE install function
  ; - should :-) have improved the install in PB IDE function
  ; - support for tab key in fields under preferences / web tab
  ;
  ; 1.63x
  ;
  ; - fixed a bug when moved to pb4.41, avoid triggering unneccessary events when updating codepanel
  ; - converted (almost) all longs to integers (.l to .i) for future compatibility
  ; - code now runs using enableexplicit (hope i did not break anything)
  ; - reformat basic indent size can now be set from preferences
  ; - added keywords macro endmacro to automatic formatting
  ; - added keyword forever to automatic formatting
  ;
  ; 1.57x
  ;
  ; - added unicode detection to the reformat function
  ; - support for 'snapshots'
  ; - added exclusion of snapshot and (optionally) build files with backups
  ; - fixed a (very old) bug where build number and save number would be lost after removal of .cdy file
  ; - converted to pb4.40b3
  ; - updated license text to include regular expression library
  ;
  ; 1.26x
  ;
  ; - fixed installer (case dependency)
  ; - fixed codesync (yes, working again, finally)
  ;
  ; 1.22x
  ;
  ; - another unicode bug squashed, saving now works in utf8 as well, still no codesync...
  ;
  ; 1.19x
  ;
  ; - converted to pb4.30
  ; - fixed install
  ; - fixed some unicode issues
  ;
  ; 1.18x
  ;
  ; - fixed possible bug when using apply in preferences
  ; - converting to pb4.30, first working code
  ;
  ; 1.16x
  ;
  ; - worked on unicode issues, seems to be okay now
  ;
  ; 1.15x
  ;
  ; - fixed crash on multiple instances
  ; - fixed logfile showing off-screen (bug in x_lib)
  ; - codesync still needs to be fixed!
  ;
  ; 1.14x
  ;
  ; - ooops, unicode release did fail nicely, needs some rework
  ;
  ; 1.12x
  ;
  ; - changes in x_lib() and updating to 4.xx broke some things, should be fixed now
  ;
  ; 1.11x
  ;
  ; - converting to pb4.x!
  ; - changed default backup numbering to 5 digits (work on codecaddy and x_lib show that 10000 saves is quite possible)
  ; - need to rewrite codesync feature due to changes in x_lib, sigh...
  ;
  ; 1.06x
  ;
  ; - search crashed if 'keep dialogs nearby' was switched off (typo in source)
  ;
  ; 1.05x
  ;
  ; - replace all tab's with 5 spaces when doing a reformat
  ;
  ; 1.03x
  ;
  ; - added .swf intro file
  ; - added preceeding multiline underscore
  ; - some very minor fixes
  ;
  ; 1.02x
  ;
  ; - replaced flatten algoritm for flatten function, preprocess and reformat didn't change
  ;
  ; 1.01
  ;
  ; - recompile, lost the original exe :-) but code should be identical
  ; - minor changes in the doc file
  ;
  ; 1.00b
  ;
  ; - ooops, missed writing a CRLF in the preprocess part, fixed
  ;
  ; 1.00a
  ;
  ; - first full (yeah right) release... we've made it past the hated '0' range :-)
  ; - added BOM support for unicode files
  ; - modified codesync to jump to 'totals' section when running within the gui
  ; - modified quickhelp file
  ;
  ; 0.99x
  ;
  ; - iconic and maximized support
  ; - added codesync output to listpanel when in gui
  ; - updated history section :-)
  ;
  ; 0.98x
  ;
  ; - fixed missing detection of included files
  ;
  ; 0.96x
  ;
  ; - bypass for unnamed / unsaved sources
  ; - better handling of max / min windows
  ;
  ; 0.93x
  ;
  ; - improved updating of list panel
  ; - no more empty lines in catagorized view (yeah!)
  ; - added non-saving find
  ;
  ; 0.92x
  ;
  ; - added keyboard shortcuts
  ; - modified response to some command line parameters
  ;
  ; 0.90x
  ;
  ; - loads of added features and functions, preparing for release
  ;
  ; 0.85x
  ;
  ; - enormous struggles with single instancing and pop to front
  ;
  ; 0.75x
  ;
  ; - working search functionality
  ;
  ; 0.60x
  ;
  ; - allows more lines
  ; - auto-trims and enables / disables logfile
  ;
  ; 0.58x
  ;
  ; - now able to modify pb's tools.prefs
  ;
  ; 0.54x
  ;
  ; - bugfix backup wraparound
  ;
  ; 0.51x
  ;
  ; - changed spin gadget limits
  ;
  ; 0.00x
  ;
  ; - a long time ago...
  ;
EndProcedure

Procedure init()                                           ; initialize and prepare
  ;
  ;
  ; *** functions and menu entries
  ;
  ;
  Enumeration
    ;
    ; either real menu entries or logical functions triggered by gadgets or events
    ; grouped per window
    ;
    ; note 1: functions could be called from other windows / menus / buttons etc as well
    ; note 2: not all may (yet) be implemented
    ;
    ; *** main - menu - file
    ; *** main - functions
    ; *** search - functions
    ;
    #f_file_exit                                ; whaddayathink
    ;
    ; *** main - menu - search
    ;
    #f_search_window                            ; open search window
    #f_search_pause                             ; pause function
    ;
    #f_search_previous
    #f_search_next
    #f_splitter_zoom                            ; zoom
    #f_search_extra                             ; fluff as in: additional but useless information :-)
    ;
    #f_filter_categorized                       ; function: limit results to n per category
    #f_filter_procedure                         ; function or flag: marks entry as procedure (i use this as a menu flag, an 'action' flag, as well as an identifier for the type of match, ie. is it a procedure etc.
    #f_filter_structure                         ; function or flag: marks entry as structure
    #f_filter_constant                          ; function or flag: marks entry as constant
    #f_filter_variable                          ; function or flag: marks entry as variable
    #f_filter_all                               ; function or flag: marks entry as other matching search params
    ;
    #f_search_included                          ; process 'include'
    #f_search_beginwith                         ; matches must start with search string
    #f_search_wildcards                         ; allow wildcards
    #f_search_widen                             ; strip leading / trailing spaces from search term and add a leading / trailing *
    #f_search_narrow                            ; filter space +-/()^* unless search term contains these
    ;
    #f_search_files
    ;
    ; *** main - menu - tools
    ;
    #f_tools_format
    #f_tools_flatten
    #f_tools_thinner
    #f_tools_codesync
    #f_tools_installinpbide
    ;
    ; *** main - menu - options
    ;
    #f_show_menu
    #f_show_toolbar
    #f_show_buttons
    #f_show_statusbar
    #f_show_keepontop
    ;
    #f_prep_savebackup
    #f_prep_addconstants
    #f_prep_multiline
    #f_log_maintain
    #f_log_showonerror
    #f_show_darkercolors
    ;
    #f_config_saveonexit
    #f_config_savenow
    ;
    #f_open_prefs                               ; open preferences window
    ;
    ; *** main - menu - help
    ;
    #f_help                                     ; show (quick)help
    #f_quickhelp                                ; show quickhelp
    #f_license                                  ; show license
    #f_display_logfile                          ; show the logfile (wow, surprising)
    #f_display_info                             ; show info on current loaded file
    #f_flash                                    ; show the flash introduction
    #f_homepage                                 ; launch firefox and
    #f_about                                    ; show the about box
    ;
    ; *** main window - toolbar (if not yet listed)
    ;
    #f_search_toggle                            ; toggles wildcard mode and relaunches a search
    #f_search_plus
    #f_search_min
    #f_copy                                     ; copy selected data to clipboard
    #f_edit                                     ; start ide with selected source
    ;
    ; *** main window - buttons (if not yet listed)
    ;
    ; *** prefs window (if not yet listed)
    ;
    #f_show_unzoom
    #f_format_keywords
    #f_log_showoncmd
    #f_prefs_ok
    #f_prefs_resetconfig
    #f_prep_thinbuilds
    ;
    ; *** search window
    ;
    #f_search_cancel
    #f_search_start
    ;
    ; *** other
    ;
    ;
  EndEnumeration
  ;
  ;
  ; *** windows and gadgets
  ;
  ;
  Enumeration #PB_Compiler_EnumerationValue
    ;
    ; windows
    ;
    #w_prefs_nr
    #w_main_nr
    #w_about_nr
    #w_search_nr
    #w_flash_nr
    #w_progress_nr
    ;
    ; menus
    ;
    #m_main_nr
    ;
    ; toolbars
    ;
    #tb_main_nr
    ;
    ; status bars
    ;
    #sb_main_nr
    ;
    ; gadgets - main
    ;
    #g_codepanel
    #g_listpanel
    #g_open_search
    #g_search_pause
    #g_search_toggle
    #g_select
    #g_previous
    #g_next
    #g_filter_categorized
    #g_filter_procedure
    #g_filter_structure
    #g_filter_constant
    #g_filter_variable
    #g_filter_all
    #g_copy
    #g_edit
    #g_show_menu
    #g_open_prefs
    #g_exit
    #g_help
    #g_splitter
    #g_splitter_zoom
    #g_search_extra
    #g_show_keepontop
    #g_flash_webgadget
    ;
    ; gadgets - about
    ;
    #g_about_wackoware
    ;
    ; gadgets - prefs
    ;
    #g_prefs_panel
    #g_prefs_reset
    #g_prefs_apply
    #g_prefs_save
    #g_prefs_ok
    #g_prefs_cancel
    ;
    ; gadgets - prefs - gui
    ;
    #g_prefs_gui
    #g_prefs_config_saveonexit
    #g_prefs_controls_f
    #g_prefs_show_menu
    #g_prefs_show_toolbar
    #g_prefs_show_buttons
    #g_prefs_show_statusbar
    #g_prefs_show_keepontop
    #g_prefs_show_darkercolors
    #g_prefs_show_nearbydialogs
    #g_prefs_show_unzoom
    #g_prefs_appearance_f
    #g_prefs_font
    #g_prefs_font_t
    #g_prefs_spacing_frame
    #g_prefs_spacing_frame_t
    #g_prefs_spacing_buttons
    #g_prefs_spacing_buttons_t
    #g_prefs_search_options
    #g_prefs_search_firstnr
    #g_prefs_search_firstnr_t
    #g_prefs_search_extra
    ;
    ; gadgets - prefs - backup
    ;
    #g_prefs_backup_t
    #g_prefs_backup_what_f
    #g_prefs_save_max
    #g_prefs_save_max_t
    #g_prefs_save_excludebuilds
    #g_prefs_save_excludebuilds_t
    #g_prefs_save_excludesnapshots
    #g_prefs_save_excludesnapshots_t
    #g_prefs_save_length
    #g_prefs_save_length_t
    #g_prefs_backup_where_f
    #g_prefs_save_baktobackup
    #g_prefs_save_cdytobackup
    #g_prefs_backup_when_f
    #g_prefs_compilerun_savefrequency
    #g_prefs_compilerun_savefrequency_t
    #g_prefs_compilerun_autosaveinterval
    #g_prefs_compilerun_autosaveinterval_t
    #g_prefs_backup_note_t
    ;
    ; gadgets - prefs - preprocess
    ;
    #g_prefs_prep_t
    #g_prefs_prep_generic_f
    #g_prefs_prep_savebackup
    #g_prefs_prep_addconstants
    #g_prefs_prep_multiline
    #g_prefs_prep_keepsync
    #g_prefs_prep_thinbuilds
    #g_prefs_prep_thindeep
    #g_prefs_prep_note_t
    ;
    ; gadgets - prefs - other
    ;
    #g_prefs_format_f
    #g_prefs_format_smart
    #g_prefs_format_multiline
    #g_prefs_format_multiline_indent
    #g_prefs_format_procedure
    #g_prefs_format_procedure_space
    #g_prefs_format_indent
    #g_prefs_format_indent_t
    #g_prefs_codesync_f
    #g_prefs_codesync_folder1
    #g_prefs_codesync_folder1_t
    #g_prefs_codesync_select1
    #g_prefs_codesync_folder2
    #g_prefs_codesync_folder2_t
    #g_prefs_codesync_select2
    #g_prefs_codesync_filter
    #g_prefs_codesync_filter_t
    #g_prefs_codesync_baklimit
    #g_prefs_codesync_baklimit_t
    #g_prefs_codesync_confirmation
    #g_prefs_commandline_f
    #g_prefs_log_maintain
    #g_prefs_log_showoncmd
    #g_prefs_log_showonerror
    #g_prefs_command_node_t
    ;
    ; gadgets - prefs - keywords
    ;
    #g_prefs_keywords_t
    #g_prefs_keywords_single_f
    #g_prefs_keywords_up_t
    #g_prefs_keywords_up
    #g_prefs_keywords_down_t
    #g_prefs_keywords_down
    #g_prefs_keywords_double_f
    #g_prefs_keywords_doubleup_t
    #g_prefs_keywords_doubleup
    #g_prefs_keywords_doubledown_t
    #g_prefs_keywords_doubledown
    ;
    ; gadgets - prefs - search
    ;
    #g_prefs_search_local_t
    #g_prefs_search_current
    #g_prefs_search_current_t
    #g_prefs_search_basic_t
    #g_prefs_search_basic
    #g_prefs_search_basic_file
    #g_prefs_search_basic_folder
    #g_prefs_search_extended_t
    #g_prefs_search_extended
    #g_prefs_search_extended_file
    #g_prefs_search_extended_folder
    ;
    ; gadgets - prefs - internet
    ;
    #g_prefs_web_t
    #g_prefs_web_keyword
    #g_prefs_web_keyword_t
    #g_prefs_web_browser_t
    #g_prefs_web_browser
    #g_prefs_web_empty_t
    #g_prefs_web_empty
    #g_prefs_web_underscore_t
    #g_prefs_web_underscore
    #g_prefs_web_other_t
    #g_prefs_web_other
    ;
    ; gadgets - search
    ;
    #g_search_findstring_t
    #g_search_findstring
    #g_search_options
    #g_search_cancel
    #g_search_start
    #g_search_wildcards
    #g_search_widen
    #g_search_narrow
    #g_search_included
    #g_search_beginwith
    ;
    ; gadgets - progress, thinner and codesync
    ;
    #g_progress_cancel
    #g_progress_bar
    #g_progress_top
    #g_progress_bottom
    ;
  EndEnumeration
  ;
  ;
  ; *** images and icons
  ;
  ;
  Enumeration #PB_Compiler_EnumerationValue
    ;
    #i_file_open
    #i_find
    #i_play
    #i_format
    #i_previous
    #i_next
    #i_font
    #i_font_plus
    #i_font_min
    #i_eye_big
    #i_eye_two
    #i_edit_copy
    #i_purebasic_white
    #i_exit
    #i_menu
    #i_pin
    #i_help
    #i_properties
    #i_binoculars
    #i_splitter
    #i_pause
    #i_wackoware
    #i_about
    #i_bullets_numbers
    #i_paragraph_info
    #i_paragraph_plus
    #i_paragraph_min
    ;
    #i_led_darkgreen
    #i_led_red
    #i_led_yellow
    #i_led_green
    #i_led_blue
    ;
  EndEnumeration
  ;
  DataSection
    ;
    i_file_open_data:
    IncludeBinary("icons\file_open.ico")
    i_search_data:
    IncludeBinary("icons\find_2.ico")
    i_binoculars_data:
    IncludeBinary "icons\binoculars.ico"
    i_format_data:
    IncludeBinary "icons\format_columns.ico"
    i_pause_data:
    IncludeBinary "icons\play_pause.ico"
    i_play_data:
    IncludeBinary "icons\play_playforward.ico"
    i_previous_data:
    IncludeBinary "icons\play_previous_2.ico"
    i_next_data:
    IncludeBinary "icons\play_next_2.ico"
    i_font_data:
    IncludeBinary "icons\font.ico"
    i_font_min_data:
    IncludeBinary "icons\font_min.ico"
    i_font_plus_data:
    IncludeBinary "icons\font_plus.ico"
    i_eye_big_data:
    IncludeBinary "icons\eyes_4.ico"
    i_eye_two_data:
    IncludeBinary "icons\eyes_2.ico"
    i_edit_copy_data:
    IncludeBinary "icons\edit_copy.ico"
    i_purebasic_white_data:
    IncludeBinary "icons\purebasic_white.ico"
    i_exit_data:
    IncludeBinary "icons\exit_2.ico"
    i_menu_data:
    IncludeBinary "icons\p_menu_drop.ico"
    i_pin_data:
    IncludeBinary "icons\pin_1.ico"
    i_help_data:
    IncludeBinary "icons\help.ico"
    i_properties_data:
    IncludeBinary "icons\properties_2.ico"
    i_splitter_up:
    IncludeBinary "icons\p_splitter_up.ico"
    i_led_yellow_data:
    IncludeBinary "icons\led_yellow_1.ico"
    i_led_red_data:
    IncludeBinary "icons\led_red_1.ico"
    i_led_green_data:
    IncludeBinary "icons\led_green_1.ico"
    i_led_darkgreen_data:
    IncludeBinary "icons\led_darkgreen_1.ico"
    i_led_blue_data:
    IncludeBinary "icons\led_blue_1.ico"
    i_bullets_numbers_data:
    IncludeBinary "icons\bullets_numbers.ico"
    i_paragraph_info_data:
    IncludeBinary "icons\p_paragraph_info.ico"
    i_paragraph_plus_data:
    IncludeBinary "icons\p_paragraph_plus.ico"
    i_paragraph_min_data:
    IncludeBinary "icons\p_paragraph_min.ico"
    ;
    i_wackoware_data:
    IncludeBinary("images\wackoware.bmp")
    ;
  EndDataSection
  ;
  ; image and icon handles
  ;
  Global i_search_h.i, i_format_h.i, i_previous_h.i, i_next_h.i, i_font_h.i, i_font_plus_h.i
  Global i_font_min_h.i, i_eye_big_h.i, i_edit_copy_h.i, i_purebasic_white_h.i, i_exit_h.i
  Global i_menu_h.i, i_pin_h.i, i_help_h.i,i_properties_h.i, i_binoculars_h.i, i_eye_two_h.i
  Global i_char_p_red_h.i, i_char_s_yellow_h.i, i_char_hash_blue_h.i, i_char_is_green_h.i
  Global i_splitter_zoom_h.i, i_pause_h.i, i_wackoware_h.i, i_file_open_h.i, i_play_h.i
  Global i_bullets_numbers_h.i, i_char_is_black_h.i
  Global i_paragraph_info_h.i, i_paragraph_plus_h.i, i_paragraph_min_h.i
  Global i_char_1_black_h.i, i_char_asterix_black_h.i, i_char_asterix_green_h.i, i_char_plus_black_h.i
  Global i_led_red_h.i, i_led_yellow_h.i, i_led_green_h.i, i_led_blue_h.i, i_led_darkgreen_h.i
  Global i_char_doubleperiod_black_h.i, i_char_wildcards_black_h.i, i_char_5_black_h.i
  ;
  ; loaded icons
  ;
  i_file_open_h = CatchImage(#i_file_open,?i_file_open_data)
  i_search_h = CatchImage(#i_find,?i_search_data)
  i_play_h = CatchImage(#i_play,?i_play_data)
  i_format_h = CatchImage(#i_format,?i_format_data)
  i_previous_h = CatchImage(#i_previous,?i_previous_data)
  i_next_h = CatchImage(#i_next,?i_next_data)
  i_font_h = CatchImage(#i_font,?i_font_data)
  i_font_plus_h = CatchImage(#i_font_plus,?i_font_plus_data)
  i_font_min_h = CatchImage(#i_font_min,?i_font_min_data)
  i_eye_big_h = CatchImage(#i_eye_big,?i_eye_big_data)
  i_eye_two_h = CatchImage(#i_eye_two,?i_eye_two_data)
  i_edit_copy_h = CatchImage(#i_edit_copy,?i_edit_copy_data)
  i_purebasic_white_h = CatchImage(#i_purebasic_white,?i_purebasic_white_data)
  i_exit_h = CatchImage(#i_exit,?i_exit_data)
  i_menu_h = CatchImage(#i_menu,?i_menu_data)
  i_pin_h = CatchImage(#i_pin,?i_pin_data)
  i_help_h = CatchImage(#i_help,?i_help_data)
  i_properties_h = CatchImage(#i_properties,?i_properties_data)
  i_binoculars_h = CatchImage(#i_binoculars,?i_binoculars_data)
  i_splitter_zoom_h = CatchImage(#i_splitter,?i_splitter_up)
  i_pause_h = CatchImage(#i_pause,?i_pause_data)
  i_led_red_h = CatchImage(#i_led_red,?i_led_red_data)
  i_led_green_h = CatchImage(#i_led_green,?i_led_green_data)
  i_led_yellow_h = CatchImage(#i_led_yellow,?i_led_yellow_data)
  i_led_blue_h = CatchImage(#i_led_blue,?i_led_blue_data)
  i_led_darkgreen_h = CatchImage(#i_led_darkgreen,?i_led_darkgreen_data)
  i_bullets_numbers_h = CatchImage(#i_bullets_numbers,?i_bullets_numbers_data)
  i_paragraph_info_h = CatchImage(#i_paragraph_info,?i_paragraph_info_data)
  i_paragraph_plus_h = CatchImage(#i_paragraph_plus,?i_paragraph_plus_data)
  i_paragraph_min_h = CatchImage(#i_paragraph_min,?i_paragraph_min_data)
  ;
  ; created icons
  ;
  i_char_1_black_h = x_icon_charactericon(16,16,"1",RGB(0,0,0),24)
  i_char_5_black_h = x_icon_charactericon(16,16,"5",RGB(0,0,0),24)
  i_char_asterix_black_h = x_icon_charactericon(16,16,"*",RGB(0,0,0),24)
  i_char_asterix_green_h = x_icon_charactericon(16,16,"*",RGB(0,128,0),24)
  i_char_p_red_h = x_icon_charactericon(16,16,"P",RGB(128,0,0),24)
  i_char_s_yellow_h = x_icon_charactericon(16,16,"S",RGB(128,96,64),24)
  i_char_hash_blue_h = x_icon_charactericon(16,16,"#",RGB(0,0,128),24)
  i_char_is_green_h = x_icon_charactericon(16,16,"=",RGB(0,128,0),24)
  i_char_is_black_h = x_icon_charactericon(16,16,"=",RGB(0,0,0),24)
  i_char_plus_black_h = x_icon_charactericon(16,16,"+",RGB(0,0,0),24)
  i_char_doubleperiod_black_h = x_icon_charactericon(16,16,"..",RGB(0,0,0),24)
  i_char_wildcards_black_h = x_icon_charactericon(16,16,"?*",RGB(0,0,0),24)
  ;
  ; images
  ;
  i_wackoware_h = CatchImage(#i_wackoware,?i_wackoware_data)
  ;
  ; created images
  ;
  Global i_about_h.i
  ;
  ;
  ; *** fonts
  ;
  ;
  #font_normal = 0
  #font_bold = 1
  ;
  ; actual fonts etc. used
  ;
  Global font_bold_h.i             ; bold font
  Global font_normal_h.i            ; normal font
  Global font_name.s                ; keep font name
  Global font_size.i                ; keep font size
  ;
  ; placeholders for the preferences menu until applied or ok'ed
  ;
  Global prefs_font_name.s          ; keep font name
  Global prefs_font_size.i          ; keep font size
  ;
  ;
  ; *** other globals
  ;
  ; find results - color markings (set in colorset())
  ;
  Global col_white.i
  Global col_black.i
  Global col_pink.i
  Global col_blue.i
  Global col_orange.i
  Global col_yellow.i
  Global col_green.i
  Global col_grey.i
  ;
  col_white =            $00FFFFFF
  col_black =            $00000000
  ;
  ; gui - components - windows, menus, toolbars etc.
  ;
  Global w_main_h.i, m_main_h.i, sb_main_h.i, tb_main_h.i
  Global w_prefs_h.i, w_about_h.i
  Global w_search_h.i
  ;
  ; gui - components - main
  ;
  Global g_filter_wildcards_h.i
  Global g_filter_categorized_h.i
  Global g_filter_procedure_h.i
  Global g_filter_structure_h.i
  Global g_filter_variable_h.i
  Global g_filter_constant_h.i
  Global g_filter_all_h.i
  Global g_show_menu_h.i
  Global g_show_keepontop_h.i
  Global g_show_darkercolors_h.i
  Global g_search_pause_h.i
  Global g_search_toggle_h.i
  Global g_splitter_zoom_h.i
  Global g_search_extra_h.i
  Global g_codepanel_h.i
  Global g_selected_h.i
  ;
  ; gui - components - prefs and about
  ;
  ; filenames
  ;
  Global backupfile.s               ; path + name of .bak backup file (without an eventual _backup\ part)
  Global configfile.s               ; path + name of configuration
  Global caddyfile.s                ; path + name of .cdy counter file (without an _backup\ part)
  Global file.s                     ; path + name of source code
  Global compilefile.s              ; path + name of file passed on to compiler
  Global unicodemode.i              ; tells codecaddy what kind of file is incoming (used in flatten and pre-process)
  ;
  ; gui appearance
  ;
  Global w_main_x.i, w_main_y.i     ; coordinates and size or main window
  Global w_main_maximized.i
  Global w_main_width.i
  Global w_main_height.i
  Global old_w_main_width           ; used to detect horizontal size changes and adjust the status bar
  Global show_menu.i                ; show menu
  Global show_statusbar.i           ; show statusbar
  Global show_toolbar.i             ; show toolbar
  Global show_buttons.i             ; show buttons
  Global show_keepontop.i           ; keep window on top
  Global show_darkercolors.i        ; use darker color stripes for use on laptops
  Global show_nearbydialogs.i       ; keep dialogs nearby / ontop main window
  Global show_unzoom.i              ; unzoom on previous / next
  Global spacing_frame.i            ; size of border around all gadgets
  Global spacing_buttons.i          ; size of button separator
  Global splitter_permileage.i      ; position of splitter
  Global splitter_swap.i            ; swap top and bottom (not yet implemented)
  Global search_extra.i             ; show additional info for search results
  Global search_firstnr.i           ; show n lines on categorized list
  ;
  ; gui resizing
  ;
  Global old_splitter_height.i      ; used to detect events vs. moving splitter bar
  Global old_splitter_width.i
  ;
  ; gui general
  ;
  Global show_prefs.i               ; true = show the prefs window
  Global show_search.i              ; true = show the search window
  Global splitter_max.i             ; splitter is currently zoomed (max position)
  Global config_saveonexit.i        ; #true to save settings on gui exit
  ;
  ; backup and counters
  ;
  Global save_baktobackup.i         ; #true bak is stored separately
  Global save_cdytobackup.i         ; #true cdy is stored separately
  Global save_nr.i                  ; save counter, stored in .cdy file
  Global build_nr.i                 ; build counter
  Global timestamp.i                ; timestamp of last save, used icw autosaveinterval
  Global save_max.i                 ; maximal number of backup files to keep
  Global save_excludebuilds.i       ; true to skip build backups when cleaning up backup files
  Global save_excludesnapshots.i    ; true to skip snapshot backups when cleaning up backup files
  Global save_length.i              ; nr of digits to use in backup counting
  Global save_wrap.i                ; start numbering again at '1' after 'n' saves / builds
  Global save_mask.s                ; string of '#' chars with lengt of save_length, used for speedup
  Global compilerun.i                     ; #true if doing a compile/run, #false if running the final exe
  Global compilerun_savefrequency.i       ; save every 'n' times
  Global compilerun_autosaveinterval.i    ; save after 'n' seconds since last compile/run or build
  ;
  ; preprocessing
  ;
  Global prep_addconstants.i        ; add constants to compilefile
  Global prep_savebackup.i          ; create backups when preprocessing
  Global prep_multiline.i           ; support multilining
  Global prep_keepsync.i            ; add blank lines to compensate for aggregated continued lines
  Global prep_thinbuilds.i          ; remove unused procedures and macros from builds
  Global prep_thindeep.i            ; remove all formatting, comments and empty lines
  ;
  ; command line usage
  ;
  Global log_maintain.i             ; use a logfile
  Global log_showonerror.i          ; show logfile on error
  Global log_showoncmd.i            ; always show logfile on command line usage
  Global error.i                    ; #true means error
  Global command.s                  ; command found on the command line
  ;
  ; reformat
  ;
  Global format_smart.i             ; detect : ' _ ; and strange combo's like _ ;
  Global format_multiline.i         ; true multiline conversion on
  Global format_multiline_indent.i  ; tab size used for continued multiline lib
  Global format_procedure.i         ; set to true to add whitespace after procedure names
  Global format_procedure_space.i   ; column up to which space will be added after the procedure name
  Global format_indent.i            ; default indent siize
  Global keywords_up.s              ; keywords to increase margin
  Global keywords_down.s            ; same downward
  Global keywords_doubleup.s        ; same double up
  Global keywords_doubledown.s      ; same double down
  ;
  ; codesync
  ;
  Global codesync_folder1.s         ; path + file to be compared with second...
  Global codesync_folder2.s         ; ... path + file
  Global codesync_baklimit.i        ; number of .bak files to copy
  Global codesync_filter.s          ; filename pattern to filter
  Global codesync_confirmation.i    ; confirm each overwrite 0 = no, 1 = yes
  ;
  ; thinner
  ;
  Global thin_filesincluded.i       ; counter for number of files included
  Global thin_lines_n.i             ; counter for number of lines included
  Global thin_linesstripped_n.i     ; counter for number of lines removed
  Global thin_commentsstripped_n.i  ; counter for number of empty or commentlines stripped
  Global thin_declaresstripped_n.i  ; counter for number of declares removed
  Global thin_procsstripped_n.i     ; counter for number of procedures stripped
  Global thin_progress.i            ; counter used for progress indicator
  ;
  Structure thin_procmap
    key.s                          ; used to store procedure name
    linenr.i                       ; line number where the procedure can be found
    inuse.i                        ; flag to indicate if the procedure of that name is actually in use
  EndStructure
  ;
  Global NewList thin_procmap.thin_procmap()
  Global NewList thin_codelist.s()
  ;
  Global regexp_include.i, regexp_brackets.i, regexp_procedure.i, regexp_end.i, regexp_endprocedure.i, regexp_declare.i, regexp_call.i
  ;
  regexp_include = CreateRegularExpression(#PB_Any,"^[ ]*(i|I|XI)nclude(file|File|path|Path|binary|Binary)")
  regexp_brackets = CreateRegularExpression(#PB_Any,"^[ ]*(i|I|XI)nclude(file|File|path|Path|binary|Binary)[(]")
  regexp_procedure = CreateRegularExpression(#PB_Any,"^[ ]*([Pp]rocedure[\. ]|[Mm]acro[ ])")
  regexp_endprocedure = CreateRegularExpression(#PB_Any,"^[ ]*([Ee]nd[Pp]rocedure\b|[Ee]nd[Mm]acro\b)")
  regexp_declare = CreateRegularExpression(#PB_Any,"^[ ]*[Dd]eclare[\. ]")
  regexp_call = CreateRegularExpression(#PB_Any,"[a-zA-Z_][0-9]*\(")
  regexp_end = CreateRegularExpression(#PB_Any,"^[ ]*[Ee]nd\b")
  ;
  ; checkline
  ;
  Global checkline_t.i
  Global checkline_p.i
  ;
  ; search
  ;
  Global search_basic.s             ; files / paths for 'basic'
  Global search_basic_n.i           ; nr of items in 'basic'
  Global search_extended.s          ; files / paths for 'extended'
  Global search_extended_n.i        ; nr of items in 'extended'
  Global files_p.i                  ; search file pointer
  Global files_n.i                  ; nr of files to search
  Global filter_type.i              ; see #f_filter_xxxx
  Global search_wildcards.i         ; #true to allow wildcards in search
  Global search_widen.i             ; #true to make search string more 'readable' ie. add *'s and remove some spaces
  Global search_narrow.i            ; #true to filter out results matching specific characters
  Global search_beginwith.i         ; #true will only allow search match if the found phrase starts with the search string
  Global search_included.i          ; #true to process included files in source code
  Global search_string.s            ; string to search for
  ;
  ; web
  ;
  Global web_browser.s              ; browser to launch
  Global web_empty_n.i        ; nr of items in 'empty'
  Global web_empty.s          ; sites to search on an empty keyword
  Global web_underscore_n.i   ; nr of items in 'underscore'
  Global web_underscore.s     ; sites to search on a keyword with underscore
  Global web_other_n.i        ; nr of items in 'other'
  Global web_other.s          ; sites to search on other keywords
  ;
  search_wildcards = #False
  search_widen = #True
  search_narrow = #True
  filter_type = #f_filter_categorized
  ;
  ; progress window
  ;
  Global progress_abort.i           ; flag to abort session
  ;
  ; *** other stuff
  ;
  ;
  ; custom drawing (gadgetitem coloring)
  ;
  #CDDS_PREPAINT = 1
  #CDRF_NOTIFYITEMDRAW = 32
  #CDDS_ITEM = 65536
  #CDRF_NEWFONT = 2
  ;
  ; searching, duplicate filtering and pattern matching
  ;
  Global NewList files.s()
  ;
  files_n = 0
  files_p = 0
  ;
  ; data for listpanel, codepanel, and found lists
  ;
  Structure entry
    foreground.i                     ; colors in listicongadget
    background.i                     ; (applied via callback)
    style.i                          ; bold or not
    ; string.s                       ; associated text - removed in v.078x
    file.s                           ; associated file
    line.i                           ; line where the entry was found
    seek_pos.i                       ; seek position in file
    seek_line.i                      ; associated line
    type.i                           ; type using #f_filter_xxxx constants
  EndStructure
  ;
  Structure hit
    string.s                         ; associated text
    file.s                           ; associated file (not for code.entry())
    line.i                           ; line where the entry was found
    seek_pos.i                       ; seek position in file
    seek_line.i                      ; line number of seek position in file
    type.i                           ; type using #f_filter_xxxx constants
  EndStructure
  ;
  ;
  #list_max = 10000                  ; max size of each array used for displaying results, defines max. number of hits
  ;
  ; this array contains the selected set of references (ie. categorized, procedures, variables, etc.)
  ; it is shown in the top half of the window
  ;
  Global Dim List.entry(#list_max+10)  ; I dim a few extra, there's some messy code that ignores #list_max when adding extra information
  Global list_n.i
  list_n = 0
  ;
  ; this array shows the code sample (ie. a section of the file that contained the hit)
  ; it is shown in the bottom half of the window
  ;
  Global Dim code.entry(#list_max)
  Global code_n.i
  code_n = 0
  ;
  ; the following array contains the matches that have been found
  ;
  Global Dim hit.hit(#list_max)
  ;
  ; counters per category to keep track of the number of hits
  ;
  Global hit_n.i
  Global hit_procedure_n.i
  Global hit_structure_n.i
  Global hit_constant_n.i
  Global hit_variable_n.i
  Global old_n.i
  Global old_procedure_n.i
  Global old_structure_n.i
  Global old_constant_n.i
  Global old_variable_n.i
  Global old_files_p.i
  Global old_filter_type.i
  Global old_search_firstnr.i
  Global old_search_extra.i
  ;
  ; status
  ;
  Global search_status.i                   ; currently searching or not?
  Global old_search_status.i               ; used to guarantee list updates at the end of a search
  ;
  #status_ready = 0                        ; light green led, waitwindowevent()
  #status_searching = 1                    ; dark green led, windowevent()
  #status_paused = 2                       ; yellow led, waiting
  #status_error = 3                        ; blue led, reached limit
  ;
  ; array to keep a number of lines in memory before and after hit
  ;
  #seek_buffer = 10                        ; n lines before, 2x n lines after
  ;
  Global Dim seek_buffer_pos.i(#seek_buffer)      ; store seek pos
  Global Dim seek_buffer_line.i(#seek_buffer)     ; store associated line number
  ;
  Global list_selected.i                   ; selected entry in list panel
  Global hit_file.s                        ; file found
  Global hit_line.i                        ; line where the search phrase was found
  Global hit_type.i                        ; type of hit (filter)
  Global seek_pos.i                        ; seek pos in file
  Global seek_line.i                       ; line associated with seek pos
  Global list_n_old.i                      ; old size of list, used in remember_selected to check for increase / decrease
  ;
  ; for showing off in the about screen (not used)
  ;
  #interval = 1000/50                      ; 50 hz
  #wrapalert = 2147483647-3*#interval
  ;
  ; instance related stuff
  ;
  Global mutex_name.s                          ; mutex name
  Global mutex_h.i                             ; mutex handle for single instance detection
  Global first_instance.i                      ; identifies if this is the first instance of codecaddy
  Global wakeup_message.s                      ; wakeup message for codecaddy
  Global mailslot_log.s                        ; mailslot for codecaddy log messages
  Global mailslot_command.s                    ; mailslot for codecaddy commands (parameter passing)
  Global wakeup_message_nr.i
  Global mailslot_log_h.i
  Global mailslot_command_h.i
  ;
  mutex_name = "codecaddy_instance"
  wakeup_message = "codecaddy_wakeup"
  mutex_h.i = 0
  mailslot_log.s = "\\.\mailslot\codecaddy_log"
  mailslot_command.s = "\\.\mailslot\codecaddy_command"
  ;
  ; *** other constants
  ;
  #CSIDL_APPDATA = $001a
  ;
EndProcedure

Procedure colorset(mode.i)                                 ; set colors (light or dark colours)
  ;
  col_white =            $00FFFFFF
  col_black =            $00000000
  ;
  Select mode
      Case 0
        col_pink =           $00FFF0FF
        col_blue =           $00FFF0F0
        col_orange =         $00F0F0FF
        col_yellow =         $00D0FFFF
        col_green =          $00F0FFF0
        col_grey =           $00F4F4F4
      Case 1
        col_pink =           $00FFC0FF
        col_blue =           $00FFC0C0
        col_orange =         $00D0C0FF
        col_yellow =         $0090FFFF
        col_green =          $00C0FFC0
        col_grey =           $00C0C0C0
  EndSelect
EndProcedure

Procedure read_caddyfile()                                 ; read counters per source file (.cdy)
  Protected v.i, p.i, n.i, name.s, path.s
  ;
  ; *** read caddyfile (.cdy file saved for each pb source processed)
  ;
  path = GetPathPart(caddyfile)
  name = GetFilePart(caddyfile)
  If save_cdytobackup = #True
    path = path+"_backup\"
    If FileSize(path) = -2
    Else
      CreateDirectory(path)
    EndIf
  EndIf
  ;
  If x_exist(path+name)
    OpenPreferences(path+name)
    save_nr = ReadPreferenceInteger("save_nr",0)
    build_nr = ReadPreferenceInteger("build_nr",0)
    timestamp = ReadPreferenceInteger("timestamp",0)
    ClosePreferences()
  Else
    ;
    ; file did not exist, retrieve save and build nrs from existing files
    ;
    ; standard file name: abcd.pb
    ; backup file name:   abcd.pb.12345.bak
    ; build filename:     abcd.pb.12345.build123.bak
    ; snapshot filename:  abcd.pb.12345.snapshot123.bak
    ;
    If save_baktobackup = #True
      path = path+"_backup\"
    EndIf
    x_dir_simple(path,x_chop(name,0,4)+".*.bak",-1)
    n = 0
    While n < x_dir_n
      SelectElement(x_dir_file(),n)
      v = Val(Mid(x_dir_file()\name,Len(name)+2-4,10))
      save_nr = x_max(save_nr,v)
      p = FindString(x_dir_file()\name,"build",Len(name))
      If p <> 0
        v = Val(Mid(x_dir_file()\name,p+5,10))
        build_nr = x_max(build_nr,v)
      EndIf
      n = n+1
    Wend
  EndIf
EndProcedure

Procedure write_caddyfile()                                ; store counters per source file (.cdy)
  Protected path.s, name.s
  ;
  ; *** write caddyfile (.cdy file written for each processed pb file)
  ;
  path = GetPathPart(caddyfile)
  name = GetFilePart(caddyfile)
  If save_cdytobackup = #True
    path = path+"_backup\"
    If FileSize(path) = -2
    Else
      CreateDirectory(path)
    EndIf
  EndIf
  ;
  CreatePreferences(path+name)
  PreferenceComment(" codecaddy "+#codecaddy_version+" counters")
  PreferenceComment(" for "+file.s)
  PreferenceComment("")
  WritePreferenceInteger("save_nr",save_nr)
  WritePreferenceInteger("build_nr",build_nr)
  WritePreferenceInteger("timestamp",timestamp)
  ClosePreferences()
EndProcedure

Procedure write_config()                                   ; store code caddy preferences
  Protected n.i
  ;
  ; write default configuration
  ;
  CreatePreferences(configfile)
  ;
  PreferenceComment(" codecaddy "+#codecaddy_version+" preferences")
  PreferenceComment("")
  ;
  PreferenceGroup("prep")
  WritePreferenceInteger("prep_savebackup",prep_savebackup)
  WritePreferenceInteger("prep_addconstants",prep_addconstants)
  WritePreferenceInteger("prep_multiline",prep_multiline)
  WritePreferenceInteger("prep_keepsync",prep_keepsync)
  WritePreferenceInteger("prep_thinbuilds",prep_thinbuilds)
  WritePreferenceInteger("prep_thindeep",prep_thindeep)
  WritePreferenceInteger("log_maintain",log_maintain)
  WritePreferenceInteger("log_showoncmd",log_showoncmd)
  WritePreferenceInteger("log_showonerror",log_showonerror)
  PreferenceComment("")
  ;
  PreferenceGroup("backup")
  WritePreferenceInteger("save_max",save_max)
  WritePreferenceInteger("save_excludebuilds",save_excludebuilds)
  WritePreferenceInteger("save_excludesnapshots",save_excludesnapshots)
  WritePreferenceInteger("save_length",save_length)
  WritePreferenceInteger("save_baktobackup",save_baktobackup)
  WritePreferenceInteger("save_cdytobackup",save_cdytobackup)
  WritePreferenceInteger("compilerun_savefrequency",compilerun_savefrequency)
  WritePreferenceInteger("compilerun_autosaveinterval",compilerun_autosaveinterval)
  PreferenceComment("")
  ;
  PreferenceGroup("format")
  WritePreferenceInteger("format_smart",format_smart)
  WritePreferenceInteger("format_multiline",format_multiline)
  WritePreferenceInteger("format_multiline_indent",format_multiline_indent)
  WritePreferenceInteger("format_procedure",format_procedure)
  WritePreferenceInteger("format_procedure_space",format_procedure_space)
  WritePreferenceInteger("format_indent",format_indent)
  WritePreferenceString("keywords_up",keywords_up)
  WritePreferenceString("keywords_down",keywords_down)
  WritePreferenceString("keywords_doubleup",keywords_doubleup)
  WritePreferenceString("keywords_doubledown",keywords_doubledown)
  PreferenceComment("")
  ;
  PreferenceGroup("codesync")
  WritePreferenceString("codesync_folder1",codesync_folder1)
  WritePreferenceString("codesync_folder2",codesync_folder2)
  WritePreferenceInteger("codesync_baklimit",codesync_baklimit)
  WritePreferenceString("codesync_filter",codesync_filter)
  WritePreferenceInteger("codesync_confirmation",codesync_confirmation)
  PreferenceComment("")
  ;
  PreferenceGroup("search")
  WritePreferenceInteger("search_wildcards",search_wildcards)
  WritePreferenceInteger("search_widen",search_widen)
  WritePreferenceInteger("search_narrow",search_narrow)
  WritePreferenceInteger("search_included",search_included)
  WritePreferenceInteger("search_beginwith",search_beginwith)
  search_basic_n = x_writepreferencestringex("search_basic",search_basic)
  search_extended_n = x_writepreferencestringex("search_extended",search_extended)
  ;
  PreferenceGroup("web")
  WritePreferenceString("web_browser",web_browser)
  web_empty_n = x_writepreferencestringex("web_empty",web_empty)
  web_underscore_n = x_writepreferencestringex("web_underscore",web_underscore)
  web_other_n = x_writepreferencestringex("web_other",web_other)
  PreferenceComment("")
  ;
  PreferenceGroup("gui")
  WritePreferenceInteger("window_x",w_main_x)
  WritePreferenceInteger("window_y",w_main_y)
  WritePreferenceInteger("window_width",w_main_width)
  WritePreferenceInteger("window_height",w_main_height)
  WritePreferenceInteger("window_maximized",w_main_maximized)
  WritePreferenceInteger("spacing_frame",spacing_frame)
  WritePreferenceInteger("spacing_buttons",spacing_buttons)
  WritePreferenceInteger("splitter_pos",splitter_permileage)
  WritePreferenceInteger("splitter_max",splitter_max)
  WritePreferenceInteger("splitter_swap",splitter_swap)
  WritePreferenceInteger("show_menu",show_menu)
  WritePreferenceInteger("show_statusbar",show_statusbar)
  WritePreferenceInteger("show_toolbar",show_toolbar)
  WritePreferenceInteger("show_buttons",show_buttons)
  WritePreferenceInteger("show_keepontop",show_keepontop)
  WritePreferenceInteger("show_darkercolors",show_darkercolors)
  WritePreferenceInteger("show_nearbydialogs",show_nearbydialogs)
  WritePreferenceInteger("show_unzoom",show_unzoom)
  WritePreferenceInteger("config_saveonexit",config_saveonexit)
  WritePreferenceString("font_name",font_name)
  WritePreferenceInteger("font_size",font_size)
  WritePreferenceInteger("search_info",search_extra)
  WritePreferenceInteger("search_firstnr",search_firstnr)
  PreferenceComment("")
  ;
  ClosePreferences()
EndProcedure

Procedure read_config()                                    ; read or default code caddy preferences
  Protected n.i
  ;
  ; *** read configuration
  ;
  ; actual path read from depends on running as an executable or running as a testrun
  ; which is why configfile is defined in init() depending on #codecaddy_compilerun
  ;
  OpenPreferences(configfile)
  ;
  PreferenceGroup("prep")
  prep_savebackup = ReadPreferenceInteger("prep_savebackup",#True)
  prep_addconstants = ReadPreferenceInteger("prep_addconstants",#True)
  prep_multiline = ReadPreferenceInteger("prep_multiline",#True)
  prep_keepsync = ReadPreferenceInteger("prep_keepsync",#True)
  prep_thinbuilds = ReadPreferenceInteger("prep_thinbuilds",#True)
  prep_thindeep = ReadPreferenceInteger("prep_thindeep",#True)
  log_maintain = ReadPreferenceInteger("log_maintain",#True)
  log_showoncmd = ReadPreferenceInteger("log_showoncmd",#False)
  log_showonerror = ReadPreferenceInteger("log_showonerror",#True)
  ;
  PreferenceGroup("backup")
  save_max = ReadPreferenceInteger("save_max",50)
  save_excludebuilds = ReadPreferenceInteger("save_excludebuilds",#True)
  save_excludesnapshots = ReadPreferenceInteger("save_excludesnapshots",#True)
  save_length = ReadPreferenceInteger("save_length",5)
  save_baktobackup = ReadPreferenceInteger("save_baktobackup",#True)
  save_cdytobackup = ReadPreferenceInteger("save_cdytobackup",#False)
  compilerun_savefrequency = ReadPreferenceInteger("compilerun_savefrequency",5)
  compilerun_autosaveinterval = ReadPreferenceInteger("compilerun_autosaveinterval",300)
  ;
  PreferenceGroup("format")
  format_smart = ReadPreferenceInteger("format_smart",#True)
  format_multiline = ReadPreferenceInteger("format_multiline",#True)
  format_multiline_indent = ReadPreferenceInteger("format_multiline_indent",2)
  format_procedure = ReadPreferenceInteger("format_procedure",#True)
  format_procedure_space = ReadPreferenceInteger("format_procedure_space",0)
  format_indent = ReadPreferenceInteger("format_indent",2)
  keywords_up = ReadPreferenceString("keywords_up", _
    "If|ElseIf|Else|While|Repeat|Case|For|ForEach|With|CompilerIf|" + _
    "CompilerElse|CompilerElseIf|Structure|Procedure|Procedure.?|" + _
    "Enumeration|DataSection|StructureUnion|Default|PanelGadget(*|" + _
    "Select|StartDrawing(*|Macro|Case|Default")
  keywords_down = ReadPreferenceString("keywords_down", _
    "ElseIf|Else|EndIf|Wend|Until|Case|Next|EndWith|CompilerElseIf|" + _
    "CompilerElse|CompilerEndIf|EndStructure|EndProcedure|EndEnumeration|" + _
    "EndDataSection|EndStructureUnion|Default|CloseGadgetList(*|EndSelect|" + _
    "StopDrawing(*|ForEver|EndMacro|Case|Default")
  keywords_doubleup = ReadPreferenceString("keywords_doubleup","Select")
  keywords_doubledown = ReadPreferenceString("keywords_doubledown","EndSelect")
  ;
  PreferenceGroup("codesync")
  codesync_folder1 = ReadPreferenceString("codesync_folder1",GetCurrentDirectory())
  codesync_folder2 = ReadPreferenceString("codesync_folder2",GetCurrentDirectory())
  codesync_baklimit = ReadPreferenceInteger("codesync_baklimit",5)
  codesync_filter = ReadPreferenceString("codesync_filter","test*.pb|*.$$$|*.tmp|*.log|thumbnails.db| bbthumbs.dat")
  codesync_confirmation = ReadPreferenceInteger("codesync_confirmation",1)
  ;
  PreferenceGroup("search")
  search_wildcards = ReadPreferenceInteger("search_wildcards",0)
  search_widen = ReadPreferenceInteger("search_widen",1)
  search_narrow = ReadPreferenceInteger("search_narrow",1)
  search_included = ReadPreferenceInteger("search_included",0)
  search_beginwith = ReadPreferenceInteger("search_beginwith",0)
  search_basic = x_readpreferencestringex("search_basic","C:\software\purebasic\_projects\x_lib\x_lib.pb|C:\software\purebasic\_projects\x_lib\x_lib_test.pb")
  search_basic_n = x_retval
  search_extended = x_readpreferencestringex("search_extended", "C:\software\purebasic\*.pb ++|C:\software\purebasic\*.pbi ++|C:\software\purebasic\*.txt ++")
  search_extended_n = x_retval
  ;
  PreferenceGroup("web")
  web_browser = ReadPreferenceString("web_browser","firefox.exe")
  web_empty = x_readpreferencestringex("web_empty","http://forums.purebasic.com/english")
  web_empty_n = x_retval
  web_underscore = x_readpreferencestringex("web_underscore", _
    "http://google.com/search?q=%keyword%|" + _
    "http://www.google.nl/codesearch?q=%keyword%&hl=en&btnG=Search+Code|" + _
    "http://google.com/search?q=site:purearea.net+%keyword%_|" + _
    "http://google.com/search?q=site:forums.purebasic.com/english+%keyword%_|" + _
    "http://google.com/search?q=site:msdn.microsoft.com/en-us/library+%keyword%" )
  web_underscore_n = x_retval
  web_other = x_readpreferencestringex("web_other", _
    "http://google.com/search?q=%keyword%|" + _
    "http://google.com/search?q=site:purearea.net+%keyword%|" + _
    "http://google.com/search?q=site:forums.purebasic.com/english+%keyword%|" + _
    "http://google.com/search?q=site:www.purebasic.com/documentation+%keyword%" )
  web_other_n = x_retval
  ;
  PreferenceGroup("gui")
  w_main_x = ReadPreferenceInteger("window_x",10)
  w_main_y = ReadPreferenceInteger("window_y",10)
  w_main_width = ReadPreferenceInteger("window_width",412)
  w_main_height = ReadPreferenceInteger("window_height",400)
  w_main_maximized = ReadPreferenceInteger("window_maximized",#False)
  spacing_frame = ReadPreferenceInteger("spacing_frame",2)
  spacing_buttons = ReadPreferenceInteger("spacing_buttons",6)
  splitter_permileage = ReadPreferenceInteger("splitter_pos",500)
  splitter_max = ReadPreferenceInteger("splitter_max",#False)
  splitter_swap = ReadPreferenceInteger("splitter_swap",#False)
  show_menu = ReadPreferenceInteger("show_menu",#True)
  show_statusbar = ReadPreferenceInteger("show_statusbar",#True)
  show_toolbar = ReadPreferenceInteger("show_toolbar",#True)
  show_buttons = ReadPreferenceInteger("show_buttons",#False)
  show_keepontop = ReadPreferenceInteger("show_keepontop",#True)
  show_darkercolors = ReadPreferenceInteger("show_darkercolors",#False)
  show_nearbydialogs = ReadPreferenceInteger("show_nearbydialogs",#True)
  show_unzoom = ReadPreferenceInteger("show_unzoom",#True)
  config_saveonexit = ReadPreferenceInteger("config_saveonexit",#True)
  font_name = ReadPreferenceString("font_name","courier new")
  font_size = ReadPreferenceInteger("font_size",10)
  search_extra = ReadPreferenceInteger("search_info",#True)
  search_firstnr = ReadPreferenceInteger("search_firstnr",3)
  ;
  ClosePreferences()
  ;
  save_wrap = Pow(10,save_length)
  save_mask = x_string(save_length,"#")
  ;
  If x_not(x_exist(configfile))
    write_config()
  EndIf
EndProcedure

Procedure nearby_dialog()                                  ; keep dialog nearby :-)
  If show_nearbydialogs And w_main_h > 0
    x_setrequesterposition(WindowX(#w_main_nr)+80,WindowY(#w_main_nr)+80,#w_main_nr)
    w_main_maximized = IsZoomed_(w_main_h)
    If w_main_maximized = #False
      w_main_x = WindowX(#w_main_nr)
      w_main_y = WindowY(#w_main_nr)
    EndIf
  EndIf
EndProcedure

Procedure backup_source()                                  ; make copy of source
  Protected n.i, path.s, name.s, exclude.i
  ;
  ; *** create a copy of the source
  ;
  ; global variables file.s and backupfile.s contain filenames
  ; backup_file.s is set in this routine
  ;
  x_log("save_nr: "+Str(save_nr))
  ;
  ; step 1: check and if necessary create the folder
  ;
  path = GetPathPart(file)
  name = GetFilePart(file)
  If save_baktobackup = #True
    path = path+"_backup\"
    If FileSize(path) = -2
    Else
      CreateDirectory(path)
    EndIf
  EndIf
  ;
  ; step 2: build file list, exclude builds and snapshots, trim number of files
  ;
  x_dir_simple(path,name+".*.bak",-1)
  n = 0
  While n < x_dir_n And x_dir_n > 0
    SelectElement(x_dir_file(),n)
    If ( save_excludesnapshots And x_matchpattern(x_dir_file()\name,"*.pb.*.snapshot*.bak",#x_parse_anycase) ) Or _
        ( save_excludebuilds And x_matchpattern(x_dir_file()\name,"*.pb.*.build*.bak",#x_parse_anycase) )
      DeleteElement(x_dir_file(),n)
      x_dir_n = x_dir_n-1
      n = n-1
    EndIf
    n = n+1
  Wend
  ;
  If x_dir_n > 0
    n = 0
    While (x_dir_n-n) > (save_max)
      SelectElement(x_dir_file(),n)
      DeleteFile(path+x_dir_file()\name)
      n = n+1
    Wend
  EndIf
  ;
  ; step 3: handle wraps
  ;
  If save_nr = 0                                     ; only possible after a wrap, a rare event indeed
    x_dir_simple(path,name+".*.bak",-1)
    n = 0
    While n < x_dir_n
      SelectElement(x_dir_file(),n)
      If ( save_excludesnapshots And x_matchpattern(x_dir_file()\name,"*.pb.*.snapshot*.bak",#x_parse_anycase) ) Or _
          ( save_excludebuilds And x_matchpattern(x_dir_file()\name,"*.pb.*.build*.bak",#x_parse_anycase) )
      Else
        RenameFile(path+x_dir_file()\name,path+name+"."+x_strex(save_nr,save_mask)+".wrap.bak")
        save_nr = save_nr+1
      EndIf
      n = n+1
    Wend
    write_caddyfile()
  EndIf
  ;
  ; step 4: create new backup for build or regular save
  ;
  If command = "build"
    backupfile = file+"."+x_strex(save_nr,save_mask)+".build"+Str(build_nr)+".bak"
  ElseIf command = "snapshot"
    backupfile = file+"."+x_strex(save_nr,save_mask)+".snapshot.bak"
  Else
    backupfile = file+"."+x_strex(save_nr,save_mask)+".bak"
  EndIf
  CopyFile(file,path+GetFilePart(backupfile))
  ;
EndProcedure

Procedure.i checkline(x.s)                                 ; check pb source line for _ ; :
  Protected l.i, t.i, p.i, x_p.i, m.i, c.i
  ;
  ; *** checks a pb source line to see if it's a valid multiline or multicommand
  ;
  ; multiline: a pb sourcecode line that ends on a [space][underscore][space] condition
  ; multicommand: a pb sourcecode line that contains multiple commands separated by colon(s)
  ;
  ; in:       x.s                    - string to check
  ; retval:   0..1                   - 0 = single statement 1 = multi statement (colon)
  ; out:      checkline_p.i          - pointer to last char before continuation character
  ;           checkline_t.i = 1      - no line continuation char
  ;                           2      - line continuation at eol
  ;                           3      - line continuation before comment
  ;
  x_p = @x
  l = StringByteLength(x)                  ; length of string
  t = 0                                    ; test flag, 1 is normal line, 2 is multiline
  p = 0                                    ; counter / pointer
  m = 0                                    ; flag to indicate existence of colon
  ;
  If l < 3 Or ( FindString(Trim(x.s)," _",1) = 0 And FindString(x.s,":",1) = 0 )
    t = 1                                  ; speedup as findstring is faster than my code
  Else
    c = PeekC(x_p+p)
    Repeat
      If c = 34                            ; double quote char
        Repeat                             ; repeat until another one is hit
          p = p+#x_charsize
          c = PeekC(x_p+p)
        Until c = 34 Or p = l-#x_charsize
        p = p+#x_charsize
        If p = l
          t = 1
        Else
          c = PeekC(x_p+p)
        EndIf
      ElseIf c = 39                        ; single quote char
        Repeat                             ; repeat until another one is hit
          p = p+#x_charsize
          c = PeekC(x_p+p)
        Until c = 39 Or p = l-#x_charsize
        If p = l
          t = 1
        Else
          p = p+#x_charsize
          c = PeekC(x_p+p)
        EndIf
      ElseIf c = ' '                       ; ah a space
        Repeat
          p = p+#x_charsize
          c = PeekC(x_p+p)
        Until c <> ' ' Or p = l-#x_charsize  ; keep on going until it's no longer a space
        If c ='_'
          If p = l-#x_charsize
            t = 2                          ; we're on an eol with a [space][underscore]
            p = p-#x_charsize              ; adjust pointer to spot before [underscore]
          Else
            p = p+#x_charsize
            c = PeekC(x_p+p)
            If c = ' '
              t = 3                        ; we just passed a [space][underscore][space]
              p = p-2*#x_charsize          ; adjust pointer to spot before [underscore]
            EndIf
          EndIf
        EndIf
      ElseIf c = ';'                       ; comment encountered before multiline character
        t = 1
      ElseIf c = ':'                                              ; don't support multiline on multistatement lines
        If p < l-#x_charsize And PeekC(x_p+p+#x_charsize)=':'     ; fix in 2.10x: skip module colons
        ElseIf p > #x_charsize And PeekC(x_p+p-#x_charsize)=':'
        Else
          m = 1
        EndIf
          t = 1
      ElseIf p < l-#x_charsize
        p = p+#x_charsize
        c = PeekC(x_p+p)
      Else
        t = 1
      EndIf
    Until t <> 0
  EndIf
  ;
  checkline_t = t
  checkline_p = p/2
  ProcedureReturn m
EndProcedure

Procedure format()                                         ; create a backup then reformat and reload source
  Protected margin.i, x.s, y.s, m.i
  ;
  ; *** create a backup then reformat and reload source
  ;
  ; file.s contains the filename, backupfile.s the name of the saved copy
  ; backupfile.s is set in backup_source(), however it does not contain the optional _backup component
  ;
  x_log("format "+Chr(34)+file+Chr(34))
  ;
  If x_not(x_exist(file))
    x_log("*** error: file not found")
    error = #True
  Else
    caddyfile = file+".cdy"
    read_caddyfile()
    save_nr = (save_nr+1) % save_wrap
    timestamp = Date()
    write_caddyfile()
    command = ""
    backup_source()
    ;
    ; file exists, and a backup has been made, now format it using the backup as the source
    ; two variants, either supporting multi statement or not
    ; without multi statement it's a bit faster
    ;
    ; backupfile.s is set in backup_source(), however it does not contain the optional _backup component
    ;
    If save_baktobackup
      OpenFile(1,GetPathPart(backupfile)+"_backup\"+GetFilePart(backupfile))
    Else
      OpenFile(1,backupfile)
    EndIf
    CreateFile(2,file)
    ;
    unicodemode = ReadStringFormat(1)
    WriteStringFormat(2,unicodemode)
    ;
    margin = 0
    ;
    If format_smart = #False
      ;
      ; no check on multistatement lines or continuation characters
      ;
      While x_not(Eof(1))
        x.s = ReadString(1,unicodemode)
        x.s = Trim(ReplaceString(x.s,Chr(9),"     "))
        y.s = StringField(x,1," ")
        If y.s = ""
          WriteString(2,Space(margin)+x+Chr(13)+Chr(10),unicodemode)
        Else
          If format_procedure And Left(x,9)="Procedure"
            If Len(x) < format_procedure_space
              x = LSet(x,format_procedure_space)
            EndIf
          Else
            If x_matchpattern(y,keywords_down,#x_parse_anycase) = #True
              margin = x_max(0,margin-format_indent)
            EndIf
            If x_matchpattern(y,keywords_doubledown,#x_parse_anycase) = #True
              margin = x_max(0,margin-format_indent*2)
            EndIf
          EndIf
          WriteString(2,Space(margin)+x+Chr(13)+Chr(10),unicodemode)
          If x_matchpattern(y,keywords_up,#x_parse_anycase) = #True
            margin = margin+format_indent
          EndIf
          If x_matchpattern(y,keywords_doubleup,#x_parse_anycase) = #True
            margin = margin+2*format_indent
          EndIf
        EndIf
      Wend
    Else
      ;
      ; detect multistatement and line continuation
      ;
      m = #False                                        ; flag to indicate the previous line ended on multiline character
      While x_not(Eof(1))
        ;
        x.s = ReadString(1,unicodemode)
        x.s = Trim(ReplaceString(x.s,Chr(9),"     "))
        If checkline(x) = 1                           ; there's a colon, so it's multistatement and we do not support that, sorry
          WriteString(2,Space(margin)+Trim(x)+Chr(13)+Chr(10),unicodemode)
          m = #False
        ElseIf m = #True And format_multiline = #False  ; second of multiline but formatting multilines has been switched off
          WriteString(2,x+Chr(13)+Chr(10),unicodemode)
          If checkline_t > 1
            m = #True
          Else
            m = #False
          EndIf
        ElseIf m = #True                                  ; a continued line, don't parse, just indent
          WriteString(2,Space(margin+m*format_multiline_indent)+Trim(x)+Chr(13)+Chr(10),unicodemode)
          If checkline_t > 1
            m = #True
          Else
            m = #False
          EndIf
        Else                                              ; not a continued line, so parse
          y.s = StringField(Trim(x),1," ")
          If y.s = ""
            WriteString(2,Space(margin)+Trim(x)+Chr(13)+Chr(10),unicodemode)
          Else
            If x_matchpattern(y,keywords_down,#x_parse_anycase) = #True
              margin = x_max(0,margin-format_indent)
            EndIf
            If x_matchpattern(y,keywords_doubledown,#x_parse_anycase) = #True
              margin = x_max(0,margin-format_indent*2)
            EndIf
            If format_procedure And Left(x,9) = "Procedure"
              If Len(x) < format_procedure_space
                x = LSet(x,format_procedure_space)
              EndIf
            EndIf
            WriteString(2,Space(margin)+x+Chr(13)+Chr(10),unicodemode)
            If x_matchpattern(y,keywords_up,#x_parse_anycase) = #True
              margin = margin+format_indent
            EndIf
            If x_matchpattern(y,keywords_doubleup,#x_parse_anycase) = #True
              margin = margin+format_indent*2
            EndIf
            If checkline_t > 1
              m = #True
            EndIf
          EndIf
          ;
        EndIf
      Wend
    EndIf
    CloseFile(2)
    CloseFile(1)
    If margin <> 0
      x_log("*** warning: format unsuccessfull")
    EndIf
  EndIf
  ;
EndProcedure

Procedure.s strip_comment(x.s)                             ; strips comment from line of source, if possible
  Protected c.i, p.i, l.i, doublequote.i, quote.i, semicolon.i
  ;
  ; this procedure removes a comment section, if existing
  ; a comment section starts at the first semicolon that is not enclosed between doublequote or quotes
  ;
  ; used by flatten()
  ;
  doublequote = 0
  quote = 0
  semicolon = #False
  ;
  l = Len(x)
  ;
  p = 0
  While p < l And semicolon = #False
    p = p+1
    c = Asc(Mid(x,p,1))
    If c = 34
      doublequote = #True - doublequote
    ElseIf c = 39
      quote = #True - quote
    ElseIf c = 59 And quote = #False And doublequote = #False
      semicolon = #True
    EndIf
  Wend
  ;
  If semicolon = #True
    ProcedureReturn RTrim(Left(x,p-1))
  Else
    ProcedureReturn RTrim(x)
  EndIf
  ;
EndProcedure

Procedure flatten()                                        ; join continued lines in file 1 and export results to file 2
  Protected a.s, b.s, aa.s, bb.s, n.i, p.i, nomore.i
  ;
  ; *** takes (open) source and (open) destination file, then flattens source to destination
  ;
  ; notes  - file #1 is input, file #2 is output
  ;        - files have to be open and will not be closed by this procedure
  ;
  ; I. each line passed on to the flatten function can be broken down into:
  ;
  ;      [source] [ ; <comments> ]
  ;      [source] [ _ ] [ ; <comments> ]
  ;      [ _ ] [source] [ ; <comments> ]
  ;
  ;    any line ending on, or starting with an underscore is considered part of a multiline construction
  ;
  ; II. the preprocessor ignores all source between pairs of doublequote or quotes uncluding comments, underscores, etc.
  ;
  ;      [source] " <whatever> " [source]
  ;      [source] ' <whatever> ' [source]
  ;
  ; III. there are no comments allowed after any remaining doublequote, ie. valid constructions are
  ;
  ;      ... " <text> "   ; <comment>
  ;      ... " <text> " _ ; <comment>
  ;      ... " <text> " _
  ;
  ;    an example of an invalid line:
  ;
  ;      ... " <text> _ ; <comment>
  ;
  ;    however, the following is a special condition (see below) which is valid:
  ;
  ;      ... " <text> _
  ;
  ; IV. a special condition is an odd number of doublequote with the line ending on an underscore, in this case
  ;    it is considered a valid multiline construction but no comments are allowed after the undercore
  ;
  ;    this multiline construction is only allowed for text spread over multiple lines; the lines will be trimmed
  ;    and added together with a single space in between them, ie.:
  ;
  ;      ... "<text> _
  ;      <text>" ...
  ;
  ;    will be turned into
  ;
  ;      ... "<text> <text>" ...
  ;
  ;
  ; well, thus far theory, now it's time to do the real thing!
  ; let's start by writing it in pseudosource
  ;
  ; 1.  n = n+1
  ; 2.  line a = line n
  ; 3.  p = 0
  ; 4.  line b = line n+p+1
  ; 5.  strip comments from line a, trim end line a
  ; 6.  if line a ends on continuation char
  ; 7.    p = p+1
  ; 8.    strip continuation char
  ; 9.    replace with a single space
  ; 10.   trim line b
  ; 11.   add line b to line a
  ; 12 .  go back to step 4
  ; 13. elseif line b starts with continuation char
  ; 14.   p = p+1
  ; 15.   strip continuation char
  ; 16.   trim line b
  ; 17.   add line b to line a
  ; 18.   go back to step 4
  ; 19. else
  ; 20.   we now have a complete line to write
  ; 21.   write line a
  ; 22.   write 'p' empty lines
  ; 23.   n = n+p-1
  ;
  ; when called, file #1 should be just opened and the pointer should point to the beginning
  ; first read the bom to see if it's an UTF8 file or not
  ;
  unicodemode = ReadStringFormat(1)
  WriteStringFormat(2,unicodemode)
  ;
  n = 0
  a = ReadString(1,unicodemode)
  While Eof(1) = #False
    n = n+1
    p = 0
    nomore = #False
    While nomore = #False
      aa = a
      a = strip_comment(a)
      bb = ReadString(1,unicodemode)
      b = Trim(bb)
      If Right(a,2) = " _"                                  ; v2.01x
        p = p+1
        a = RTrim(Left(a,Len(a)-1))+" "+b
      ElseIf Left(b,2)="_ "
        p = p+1
        a = a+" "+Trim(Mid(b,2,Len(b)))
      Else
        WriteString(2,aa+#CRLF$,unicodemode)
        While p > 0
          p = p-1
          WriteString(2,#CRLF$,unicodemode)
        Wend
        a = bb
        nomore = #True
      EndIf
    Wend
  Wend
  ;
  ; turns out the real code is smaller than it's pseudo code counterpart :-)
  ;
EndProcedure

Procedure merge_files(source.s)                            ; read and merge specified source and all related includes
  Protected n.i, x.s, file_nr.i, f.s
  ;
  ; this procedure removes all unused code from a source file and its include files
  ; and creates a hash table of all procedure names (steps 1 and 2 in codestripper)
  ;
  ; for optimal results, smallest source, and to avoid false positives i'll strip comments, spaces etc.
  ; for debugging purposes it's possible to leave all this inside the generated file by clearing prep_thindeep
  ;
  If prep_thindeep = #False And ListSize(thin_codelist()) > 0
    AddElement(thin_codelist())
    thin_codelist() = "; include "+#DQUOTE$+source+#DQUOTE$
    AddElement(thin_codelist())
    thin_codelist() = ";"
  EndIf
  ;
  If x_exist(file)
    file_nr = ReadFile(#PB_Any,source)
    thin_filesincluded = thin_filesincluded+1
    unicodemode = ReadStringFormat(file_nr)
    n = 0
    While Not Eof(file_nr)
      x = ReadString(file_nr)
      thin_lines_n = thin_lines_n+1
      ;
      ; includefile has two different syntaxes:
      ;
      ;   includefile(<filename>)
      ;   includefile <filename>
      ;
      If MatchRegularExpression(regexp_include,x)
        ;
        ; parse all includes
        ;
        If MatchRegularExpression(regexp_brackets,x)
          x = ReplaceString(x,"("," ")
          x = ReplaceString(x,")"," ")
        EndIf
        x_parse(x,#DQUOTE$)
        x_parsestring(#DQUOTE$)
        f = x_parsed
        x_parse(x," ",#x_parse_eol|#x_parse_lcase|#x_parse_trim)
        Select x_parsed
            Case "includefile"
              If prep_thindeep = #False
                AddElement(thin_codelist())
                thin_codelist() = ";"
                AddElement(thin_codelist())
                thin_codelist() = "; found '"+x+"'"
                AddElement(thin_codelist())
                thin_codelist() = ";"
              EndIf
              merge_files(x_modifypath(file,f))
              If prep_thindeep = #False
                AddElement(thin_codelist())
                thin_codelist() = ";"
                AddElement(thin_codelist())
                thin_codelist() = "; continuing with "+#DQUOTE$+source+#DQUOTE$
                AddElement(thin_codelist())
                thin_codelist() = ";"
              EndIf
            Case "includebinary"
              AddElement(thin_codelist())
              thin_codelist() = x_parsed+" "+#DQUOTE$+x_modifypath(source,f)+#DQUOTE$
            Case "xincludefile"
            Case "includepath"
        EndSelect
      ElseIf Left(Trim(x),1) = ";"
        ;
        ; strip out all comments lines except purebasic's
        ; at the end of a purebasic file it may contain some IDE / compiler information with the following format:
        ;
        ;   IDE Options = PureBasic 4.41 (Windows - x86)
        ;   CursorPosition = 17
        ;   FirstLine = 13
        ;   Folding = BABAAAAA-
        ;   Markers = 1886,2164
        ;   EnableAsm
        ;   EnableUnicode
        ;   EnableXP
        ;   UseIcon = icons\purebasic_purple.ico
        ;   Executable = ..\..\codecaddy.exe
        ;   CurrentDirectory = C:\software\purebasic\_projects\
        ;   EnableCompileCount = 1293
        ;   EnableBuildCount = 318
        ;   EnableExeConstant
        ;
        ; when required paths are adjusted, otherwise they are exported as is
        ;
        x_parse(x," ",#x_parse_trim|#x_parse_eol|#x_parse_lcase)
        x_parsenext()
        Select x_parsed
            Case "useicon"
              x_parsenext()
              AddElement(thin_codelist())
              thin_codelist() = "; UseIcon = "+x_modifypath(GetPathPart(source),x_parse)
            Case "executable"
              x_parsenext()
              AddElement(thin_codelist())
              thin_codelist() = "; Executable = "+x_modifypath(GetPathPart(source),x_parse)
            Case "currentdirectory"
              x_parsenext()
              AddElement(thin_codelist())
              thin_codelist() = "; CurrentDirectory = "+x_modifypath(GetPathPart(source),x_parse)
            Case "ide" , "cursorposition" , "firstline" , "folding" , "markers" , "enableasm" , "enableunicode" , "enablexp" , "enablecompilecount" , "enablebuildcount", "enableexeconstant"
              AddElement(thin_codelist())
              thin_codelist() = x
            Default
              ;
              ; optionally strip out all comment-only lines
              ;
              If prep_thindeep = #False
                AddElement(thin_codelist())
                thin_codelist() = x
              Else
                thin_commentsstripped_n = thin_commentsstripped_n+1
              EndIf
        EndSelect
        ;
      ElseIf Trim(x) = "" And prep_thindeep = #True
        ;
        ; optionally strip out all empty lines
        ;
        thin_commentsstripped_n = thin_commentsstripped_n+1
        ;
      Else
        ;
        ; we've found a regular line containing code
        ; optionally all comments can be removed
        ; but we will make sure they won't cause false positives
        ;
        If prep_thindeep = #True
          x = Trim(strip_comment(x))
          AddElement(thin_codelist())
          thin_codelist() = x
        Else
          AddElement(thin_codelist())
          thin_codelist() = x
          x = Trim(strip_comment(x))
        EndIf
        ;
        ; scan for procedures
        ;
        If MatchRegularExpression(regexp_procedure,x)
          x_parse(x," ",#x_parse_eol|#x_parse_lcase|#x_parse_trim)
          x_parsestring("(")
          x_parse(x_parsed,".")
          AddElement(thin_procmap())
          thin_procmap()\key = x_parsed
          thin_procmap()\linenr = ListIndex(thin_codelist())+1
          thin_procmap()\inuse = #False
        EndIf
        ;
      EndIf
      ;
    Wend
    If prep_thindeep = #False
      AddElement(thin_codelist())
      thin_codelist() = ";"
      AddElement(thin_codelist())
      thin_codelist() = "; end of "+#DQUOTE$+source+#DQUOTE$
      AddElement(thin_codelist())
      thin_codelist() = ";"
    EndIf
    CloseFile(file_nr)
  EndIf
  ;
EndProcedure

Procedure walk_code(linenr.i)                              ; walk through code and identify used procedures
  Protected x.s, regexp.i, nr.i, d.s, procsinuse.i, p.i
  ;
  ; in:    linenr.i - point in the thin_codelist() list to walk through
  ;        progressflag.i - used for progress indicator, together with the local var procsinuse.i
  ;
  ; walk through the code and try to identify procedures in use
  ; this is step 3 of thinner functionality, this proc does the following:
  ;
  ; 1. walk through the code
  ; 2. skip non-executable parts (procedure definitions)
  ; 3. follow every procedure call if the procedure is not yet marked as in use
  ; 4. until eof, end, or endprocedure
  ;
  ;
  SelectElement(thin_codelist(),linenr-1)
  x = thin_codelist()
  SetGadgetText(#g_progress_bottom,Str(linenr))
  ;
  Repeat
    If MatchRegularExpression(regexp_endprocedure,x)
      ;
      ; we're at an endprocedure, nothing to do but quit
      ;
    ElseIf MatchRegularExpression(regexp_procedure,x)
      ;
      ; it's a procedure definition which we skip
      ;
      Repeat
        If NextElement(thin_codelist())
        EndIf
        x = thin_codelist()
        linenr = linenr+1
        thin_progress = thin_progress + 1
      Until linenr = thin_lines_n Or _
        MatchRegularExpression(regexp_end,x) Or _
        MatchRegularExpression(regexp_endprocedure,x)
      ;
      ; the pointer should be at an endprocedure now...
      ; if it is forward it one step
      ;
      If NextElement(thin_codelist())
        x = thin_codelist()
      EndIf
      linenr = linenr+1
      thin_progress = thin_progress + 1
      ;
      ; SetGadgetState(#g_progress_bar,x_limit(100*thin_progress/ListSize(thin_codelist())-20,0,100))
      If WaitWindowEvent(1) = #PB_Event_Gadget And EventGadget() = #g_progress_cancel
        progress_abort = #True
      EndIf
      ;
    ElseIf MatchRegularExpression(regexp_declare,x)
      ;
      ; going to skip any declares
      ; (must remove those declares later if the procedures are not used!)
      ;
      If NextElement(thin_codelist())
        x = thin_codelist()
      EndIf
      linenr = linenr+1
      thin_progress = thin_progress + 1
      ;
    Else
      ;
      ; this line might contain a procedurename
      ; if it does, did we use this procedure name yet?
      ; if we did not yet, we'll walk through the procedure
      ; afterwards feed the next line no matter what
      ;
      If prep_thindeep = #False
        x = strip_comment(x)
      EndIf
      ;
      procsinuse.i = 0                                              ; counter used for the progress bar
      ;
      ; v1.95 bug in thinner function seems to be nested foreach due to recursion
      ; replacing the hash table (map) with a linked list... sigh... bit tricky too!
      ; mmm... dirty code, might need some clean up, but it seems to work
      ;
      p = -1
      While p < ListSize(thin_procmap())
        p = p+1
        If p < ListSize(thin_procmap())
          SelectElement(thin_procmap(),p)
          If thin_procmap()\inuse = #True
            ;
            ; oh, hit one already in use (ie. walked through)
            ; we'll count them to create something of a progress indicator
            ;
            procsinuse = procsinuse+1
            ;
          ElseIf MatchRegularExpression(regexp_call,x)
            ;
            ; testing is only required if the line contains a procedure or procedure call
            ; found a possbile procedure / macro call that was not marked as in use... yet
            ; walk through it and remove it from the list
            ;
            regexp = CreateRegularExpression(#PB_Any,LCase("([=\\\+\-\*\( /&><,]|\b)"+thin_procmap()\key+"\("))
            If MatchRegularExpression(regexp,LCase(x))
              ;
              AddGadgetItem(#g_codepanel,-1,thin_procmap()\key+"()")
              code_n = code_n+1
              ;
              thin_procmap()\inuse = #True
              walk_code(thin_procmap()\linenr+1)
              thin_progress = thin_progress + 1
              SelectElement(thin_procmap(),p)
              ;
            Else
            EndIf
            FreeRegularExpression(regexp)
            ;
          Else
          EndIf
        EndIf
      Wend
      ;
      linenr = linenr+1
      thin_progress = thin_progress + 1
      If SelectElement(thin_codelist(),linenr-1)
        x = thin_codelist()
      EndIf
      ;
    EndIf
    ;
  Until linenr > ListSize(thin_codelist()) _
    OR MatchRegularExpression(regexp_end,x) _
    OR MatchRegularExpression(regexp_endprocedure,x) _
    OR progress_abort = #True
  ;
  SetGadgetState(#g_progress_bar,x_limit(100*thin_progress/ListSize(thin_codelist())-20,0,100))
  If WaitWindowEvent(1) = #PB_Event_Gadget And EventGadget() = #g_progress_cancel
    progress_abort = #True
  EndIf
  ;
EndProcedure

Procedure thinner(source.s,destination.s)                  ; remove unused procedures and macros from selected file
  ;
  ; *** strips out all unused macros and procedures
  ;
  ; in:  source.s       - the processed file
  ;      destination.s  - the created file
  ;
  ;
  ; step 1: create one large file with all includes onboard
  ; step 2: create a list with all procedures
  ; step 3: walk through the code to verify all used proceders
  ; step 4: strip out all unused procedures
  ;
  ; build window and progress bar
  ;
  If w_main_h > 0
    If show_keepontop = #True
      SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
    EndIf
    EnableWindow_(w_main_h,#False)
    ;
    code_n = 0
    ClearGadgetItems(#g_codepanel)
    clear_codearray()
    SetGadgetItemText(#g_codepanel,-1,"CodeSync",0)
    splitter_max = #True
    filter_type = -1
    draw()
    reflect_settings()
    ;
  EndIf
  If show_nearbydialogs And w_main_h > 0
    OpenWindow(#w_progress_nr,WindowX(#w_main_nr)+40,WindowY(#w_main_nr)+40,400,94,"CodeCaddy - Thinner",0,w_main_h)
  Else
    OpenWindow(#w_progress_nr,10,10,400,94,"CodeCaddy - Thinner",#PB_Window_ScreenCentered,w_main_h)
  EndIf
  x_window_todesktop(#w_progress_nr,-1,0)
  SetWindowPos_(WindowID(#w_progress_nr),#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)
  If Len(source) > 40+3
    TextGadget(#g_progress_top,10,10,310,16,"Thinning ..."+Right(source,40)+"...")
  Else
    TextGadget(#g_progress_top,10,10,310,16,"Thinning "+source+"...")
  EndIf
  TextGadget(#g_progress_bottom,10,64,310,16,"")
  ButtonGadget(#g_progress_cancel,330,60,60,24,"Cancel")
  ProgressBarGadget(#g_progress_bar,10,34,380,16,0,100,#PB_ProgressBar_Smooth)
  ;
  ; prepare
  ;
  ClearList(thin_procmap())
  ClearList(thin_codelist())
  thin_lines_n = 0
  thin_filesincluded = -1
  thin_linesstripped_n = 0
  thin_commentsstripped_n = 0
  thin_procsstripped_n = 0
  thin_declaresstripped_n = 0
  ;
  ; step 1 and 2
  ; create file and procedure list
  ;
  AddGadgetItem(#g_codepanel,-1,"load, merge and scan")
  code_n = code_n+1
  merge_files(source.s)
  ;
  ; step 3
  ; walk through code and scan for procedures
  ;
  AddGadgetItem(#g_codepanel,-1,"identify procedures in use")
  code_n = code_n+1
  thin_progress = 1
  progress_abort = #False
  walk_code(1)
  ;
  ; step 4
  ;
  If progress_abort = #False
    ResetList(thin_codelist())
    While NextElement(thin_codelist())
      If MatchRegularExpression(regexp_procedure,thin_codelist())
        x_parse(thin_codelist()," ",#x_parse_trim|#x_parse_eol|#x_parse_lcase)
        x_parsestring("(")
        x_parse(x_parsed,".")
        ;
        ForEach thin_procmap()
          If thin_procmap()\inuse
            ;
            ; this procedure is in use, keep on going
            ;
            
          ElseIf thin_procmap()\key = x_parsed
            ;
            ; this procedure is not in use, strip it out
            ;
            DeleteElement(thin_codelist())
            thin_linesstripped_n = thin_linesstripped_n+1
            While NextElement(thin_codelist()) And Left(LCase(Trim(thin_codelist())),12)<>"endprocedure" And Left(LCase(Trim(thin_codelist())),12)<>"endmacro"
              DeleteElement(thin_codelist())
              thin_linesstripped_n = thin_linesstripped_n+1
            Wend
            DeleteElement(thin_codelist())
            thin_linesstripped_n = thin_linesstripped_n+1
            thin_procsstripped_n = thin_procsstripped_n+1
            ;
          EndIf
        Next
      EndIf
    Wend
    ;
    CreateFile(2,destination.s)
    WriteStringFormat(2,unicodemode)
    ForEach thin_codelist()
      x_parse(thin_codelist()," ",#x_parse_lcase|#x_parse_eol|#x_parse_trim)
      If x_parsed = "declare" Or Left(x_parsed,8) = "declare."
        x_parsestring("(")
        ForEach thin_procmap()
          If thin_procmap()\key = x_parsed
            If thin_procmap()\inuse
              WriteString(2,thin_codelist()+#CRLF$)
            Else
              thin_declaresstripped_n = thin_declaresstripped_n+1
            EndIf
          EndIf
        Next
      Else
        WriteString(2,thin_codelist()+#CRLF$)
      EndIf
    Next
    CloseFile(2)
    ;
    ; and whilst we are busy we could just as well reformat the file...
    ; format() uses file.s as a filename, but i'm using that for other purposes as well, so
    ; i'll temporary store it
    ;
    If prep_thindeep = #False
      Swap file.s,destination.s
      format()
      Swap file.s,destination.s
    EndIf
    ;
    FreeGadget(#g_progress_cancel)
    FreeGadget(#g_progress_bottom)
    CloseWindow(#w_progress_nr)
    ;
    ; bring main window back up
    ;
    If w_main_h > 0
      ;
      If progress_abort = #False
        ;
        AddGadgetItem(#g_codepanel,-1,"")
        AddGadgetItem(#g_codepanel,-1,"Source: "+source.s)
        AddGadgetItem(#g_codepanel,-1,"Destination: "+destination.s)
        AddGadgetItem(#g_codepanel,-1,"")
        AddGadgetItem(#g_codepanel,-1,Str(thin_filesincluded)+" files included")
        AddGadgetItem(#g_codepanel,-1,Str(ListSize(thin_procmap()))+" procedures total")
        AddGadgetItem(#g_codepanel,-1,Str(thin_procsstripped_n)+" procedures not in use")
        AddGadgetItem(#g_codepanel,-1,Str(thin_declaresstripped_n)+" declares stripped")
        AddGadgetItem(#g_codepanel,-1,Str(thin_commentsstripped_n)+" empty or comment only removed")
        AddGadgetItem(#g_codepanel,-1,Str(thin_linesstripped_n)+" lines of sourcecode not in use")
        AddGadgetItem(#g_codepanel,-1,Str(ListSize(thin_codelist()))+" lines after thinning")
        If Not prep_thindeep
          AddGadgetItem(#g_codepanel,-1,"file has been reformatted and comments were not removed from code in use")
          code_n = code_n+1
        EndIf
        AddGadgetItem(#g_codepanel,-1,"")
        AddGadgetItem(#g_codepanel,-1,"Thinning complete")
        code_n = code_n+13
        SetActiveGadget(#g_codepanel)
        SetGadgetState(#g_codepanel,code_n-1)
        x_setlisticonvisibleline(#g_codepanel,code_n-1)
        ;
      EndIf
      ;
      EnableWindow_(w_main_h,#True)
      If GetForegroundWindow_() <> w_main_h
        If show_keepontop
          SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
          SetForegroundWindow_(w_main_h)
        Else
          SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
          SetForegroundWindow_(w_main_h)
        EndIf
      EndIf
      ;
    EndIf
  EndIf
  ;
EndProcedure

Procedure preprocess()                                     ; preprocess compilefile
  Protected n.i, path.s, name.s, x.s, y.s, mem_p.i, mem_l.i, l.i, t.i, p.i, b.i, synclines.i
  ;
  ; *** modify compilefile before processing
  ;
  path = GetPathPart(compilefile)
  If x_exist(compilefile)
    ;
    ; we have to prepare a file compilefile so the compiler can do its thing
    ;
    If prep_thinbuilds And command = "build"
      ;
      ; strip out all unused procedures and macros
      ;
      thinner(file,compilefile)
      ;
    Else
      progress_abort = #False
    EndIf
    ;
    If progress_abort = #False
      ;
      If prep_multiline
        ;
        ; flatten the source
        ; open the compilefile, create a temp file, flatten the compilefile to the tempfile
        ;
        ReadFile(1,compilefile)
        CreateFile(2,path+"codecaddy.tmp")
        flatten()
        CloseFile(1)
        CloseFile(2)
        DeleteFile(compilefile)
        RenameFile(path+"codecaddy.tmp",compilefile)
        ;
      EndIf
      ;
      If prep_addconstants
        ;
        ; add save / build constants
        ; first open it and check for a UTF8 BOM then add constants and a BOM if needed then copy remaining data
        ;
        ; uncomment next line to use an external viewer to 'preview' the contents of the (flattened) file passed on to this routine
        ;
        ;   RunProgram("c:\software\utils\lister.exe",path+"codecaddy.tmp","",#PB_Program_Wait)
        ;
        ReadFile(1,compilefile)
        CreateFile(2,path+"codecaddy.tmp")
        ;
        unicodemode = ReadStringFormat(1)
        WriteStringFormat(2,unicodemode)
        ;
        x =      "#codecaddy_save_nr = "+Str(save_nr)
        x = x+" : #codecaddy_build_nr = "+Str(build_nr)
        x = x+" : #codecaddy_build_date = "+Str(Date())
        x = x+" : #codecaddy_compilerun = "+Str(compilerun)
        ;
        y = Trim(ReadString(1,unicodemode))
        ;
        If y = "" Or Left(y,1) = ";"                     ; empty or comment line, so insert constants without a colon
          WriteString(2,x+" ",unicodemode)
        Else
          WriteString(2,x+" : ",unicodemode)             ; preceed existing code with constants and a colon
        EndIf
        WriteString(2,y+Chr($0D)+Chr($0A),unicodemode)   ; then write the line with a CRLF (forget about that one, oops)
        ;
        mem_l = Lof(1)-Loc(1)
        mem_p = AllocateMemory(mem_l)
        ReadData(1,mem_p,mem_l)
        WriteData(2,mem_p,mem_l)
        FreeMemory(mem_p)
        CloseFile(1)
        CloseFile(2)
        DeleteFile(compilefile)
        RenameFile(path+"codecaddy.tmp",compilefile)
        ;
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure install_inpbide()                                ; add codecaddy calls to pb ide tools.prefs file
  Protected p.i, choice.i, success.i, skip.i, x.s, n.i, nn.i, prefsfile.s, itemidlist_p.i, c.i, toolcount.i, instances.s, f.s, message.s, tempfile.s
  ;
  message.s = "CodeCaddy tries to find and modify the PB IDE file 'tools.prefs'."+#CRLF$+#CRLF$ + _
    "Old CodeCaddy shortcuts will be removed, and the following will be added:"+#CRLF$+#CRLF$ + _
    "- find [Ctrl]+[F1]"+#CRLF$ + _
    "- google [Alt]+[F1]"+#CRLF$ + _
    "- reformat [Alt]+[R]"+#CRLF$ + _
    "- snapshot [Alt]+[M]"+#CRLF$ + _
    "- build (auto)"+#CRLF$ + _
    "- run (auto)"+#CRLF$ + _
    "- save (unused)"+#CRLF$ + _
    "- info"+#CRLF$ + _
    "- quickhelp"+#CRLF$+#CRLF$ + _
    "These will point to:"+#CRLF$+#CRLF$ + _
    ProgramFilename()+#CRLF$+#CRLF$
  ;
  ; find all occurences of tools.prefs
  ;
  instances = ""
  f.s = GetCurrentDirectory()+"tools.prefs"
  If x_existx(f.s)
    instances = instances + f.s + "|"
  EndIf
  f.s = "c:\software\purebasic\tools.prefs"
  If x_existx(f.s)
    instances.s = instances.s + f.s + "|"
  EndIf
  f.s = GetHomeDirectory()+"purebasic\tools.prefs"
  If x_existx(f.s)
    instances.s = instances.s + f.s + "|"
  EndIf
  f.s = x_getspecialfolderlocation(#CSIDL_APPDATA)+"purebasic\tools.prefs"
  If x_existx(f.s)
    instances.s = instances.s + f.s + "|"
  EndIf
  f.s = x_getspecialfolderlocation(#CSIDL_PROGRAM_FILES)+"purebasic\tools.prefs"
  If x_existx(f.s)
    instances.s = instances.s + f.s + "|"
  EndIf
  instances = x_stringtostring(instances,10)
  ;
  If instances > ""
    ;
    ; one or more files found
    ;
    message = message + "The following file(s) will be modified:" + #CRLF$ + #CRLF$
    ;
  Else
    ;
    ; v1.99
    ; no files found, look for any occurances of purebasic.prefs
    ;
    f.s = GetCurrentDirectory()+"purebasic.prefs"
    If x_existx(f.s)
      instances.s = instances.s + f.s + "|"
    EndIf
    f.s = "c:\software\purebasic\purebasic.prefs"
    If x_existx(f.s)
      instances.s = instances.s + f.s + "|"
    EndIf
    f.s = GetHomeDirectory()+"purebasic\purebasic.prefs"
    If x_existx(f.s)
      instances.s = instances.s + f.s + "|"
    EndIf
    f.s = x_getspecialfolderlocation(#CSIDL_APPDATA)+"purebasic\purebasic.prefs"
    If x_existx(f.s)
      instances.s = instances.s + f.s + "|"
    EndIf
    f.s = x_getspecialfolderlocation(#CSIDL_PROGRAM_FILES)+"purebasic\purebasic.prefs"
    If x_existx(f.s)
      instances.s = instances.s + f.s + "|"
    EndIf
    If instances > ""
      ;
      ; found a purebasic.prefs file
      ;
      instances = x_stringtostring(instances,10)
      instances = ReplaceString(LCase(instances),"purebasic.prefs","tools.prefs")
      message = message + "The following file(s) will be created:" + #CRLF$ + #CRLF$
      ;
    EndIf
  EndIf
  ;
  If instances = ""
    ;
    message.s = message.s + "No tools.prefs file was found or created."
    nearby_dialog()
    choice = MessageRequester("Configure PB IDE",message,#MB_OK|#MB_ICONERROR)
    ;
  Else
    ;
    ; ah, files to parse
    ;
    x_parsefield(instances,"|",#x_parse_trim|#x_parse_eol)
    For n = 1 To x_parse_field_n
      message = message+x_parse_field(n)+#CRLF$
    Next n
    nearby_dialog()
    choice = MessageRequester("Configure PB IDE",message+#CRLF$+"Continue?",#MB_OKCANCEL|#MB_ICONQUESTION)
    ;
    If choice = #IDOK
      ;
      ; modify all files found
      ;
      message = "CodeCaddy modified the following file(s):"+#CRLF$+#CRLF$
      ;
      For n = 1 To x_parse_field_n
        prefsfile = x_parse_field(n)
        tempfile = prefsfile+".old"
        ;
        If Not x_existx(prefsfile)
          ;
          ; v1.99
          ; try to create a file if it did not exist yet
          ;
          If CreateFile(1,prefsfile)
            WriteString(1,";  PureBasic IDE ToolsMenu Configuration"+#CRLF$)
            WriteString(1,"; "+#CRLF$)
            WriteString(1,"[ToolsInfo]"+#CRLF$)
            WriteString(1,"Toolcount = 0"+#CRLF$)
            CloseFile(1)
          EndIf
        EndIf
        ;
        If Not OpenFile(1,prefsfile)
          ;
          ; report failure
          ;
          message = message+prefsfile+" (failed)"+#CRLF$
        Else
          If Not CreateFile(2,tempfile)
            ;
            ; report failure
            ;
            CloseFile(1)
            message = message+prefsfile+" (failed)"+#CRLF$
          Else
            ;
            ; get the default list, adjust any paths in there
            ;
            x.s = PeekS(?i_idetools_prefs,-1,#PB_UTF8)
            x.s = ReplaceString(x.s,"C:\software\purebasic\codecaddy.exe",ProgramFilename(),#PB_String_NoCase)
            ;
            ; be arrogant and put codecaddy entries on top :-)
            ;
            WriteString(2,x.s)
            WriteString(2,";"+#CRLF$)
            WriteString(2,";"+#CRLF$)
            ;
            ; skip the old header (including toolcount)
            ;
            x.s = ReadString(1)
            While x_matchpattern(x.s,"[tool_*]",#x_parse_anycase) = #False And x_not(Eof(1))
              x.s = ReadString(1)
            Wend
            ;
            ; should be at tool number one (of the old file), now read the next tool's command line
            ;
            While x_not(Eof(1))
              x.s = ReadString(1)
              If x_matchpattern(x.s,"command = *codecaddy.exe*",#x_parse_anycase) = #True
                ;
                ; it's a codecaddy entry, skip it
                ;
                skip = #True
                Repeat
                  x.s = ReadString(1)
                Until x_matchpattern(x.s,"[tool_*]",#x_parse_anycase) = #True Or Eof(1)
              Else
                ;
                ; it's not a codecaddy entry, store it
                ;
                skip = #False
                WriteString(2,"[Tool_x]"+#CRLF$)
                Repeat
                  WriteString(2,x.s+#CRLF$)
                  x.s = ReadString(1)
                Until x_matchpattern(x.s,"[tool_*]",#x_parse_anycase) = #True Or Eof(1)
              EndIf
            Wend
            ;
            ; current x.s could contain some valid data, so store it if we were not skipping
            ;
            If skip = #False
              WriteString(2,x.s+#CRLF$)
            EndIf
            ;
            CloseFile(1)
            CloseFile(2)
            ;
            ; so, how many tools did we end up with?
            ;
            ReadFile(2,tempfile)
            toolcount = 0
            While x_not(Eof(2))
              x.s = ReadString(2)
              If x_matchpattern(x.s,"[tool_*]",#x_parse_anycase) = #True
                toolcount = toolcount+1
              EndIf
            Wend
            CloseFile(2)
            ;
            ; renumber and overwrite original
            ;
            nn = 0
            ReadFile(2,tempfile)
            CreateFile(1,prefsfile)
            While x_not(Eof(2))
              x.s = ReadString(2)
              If x_matchpattern(x.s,"toolcount = *",#x_parse_anycase) = #True
                WriteString(1,"ToolCount = "+Str(Toolcount))
              ElseIf x_matchpattern(x.s,"[Tool_*",#x_parse_anycase) = #True
                WriteString(1,"[Tool_"+Str(nn)+"]")
                nn = nn+1
              Else
                WriteString(1,x.s)
              EndIf
              WriteString(1,#CRLF$)
            Wend
            CloseFile(2)
            ;
          EndIf
          CloseFile(1)
          ;
          message = message+prefsfile+#CRLF$
          ;
        EndIf
      Next n
      nearby_dialog()
      choice = MessageRequester("Configure PB IDE",message,#MB_OK)
    EndIf
  EndIf
  ;
  DataSection
    i_idetools_prefs:
    IncludeBinary "tools.prefs"
    Data.l 0
  EndDataSection
  ;
EndProcedure

Procedure codesync()                                       ; synchronize specified folders recognizing .pb and .cdy files
  Protected choice.i, s.s, f.s, ff.s, g.s, n.i, ff_n.i, pass.i, event.i
  Protected source.s, destination.s
  Protected files.i, folders.i, sources.i, other.i, created.i, confirmations.i, filtered.i, backups.i, skipped.i, copied.i
  Protected f_filesize.i, f_lastwrite.i, g_filesize.i, g_lastwrite.i, f_cdy_exists.i, g_cdy_exists.i, f_save_nr.i, g_save_nr.i
  Protected folder_exists.i, ff_existed.i
  ;
  If save_baktobackup = #True And save_cdytobackup = #False And UCase(codesync_folder1) <> UCase(codesync_folder2) And codesync_folder1 <> "" And codesync_folder2 <> ""
    choice = #IDYES
  Else
    s = "Attention! Please verify your Codesync settings!"+#CRLF$+#CRLF$
    ;
    If UCase(codesync_folder1) = UCase(codesync_folder2) Or codesync_folder1 = "" Or codesync_folder2 = ""
      s = s+"Source and destination folder are the same or invalid. You can change this"+#CRLF$
      s = s+"via Options / Preferences / Other / Codesync."+#CRLF$+#CRLF$
    EndIf
    If save_baktobackup = #False Or save_cdytobackup = #True
      s = s+"CodeSync was designed to be used with the following options:"+#CRLF$+#CRLF$
      s = s+"    Store .bak files in separate folder 'Backup' ON (currently "
      If save_baktobackup
        s = s+"ON)"
      Else
        s = s+"OFF)"
      EndIf
      s = s+#CRLF$+"    Store .cdy files in separate folder 'Backup' OFF (currently "
      If save_cdytobackup
        s = s+"ON)"
      Else
        s = s+"OFF)"
      EndIf
      s = s+#CRLF$+#CRLF$+"You can change these under Options / Preferences / Backup."+#CRLF$+#CRLF$
    EndIf
    s = s+"Continue anyway?"
    nearby_dialog()
    choice = MessageRequester("CodeSync",s,#MB_YESNO|#MB_ICONWARNING)
  EndIf
  ;
  If choice = #IDYES
    ;
    If w_main_h > 0
      code_n = 0
      ClearGadgetItems(#g_codepanel)
      clear_codearray()
      SetGadgetItemText(#g_codepanel,-1,"CodeSync",0)
      splitter_max = #True
      filter_type = -1
      draw()
      reflect_settings()
    EndIf
    ;
    files     = 0
    folders   = 0
    sources   = 0
    other     = 0
    created   = 0
    filtered  = 0
    backups   = 0
    skipped = 0
    confirmations = 0
    ;
    ; adjust pathnames
    ;
    If Right(codesync_folder1,1) <> "\"
      codesync_folder1 = codesync_folder1+"\"
    EndIf
    If Right(codesync_folder2,1) <> "\"
      codesync_folder2 = codesync_folder2+"\"
    EndIf
    ;
    ; check if paths are actually folders
    ;
    folder_exists = #True
    If FileSize(codesync_folder1) <> -2
      folder_exists = #False
      f = "create "
    Else
      f = f+"use "
    EndIf
    f = f+"folder 1: "+codesync_folder1+#CRLF$
    If FileSize(codesync_folder2) <> -2
      folder_exists = #False
      f = f+"create "
    Else
      f = f+"use "
    EndIf
    f = f+"folder 2: "+codesync_folder2
    ;
    ; if necessary, ask if the paths should be created, then create them
    ;
    progress_abort = #False
    If folder_exists = #False
      nearby_dialog()
      choice = MessageRequester("Codesync","A specified base folder does not exist. Create now? " + _
        #CRLF$+#CRLF$+f,#MB_YESNO|#MB_ICONQUESTION)
      If choice = #IDYES
        folder_exists = x_bool(x_createdirectory(codesync_folder1))
        If folder_exists
          folder_exists = x_bool(x_createdirectory(codesync_folder2))
        EndIf
        If x_not(folder_exists)
          nearby_dialog()
          MessageRequester("Codesync","Error! Could not create or use one or more base folders."+#CRLF$+#CRLF$+f,#MB_OK|#MB_ICONERROR)
          progress_abort = #True
          folder_exists = #False
        EndIf
      Else
        progress_abort = #True
      EndIf
    EndIf
    ;
    If folder_exists = #True
      ;
      ; build window and progress bar
      ;
      If w_main_h > 0
        If show_keepontop = #True
          SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
        EndIf
        EnableWindow_(w_main_h,#False)
      EndIf
      If show_nearbydialogs And w_main_h > 0
        OpenWindow(#w_progress_nr,WindowX(#w_main_nr)+40,WindowY(#w_main_nr)+40,400,94,"CodeCaddy - Codesync",0,w_main_h)
      Else
        OpenWindow(#w_progress_nr,10,10,400,94,"CodeCaddy - Codesync",#PB_Window_ScreenCentered,w_main_h)
      EndIf
      x_window_todesktop(#w_progress_nr,-1,0)
      SetWindowPos_(WindowID(#w_progress_nr),#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)
      TextGadget(#g_progress_bottom,10,64,310,16,"")
      ButtonGadget(#g_progress_cancel,330,60,60,24,"Cancel")
      ;
      ; we're going to do two passes, folder 1 to 2 then folder 2 to 1
      ;
      progress_abort = #False
      pass = 0
      While pass < 2 And progress_abort = #False
        pass = pass+1
        ;
        If pass = 1
          TextGadget(#g_progress_top,10,10,380,16,"Synchronizing... pass 1: folder 1 to folder 2")
          source = codesync_folder1
          destination = codesync_folder2
        Else
          TextGadget(#g_progress_top,10,10,380,16,"Synchronizing... pass 2: folder 2 to folder 1")
          source = codesync_folder2
          destination = codesync_folder1
        EndIf
        ;
        ; get a list of all files in source folder, and continue if it contains at least 1 folder :-)
        ;
        x_dir(source,"*.*",3,200,10000)                                              ; arbitrary limits
        SortList(x_dir_file(),#PB_Sort_Ascending)
        If x_dir_n > 0
          ;
          ; we're read the source, now remove all unwanted .bak files (either more than set in preferences, or that have no related source file)
          ; and strip out all .cdy files (they will be handled when we hit a source)
          ;
          ; basically i go through the list twice, first time backwards (end to begin), removing everything i don't need (.cdy's, superfluous .bak's etc.)
          ; then in the second step (stepping through the list this time begin to end) all folders are actually created and files actually copied
          ;
          ff = ""
          ff_existed = #False
          ff_n = 0
          ;
          LastElement(x_dir_file())
          Repeat
            f = x_dir_file()\name
            If Right(f,1) = "\"                                                                     ; keep all folders
            ElseIf LCase(Right(f,7)) = ".pb.cdy"                                                    ; strip out all .cdy files
              files = files+1
              DeleteElement(x_dir_file())
              NextElement(x_dir_file())
            ElseIf x_matchpattern(GetFilePart(f),codesync_filter,#x_parse_anycase) = #True          ; filter out what we don't want
              files = files+1
              filtered = filtered +1
              DeleteElement(x_dir_file())
              NextElement(x_dir_file())
            Else                                                                                    ; not a .cdy file, but is it a .bak file? if so, should we remove it?
              files = files+1
              If LCase(GetExtensionPart(f)) = "bak" And x_matchpattern(f,"*\_backup\*.bak",#x_parse_anycase)  ; a valid .bak file
                If x_matchpattern(f,"*\_backup\*.build*.bak",#x_parse_anycase)
                  f = Left(f,x_rfindstring(f,".")-1)                                                ; .build.bak files need an additional part of their name stripped away
                EndIf
                f = Left(f,x_rfindstring(f,".")-1)                                                  ; all .bak files need their backup number and .bak extension stripped out
                f = Left(f,x_rfindstring(f,".")-1)
                f = x_getparentpathpart(GetPathPart(f))+GetFilePart(f)
                If f = ff                                                                           ; multiple bak's belonging to the same parent
                  If ff_existed = #True And ff_n < 5                                                ; process if not too many
                    ff_n = ff_n+1
                  Else                                                                              ; strip out if too many, or if the parent does not exist
                    DeleteElement(x_dir_file())
                    NextElement(x_dir_file())
                  EndIf
                Else                                                                                ; this bak belongs to another parent
                  ff = f
                  If x_exist(f)                                                                     ; parent exists
                    ff_existed = #True
                    ff_n = 1
                  Else                                                                              ; parent does not exist
                    ff_existed = #False
                    DeleteElement(x_dir_file())
                    NextElement(x_dir_file())
                  EndIf
                EndIf
              Else                                                                                  ; doesn't match pattern
              EndIf
            EndIf
          Until PreviousElement(x_dir_file()) = 0
          ;
          ; go through the list, this time begin to end, and create folders and copy files when and where needed
          ;
          ProgressBarGadget(#g_progress_bar,10,34,380,16,0,ListSize(x_dir_file()),#PB_ProgressBar_Smooth)
          ResetList(x_dir_file())
          n = 0
          While NextElement(x_dir_file()) And folder_exists = #True And progress_abort = #False
            n = n+1
            ;
            SetGadgetState(#g_progress_bar,n)
            event = WindowEvent()
            If event = #PB_Event_Gadget And EventGadget() = #g_progress_cancel
              progress_abort = #True
            Else
              ;
              ; process an entry from the list, it could be a file or a folder
              ;
              f = x_dir_file()\name
              g = ReplaceString(f,source,destination)
              ;
              If Right(g,1) = "\"
                ;
                ; it's a folder
                ;
                folders = folders+1
                If CreateDirectory(g) <> 0 And w_main_h > 0
                  If w_main_h > 0
                    AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                    code_n = code_n+1
                  EndIf
                  created = created+1
                EndIf
                ;
              Else
                ;
                ; it's a file
                ;
                If x_not(x_exist(g))
                  ;
                  ; did not exist on the other side so let's copy
                  ;
                  If w_main_h > 0
                    AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                    code_n = code_n+1
                  EndIf
                  CopyFile(f,g)
                  ;
                  ; adjust counters and copy eventual .cdy file
                  ;
                  If LCase(Right(f,3)) = ".pb"
                    sources = sources+1
                    If x_exist(f+".cdy")
                      If w_main_h > 0
                        AddGadgetItem(#g_codepanel,-1,f+".cdy -> "+g+".cdy")
                        code_n = code_n+1
                      EndIf
                      CopyFile(f+".cdy",g+".cdy")
                    EndIf
                  ElseIf x_matchpattern(f,"*\_backup\*.pb.*.bak",#x_parse_anycase)
                    backups = backups + 1
                  Else
                    other = other+1
                  EndIf
                  ;
                ElseIf x_matchpattern(f,"*\_backup\*.pb.*.bak",#x_parse_anycase)
                  ;
                  ; .bak files are never copied if they already existed... safety first!
                  ;
                  skipped = skipped + 1
                  ;
                Else
                  ;
                  ; file exists on both sides, get additional information, take actions depending on type, date, timestamps etc.
                  ;
                  f_filesize = FileSize(f)
                  f_lastwrite = GetFileDate(f,#PB_Date_Modified)
                  g_filesize = FileSize(g)
                  g_lastwrite = GetFileDate(g,#PB_Date_Modified)
                  ;
                  ; the rules for files that exist on both sides:
                  ;
                  ;   (1)  IF source is destination -> do nothing
                  ;   (2)  ELSEIF .pb
                  ;   (3)    IF both sides have a .cdy
                  ;   (4)      IF source is newer than destination AND .cdy's confirm -> overwrite and copy .cdy
                  ;   (5)      ELSE -> throw a warning, eventually copy .pb and .cdy after confirmation
                  ;   (6)    ELSEIF source is newer than destination -> throw a warning, eventually copy .pb after confirmation
                  ;   (7)    ELSE do nothing
                  ;   (8)  ELSE non .pb
                  ;   (9)    IF source is older than destination -> do nothing
                  ;   (10)   ELSEIF warning option is ON -> throw warning, eventually copy after confirmation
                  ;   (11)   ELSE source is newer so -> overwrite
                  ;
                  If f_filesize = g_filesize And Abs(f_lastwrite-g_lastwrite)<=2                ; (1) left and right are identical, do nothing
                    ;
                    ; left and right are identical (no checksumming though, so it will miss some but hey, that's life)
                    ;
                  ElseIf LCase(Right(f,3)) = ".pb"                                              ; (2) it's a pb file
                    ;
                    ; purebasic source file
                    ;
                    f_cdy_exists = x_exist(f+".cdy")                                            ; flags to remember if related .cdy files exist
                    g_cdy_exists = x_exist(f+".cdy")                                            ; flags are a little faster than relying on windows cache, and make things easier to read
                    If f_cdy_exists And g_cdy_exists                                            ; (3) both sides have a .cdy
                      OpenPreferences(f+".cdy")
                      f_save_nr = ReadPreferenceInteger("save_nr",0)
                      ClosePreferences()
                      OpenPreferences(g+".cdy")
                      g_save_nr = ReadPreferenceInteger("save_nr",0)
                      ClosePreferences()
                      If f_lastwrite-1 > g_lastwrite+1  And f_save_nr > g_save_nr               ; (4) source is newer and .cdy's confirm
                        ;
                        ; source is newer and .cdy's confirm
                        ;
                        sources = sources+1
                        If w_main_h > 0
                          AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                          AddGadgetItem(#g_codepanel,-1,f+".cdy -> "+g+".cdy")
                          code_n = code_n+2
                        EndIf
                        CopyFile(f,g)
                        CopyFile(f+".cdy",g+".cdy")
                      Else                                                                      ; (5) possible mismatch, request confirmation
                        ;
                        ; possible conflict / mismatch of .pb and .cdy file
                        ;
                        confirmations = confirmations+1
                        nearby_dialog()
                        choice = MessageRequester("Codesync", _
                          "Timestamp versus save number indicates a possible conflict..."+ _
                          #CRLF$+#CRLF$+"Overwrite file"+ _
                          #CRLF$+#CRLF$+g+#CRLF$+FormatDate("time %DD.%MM.%YY %HH:%II",g_lastwrite)+ _
                          " size "+Str(g_filesize)+" save "+x_strex(g_save_nr,save_mask)+ _
                          #CRLF$+#CRLF$+"with file"+ _
                          #CRLF$+#CRLF$+f+#CRLF$+FormatDate("time %DD.%MM.%YY %HH:%II",f_lastwrite)+ _
                          " size "+Str(f_filesize)+" save "+x_strex(f_save_nr,save_mask), _
                          #MB_YESNOCANCEL|#MB_ICONWARNING)
                        If choice = #IDNO
                        ElseIf choice = #IDYES
                          sources = sources+1
                          If w_main_h > 0
                            AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                            AddGadgetItem(#g_codepanel,-1,f+".cdy -> "+g+".cdy")
                            code_n = code_n+2
                          EndIf
                          CopyFile(f,g)
                          CopyFile(f+".cdy",g+".cdy")
                        Else
                          progress_abort = #True
                        EndIf
                      EndIf
                    ElseIf f_lastwrite-1 > g_lastwrite+1                                        ; (6) source is newer than destination, request confirmation
                      ;
                      ; possible conflict as only one side has a .cdy
                      ;
                      confirmations = confirmations+1
                      nearby_dialog()
                      choice = MessageRequester("Codesync", _
                        "Missing .cdy file(s)..."+ _
                        #CRLF$+#CRLF$+"Overwrite file"+ _
                        #CRLF$+#CRLF$+g+#CRLF$+FormatDate("time %DD.%MM.%YY %HH:%II",g_lastwrite)+ _
                        " size "+Str(g_filesize)+" save "+x_strex(g_save_nr,save_mask)+ _
                        #CRLF$+#CRLF$+"with file"+ _
                        #CRLF$+#CRLF$+f+#CRLF$+FormatDate("time %DD.%MM.%YY %HH:%II",f_lastwrite)+ _
                        " size "+Str(f_filesize)+" save "+x_strex(f_save_nr,save_mask), _
                        #MB_YESNOCANCEL|#MB_ICONWARNING)
                      If choice = #IDNO
                      ElseIf choice = #IDYES
                        sources = sources+1
                        If w_main_h > 0
                          AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                          code_n = code_n+1
                        EndIf
                        CopyFile(f,g)
                        If x_exist(f+".cdy")
                          If w_main_h > 0
                            AddGadgetItem(#g_codepanel,-1,f+".cdy -> "+g+".cdy")
                            code_n = code_n+1
                          EndIf
                          CopyFile(f+".cdy",g+".cdy")
                        EndIf
                      Else
                        progress_abort = #True
                      EndIf
                      ;
                    Else                                                                        ; (7) source is older than destination, do nothing
                      ;
                      ; source is older than destination, do nothing
                      ;
                    EndIf
                    ;
                  Else                                                                          ; (8) non-pb file
                    ;
                    ; non-purebasic .pb (source) files
                    ;
                    If g_lastwrite-1 > f_lastwrite+1                                            ; (9) destination is newer, do nothing
                      ;
                      ; non-pb file, yet nothing to do if the destination is newer
                      ;
                    ElseIf codesync_confirmation                                                ; (10) source is newer and confirmation flag is set so ask for confirmation
                      ;
                      ; non-pb file, confirmation flag is set, source is newer, thus request confirmation
                      ;
                      confirmations = confirmations+1
                      nearby_dialog()
                      choice = MessageRequester("Codesync", _
                        "Non-pb file, source is newer than destination..."+ _
                        #CRLF$+#CRLF$+"Overwrite file"+ _
                        #CRLF$+#CRLF$+g+#CRLF$+FormatDate("time %DD.%MM.%YY %HH:%II",g_lastwrite)+ _
                        " size "+Str(g_filesize)+ _
                        #CRLF$+#CRLF$+"with file"+ _
                        #CRLF$+#CRLF$+f+#CRLF$+FormatDate("time %DD.%MM.%YY %HH:%II",f_lastwrite)+ _
                        " size "+Str(f_filesize), _
                        #MB_YESNOCANCEL|#MB_ICONWARNING)
                      If choice = #IDNO
                      ElseIf choice = #IDYES
                        other = other+1
                        If w_main_h > 0
                          AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                          code_n = code_n+1
                        EndIf
                        CopyFile(f,g)
                      Else
                        progress_abort = #True
                      EndIf
                      ;
                    Else                                                                        ; (11) confirmation flag is not set, so overwrite
                      ;
                      ; source is newer than destination, and we don't need confirmation as the flag wasn't set so overwrite
                      ;
                      other = other+1
                      If w_main_h > 0
                        AddGadgetItem(#g_codepanel,-1,f+" -> "+g)
                        code_n = code_n+1
                      EndIf
                      CopyFile(f,g)
                      ;
                    EndIf
                  EndIf
                EndIf
              EndIf
            EndIf
          Wend
        EndIf
        ;
        ; free gadgets (don't think that's actually necessary, but who cares)
        ;
        FreeGadget(#g_progress_top)
        FreeGadget(#g_progress_bar)
      Wend
      ;
      ; bring main window back up
      ;
      If w_main_h > 0
        EnableWindow_(w_main_h,#True)
        If GetForegroundWindow_() <> w_main_h
          If show_keepontop
            SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
            SetForegroundWindow_(w_main_h)
          Else
            SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
            SetForegroundWindow_(w_main_h)
          EndIf
        EndIf
      EndIf
      ;
      FreeGadget(#g_progress_cancel)
      FreeGadget(#g_progress_top)
      FreeGadget(#g_progress_bottom)
      CloseWindow(#w_progress_nr)
      ;
    EndIf
    ;
    ; report results
    ;
    If progress_abort = #True
    ElseIf folder_exists = #False
      nearby_dialog()
      MessageRequester("Codesync","Error! Could not create or use one or more folders.",#MB_OK|#MB_ICONERROR)
    Else
      If w_main_h > 0
        code_n = code_n+16
        AddGadgetItem(#g_codepanel,-1,"")
        AddGadgetItem(#g_codepanel,-1,"Folder 1: "+codesync_folder1)
        AddGadgetItem(#g_codepanel,-1,"Folder 2: "+codesync_folder2)
        AddGadgetItem(#g_codepanel,-1,"Filter: "+codesync_filter)
        AddGadgetItem(#g_codepanel,-1,"")
        AddGadgetItem(#g_codepanel,-1,Str(folders)+" folders processed")
        AddGadgetItem(#g_codepanel,-1,Str(created)+" folders created")
        AddGadgetItem(#g_codepanel,-1,Str(files)+" files found")
        AddGadgetItem(#g_codepanel,-1,Str(sources)+" sources copied")
        AddGadgetItem(#g_codepanel,-1,Str(backups)+" backup files copied")
        AddGadgetItem(#g_codepanel,-1,Str(skipped)+" backup files skipped")
        AddGadgetItem(#g_codepanel,-1,Str(other)+" other files copied")
        AddGadgetItem(#g_codepanel,-1,Str(filtered)+" files filtered")
        AddGadgetItem(#g_codepanel,-1,Str(confirmations)+" confirmations requested")
        AddGadgetItem(#g_codepanel,-1,"")
        AddGadgetItem(#g_codepanel,-1,"Synchronizing complete.")
        SetActiveGadget(#g_codepanel)
        SetGadgetState(#g_codepanel,code_n-1)
        x_setlisticonvisibleline(#g_codepanel,code_n-1)
      Else
        nearby_dialog()
        MessageRequester("Codesync","Synchronizing complete."+#CRLF$ _
          + #CRLF$+Str(files)+"  processed" +#CRLF$+Str(copied)+"  copied" _
          + #CRLF$+Str(backups)+"  backups" +#CRLF$+Str(filtered)+"  filtered" _
          + #CRLF$+Str(confirmations)+"  confirmations" _
          + #CRLF$+Str(created)+"  folders created",#MB_OK|#MB_ICONINFORMATION)
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure prefs_get()                                      ; read settings into preferences window
  ;
  ; user interface
  ;
  SetGadgetState(#g_prefs_show_menu,show_menu)
  SetGadgetState(#g_prefs_show_toolbar,show_toolbar)
  SetGadgetState(#g_prefs_show_buttons,show_buttons)
  SetGadgetState(#g_prefs_show_statusbar,show_statusbar)
  SetGadgetState(#g_prefs_show_keepontop,show_keepontop)
  SetGadgetState(#g_prefs_show_darkercolors,show_darkercolors)
  SetGadgetState(#g_prefs_show_nearbydialogs,show_nearbydialogs)
  SetGadgetState(#g_prefs_show_unzoom,show_unzoom)
  ;
  SetGadgetState(#g_prefs_spacing_frame,spacing_frame)
  SetGadgetState(#g_prefs_spacing_buttons,spacing_buttons)
  ;
  prefs_font_name = font_name
  prefs_font_size = font_size
  SetGadgetText(#g_prefs_font_t,prefs_font_name+" "+Str(prefs_font_size))
  ;
  SetGadgetState(#g_prefs_config_saveonexit,config_saveonexit)
  ;
  ; backup
  ;
  SetGadgetState(#g_prefs_save_length,save_length)
  SetGadgetState(#g_prefs_save_max,save_max)
  SetGadgetState(#g_prefs_save_excludebuilds,save_excludebuilds)
  SetGadgetState(#g_prefs_save_excludesnapshots,save_excludesnapshots)
  SetGadgetState(#g_prefs_save_baktobackup,save_baktobackup)
  SetGadgetState(#g_prefs_save_cdytobackup,save_cdytobackup)
  SetGadgetState(#g_prefs_compilerun_autosaveinterval,compilerun_autosaveinterval)
  SetGadgetState(#g_prefs_compilerun_savefrequency,compilerun_savefrequency)
  ;
  ; pre-processing
  ;
  SetGadgetState(#g_prefs_prep_savebackup,prep_savebackup)
  SetGadgetState(#g_prefs_prep_addconstants,prep_addconstants)
  SetGadgetState(#g_prefs_prep_multiline,prep_multiline)
  SetGadgetState(#g_prefs_prep_keepsync,prep_keepsync)
  SetGadgetState(#g_prefs_prep_thinbuilds,prep_thinbuilds)
  SetGadgetState(#g_prefs_prep_thindeep,prep_thindeep)
  ;
  ; codesync
  ;
  SetGadgetText(#g_prefs_codesync_folder1,codesync_folder1)
  SetGadgetText(#g_prefs_codesync_folder2,codesync_folder2)
  SetGadgetText(#g_prefs_codesync_filter,x_stringtostring(codesync_filter,8))
  SetGadgetState(#g_prefs_codesync_baklimit,codesync_baklimit)
  SetGadgetState(#g_prefs_codesync_confirmation,codesync_confirmation)
  ;
  ; format
  ;
  SetGadgetState(#g_prefs_format_indent,format_indent)
  SetGadgetState(#g_prefs_format_smart,format_smart)
  SetGadgetState(#g_prefs_format_multiline,format_multiline)
  SetGadgetState(#g_prefs_format_multiline_indent,format_multiline_indent)
  SetGadgetState(#g_prefs_format_procedure,format_procedure)
  SetGadgetState(#g_prefs_format_procedure_space,format_procedure_space)
  ;
  ; command
  ;
  SetGadgetState(#g_prefs_log_maintain,log_maintain)
  SetGadgetState(#g_prefs_log_showonerror,log_showonerror)
  SetGadgetState(#g_prefs_log_showoncmd,log_showoncmd)
  ;
  ; keywords
  ;
  SetGadgetText(#g_prefs_keywords_up,x_stringtostring(keywords_up,8))
  SetGadgetText(#g_prefs_keywords_down,x_stringtostring(keywords_down,8))
  SetGadgetText(#g_prefs_keywords_doubleup,x_stringtostring(keywords_doubleup,8))
  SetGadgetText(#g_prefs_keywords_doubledown,x_stringtostring(keywords_doubledown,8))
  ;
  ; search
  ;
  SetGadgetState(#g_prefs_search_firstnr,search_firstnr)
  SetGadgetState(#g_prefs_search_extra,search_extra)
  SetGadgetText(#g_prefs_search_basic,x_stringtostring(search_basic,9))
  SetGadgetText(#g_prefs_search_extended,x_stringtostring(search_extended,9))
  ;
  ; web
  ;
  SetGadgetText(#g_prefs_web_browser,web_browser)
  SetGadgetText(#g_prefs_web_empty,x_stringtostring(web_empty,9))
  SetGadgetText(#g_prefs_web_underscore,x_stringtostring(web_underscore,9))
  SetGadgetText(#g_prefs_web_other,x_stringtostring(web_other,9))
  ;
EndProcedure

Procedure prefs_set()                                      ; use settings from preferences window
  ;
  ; user interface
  ;
  show_menu = GetGadgetState(#g_prefs_show_menu)
  show_toolbar = GetGadgetState(#g_prefs_show_toolbar)
  show_buttons = GetGadgetState(#g_prefs_show_buttons)
  show_statusbar = GetGadgetState(#g_prefs_show_statusbar)
  show_keepontop = GetGadgetState(#g_prefs_show_keepontop)
  show_darkercolors = GetGadgetState(#g_prefs_show_darkercolors)
  show_nearbydialogs = GetGadgetState(#g_prefs_show_nearbydialogs)
  show_unzoom = GetGadgetState(#g_prefs_show_unzoom)
  ;
  spacing_frame = GetGadgetState(#g_prefs_spacing_frame)
  spacing_buttons = GetGadgetState(#g_prefs_spacing_buttons)
  ;
  font_name = prefs_font_name
  font_size = prefs_font_size
  ;
  config_saveonexit = GetGadgetState(#g_prefs_config_saveonexit)
  ;
  ; backup
  ;
  save_length = x_limit(GetGadgetState(#g_prefs_save_length),3,6)
  save_max = x_limit(GetGadgetState(#g_prefs_save_max),10,1000)
  save_excludebuilds = GetGadgetState(#g_prefs_save_excludebuilds)
  save_excludesnapshots = GetGadgetState(#g_prefs_save_excludesnapshots)
  save_baktobackup = GetGadgetState(#g_prefs_save_baktobackup)
  save_cdytobackup = GetGadgetState(#g_prefs_save_cdytobackup)
  compilerun_autosaveinterval = x_limit(GetGadgetState(#g_prefs_compilerun_autosaveinterval),0,1000)
  compilerun_savefrequency = x_limit(GetGadgetState(#g_prefs_compilerun_savefrequency),1,50)
  ;
  ; pre-processing
  ;
  prep_savebackup = GetGadgetState(#g_prefs_prep_savebackup)
  prep_addconstants = GetGadgetState(#g_prefs_prep_addconstants)
  prep_multiline = GetGadgetState(#g_prefs_prep_multiline)
  prep_keepsync = GetGadgetState(#g_prefs_prep_keepsync)
  prep_thinbuilds = GetGadgetState(#g_prefs_prep_thinbuilds)
  prep_thindeep = GetGadgetState(#g_prefs_prep_thindeep)
  ;
  ; codesync
  ;
  codesync_folder1 = GetGadgetText(#g_prefs_codesync_folder1)
  codesync_folder2 = GetGadgetText(#g_prefs_codesync_folder2)
  codesync_filter = x_stringtostring(GetGadgetText(#g_prefs_codesync_filter),4)
  codesync_baklimit = GetGadgetState(#g_prefs_codesync_baklimit)
  codesync_confirmation = GetGadgetState(#g_prefs_codesync_confirmation)
  ;
  ; format
  ;
  Format_smart = GetGadgetState(#g_prefs_format_smart)
  format_multiline = GetGadgetState(#g_prefs_format_multiline)
  format_multiline_indent = GetGadgetState(#g_prefs_format_multiline_indent)
  format_procedure = GetGadgetState(#g_prefs_format_procedure)
  format_procedure_space = GetGadgetState(#g_prefs_format_procedure_space)
  format_indent = GetGadgetState(#g_prefs_format_indent)
  ;
  ; command
  ;
  log_maintain = GetGadgetState(#g_prefs_log_maintain)
  log_showonerror = GetGadgetState(#g_prefs_log_showonerror)
  log_showoncmd = GetGadgetState(#g_prefs_log_showoncmd)
  ;
  ; keywords
  ;
  keywords_up = x_stringtostring(GetGadgetText(#g_prefs_keywords_up),4)
  keywords_down = x_stringtostring(GetGadgetText(#g_prefs_keywords_down),4)
  keywords_doubleup = x_stringtostring(GetGadgetText(#g_prefs_keywords_doubleup),4)
  keywords_doubledown = x_stringtostring(GetGadgetText(#g_prefs_keywords_doubledown),4)
  ;
  ; search
  ;
  search_firstnr = GetGadgetState(#g_prefs_search_firstnr)
  search_extra = GetGadgetState(#g_prefs_search_extra)
  search_basic = x_stringtostring(GetGadgetText(#g_prefs_search_basic),7)
  search_extended = x_stringtostring(GetGadgetText(#g_prefs_search_extended),7)
  ;
  ; web
  ;
  web_browser = GetGadgetText(#g_prefs_web_browser)
  web_empty = x_stringtostring(GetGadgetText(#g_prefs_web_empty),7)
  web_underscore = x_stringtostring(GetGadgetText(#g_prefs_web_underscore),7)
  web_other = x_stringtostring(GetGadgetText(#g_prefs_web_other),7)
  ;
EndProcedure

Procedure clear_listarray()                                ; wipe list array (top panel)
  Protected n.i
  ;
  ; *** wipe list array and set colours to black on white
  ;
  ; this defines the contents of the bottom panel
  ;
  Global Dim List.entry(#list_max)
  ;
  ; changed in 0.75x: if both colors are set to black (0) then black on white will be used
  ;
  ; For n = 0 To #list_max
  ; list(n)\foreground = col_black
  ; list(n)\background = col_white
  ; Next
  ;
  list_n = 0
EndProcedure

Procedure clear_codearray()                                ; wipe code array (bottom panel)
  Protected n.i
  ;
  ; *** wipe code array and set colours to black on white
  ;
  ; this defines the contents of the bottom panel
  ;
  Global Dim code.entry(#list_max)
  ;
  ; changed in 0.75x: if both colors were set to black (0) then black on white will be used
  ;
  ; For n = 0 To #list_max
  ; code(n)\foreground = col_black
  ; code(n)\background = col_white
  ; Next
  code_n = 0
EndProcedure

Procedure clear_allarrays()                                ; wipe all code, list and hit arrays
  ;
  ; *** wipe all code, list and reset hit array counters
  ;
  clear_listarray()
  clear_codearray()
  hit_n = 0
  hit_structure_n = 0
  hit_constant_n = 0
  hit_procedure_n = 0
  hit_variable_n = 0
EndProcedure

Procedure.i callback_handler(windowid.i,message.i,wparam.i,lparam.i)    ; handle all callbacks
  Protected *size.minmaxinfo
  Protected *nmhdr.NMHDR
  Protected *nmlvcustomdraw.NMLVCUSTOMDRAW
  Protected gadget_h.i, item_nr.i
  ;
  ; *** handle all callbacks here
  ;
  Select message
      Case #WM_SIZE
        ;
        draw()
        ;
      Case #WM_GETMINMAXINFO                            ; a min/max window size message
        ;
        Select windowid                                 ; the window for which the message arrived
            Case w_main_h                                   ; if it was for the main window
              ;
              ; limit sizes of main window
              ;
              *size.minmaxinfo = lparam                     ; fill in the structure that has to be returned
              *size\ptmintracksize\x = 100                  ; minimal width
              *size\ptminTracksize\y = 140                  ; minimal height
              *size\ptmaxTracksize\x = x_desktops_width      ; maximal width
              *size\ptmaxTracksize\y = x_desktops_height     ; maximal height
            Default
        EndSelect
        ;
      Case #WM_NOTIFY
        ;
        *nmlvcustomdraw = lparam                              ; use to do custom drawing
        *nmhdr.NMHDR = lparam                                 ; use to grab tab key
        gadget_h = *nmhdr\hwndFrom                            ; handle of gadget that caused event
        ;
        If show_prefs = #True                                 ; only process these gadgets if prefs window is open
          If GetAsyncKeyState_(#VK_TAB) = 32768               ; this is all about processing tab keys
            Select gadget_h
                Case GadgetID(#g_prefs_keywords_up)
                  SetActiveGadget(#g_prefs_keywords_down)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_keywords_down)
                  SetActiveGadget(#g_prefs_keywords_doubleup)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_keywords_doubleup)
                  SetActiveGadget(#g_prefs_keywords_doubledown)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_keywords_doubledown)
                  SetActiveGadget(#g_prefs_reset)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_search_basic)
                  SetActiveGadget(#g_prefs_search_basic_file)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_search_extended)
                  SetActiveGadget(#g_prefs_search_extended_file)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_web_browser)
                  SetActiveGadget(#g_prefs_web_empty)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_web_empty)
                  SetActiveGadget(#g_prefs_web_underscore)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_web_underscore)
                  SetActiveGadget(#g_prefs_web_other)
                  ProcedureReturn 1
                Case GadgetID(#g_prefs_web_other)
                  SetActiveGadget(#g_prefs_reset)
                  ProcedureReturn 1
                Default
            EndSelect
          EndIf
        EndIf
        ;
        ; change row colour or font of listicongadget
        ; some of this code may not make much sense anymore when v4 hits the scene
        ;
        Select *nmlvcustomdraw\nmcd\hdr\code
            Case #NM_CUSTOMDRAW
              Select *nmlvcustomdraw\nmcd\dwDrawStage
                  Case #CDDS_PREPAINT
                    ProcedureReturn #CDRF_NOTIFYITEMDRAW
                  Case #CDDS_ITEM | #CDDS_PREPAINT
                    item_nr = *nmlvcustomdraw\nmcd\dwitemspec
                    If gadget_h = g_selected_h
                      If List(item_nr)\foreground = 0 And List(item_nr)\background = 0
                        List(item_nr)\background = col_white
                      EndIf
                      If GetGadgetItemState(#g_listpanel,item_nr)
                        *nmlvcustomdraw\clrText = 16777215-List(item_nr)\foreground
                        *nmlvcustomdraw\clrTextBk = 16777215-List(item_nr)\background
                      Else
                        *nmlvcustomdraw\clrText = List(item_nr)\foreground
                        *nmlvcustomdraw\clrTextBk = List(item_nr)\background
                      EndIf
                      If List(item_nr)\style = #font_bold
                        SelectObject_(*nmlvcustomdraw\nmcd\hDC,font_bold_h)
                      Else
                        SelectObject_(*nmlvcustomdraw\nmcd\hDC,font_normal_h)
                      EndIf
                      ProcedureReturn #CDRF_NEWFONT
                    ElseIf gadget_h = g_codepanel_h
                      If code(item_nr)\foreground = 0 And code(item_nr)\background = 0
                        code(item_nr)\background = col_white
                      EndIf
                      If GetGadgetItemState(#g_codepanel,item_nr)                        ; if it was selected
                        *nmlvcustomdraw\clrText = 16777215-code(item_nr)\foreground
                        *nmlvcustomdraw\clrTextBk = 16777215-code(item_nr)\background
                      Else                                                               ; if it was not selected
                        *nmlvcustomdraw\clrText = code(item_nr)\foreground
                        *nmlvcustomdraw\clrTextBk = code(item_nr)\background
                      EndIf
                      If code(item_nr)\style = #font_bold
                        SelectObject_(*nmlvcustomdraw\nmcd\hDC,font_bold_h)
                      Else
                        SelectObject_(*nmlvcustomdraw\nmcd\hDC,font_normal_h)
                      EndIf
                      ProcedureReturn #CDRF_NEWFONT
                    EndIf
              EndSelect
        EndSelect
  EndSelect
  ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

Procedure reflect_settings()                               ; update menus and buttons
  ;
  ; only update buttons if they are used
  ;
  If show_buttons = #True
    ;
    x_button_setstate(g_filter_wildcards_h,search_wildcards)
    ; x_button_setstate(g_filter_widen_h,search_widen)
    ; x_button_setstate(g_filter_narrow_h,search_narrow)
    ;
    x_button_setstate(g_filter_categorized_h,0)
    x_button_setstate(g_filter_procedure_h,0)
    x_button_setstate(g_filter_structure_h,0)
    x_button_setstate(g_filter_constant_h,0)
    x_button_setstate(g_filter_variable_h,0)
    x_button_setstate(g_filter_all_h,0)
    ;
    Select filter_type
        Case #f_filter_categorized
          x_button_setstate(g_filter_categorized_h,1)
        Case #f_filter_procedure
          x_button_setstate(g_filter_procedure_h,1)
        Case #f_filter_structure
          x_button_setstate(g_filter_structure_h,1)
        Case #f_filter_constant
          x_button_setstate(g_filter_constant_h,1)
        Case #f_filter_variable
          x_button_setstate(g_filter_variable_h,1)
        Case #f_filter_all
          x_button_setstate(g_filter_all_h,1)
    EndSelect
    ;
    x_button_setstate(g_splitter_zoom_h,splitter_max)
    x_button_setstate(g_search_extra_h,search_extra)
    x_button_setstate(g_show_keepontop_h,show_keepontop)
    ;
    If search_status = #status_paused
      x_button_setstate(g_search_pause_h,1)
    Else
      x_button_setstate(g_search_pause_h,0)
    EndIf
    ;
    x_button_setstate(g_search_toggle_h,search_wildcards)
    ;
  EndIf
  ;
  ; update toolbars when in use
  ;
  If show_toolbar = #True
    ;
    If search_status = #status_paused
      SetToolBarButtonState(#tb_main_nr,#f_search_pause,1)
    Else
      SetToolBarButtonState(#tb_main_nr,#f_search_pause,0)
    EndIf
    SetToolBarButtonState(#tb_main_nr,#f_search_toggle,search_wildcards)
    ;
    SetToolBarButtonState(#tb_main_nr,#f_filter_categorized,0)
    SetToolBarButtonState(#tb_main_nr,#f_filter_procedure,0)
    SetToolBarButtonState(#tb_main_nr,#f_filter_structure,0)
    SetToolBarButtonState(#tb_main_nr,#f_filter_constant,0)
    SetToolBarButtonState(#tb_main_nr,#f_filter_variable,0)
    SetToolBarButtonState(#tb_main_nr,#f_filter_all,0)
    SetToolBarButtonState(#tb_main_nr,#f_help,0)
    ;
    Select filter_type
        Case #f_filter_categorized
          SetToolBarButtonState(#tb_main_nr,#f_filter_categorized,1)
        Case #f_filter_procedure
          SetToolBarButtonState(#tb_main_nr,#f_filter_procedure,1)
        Case #f_filter_structure
          SetToolBarButtonState(#tb_main_nr,#f_filter_structure,1)
        Case #f_filter_constant
          SetToolBarButtonState(#tb_main_nr,#f_filter_constant,1)
        Case #f_filter_variable
          SetToolBarButtonState(#tb_main_nr,#f_filter_variable,1)
        Case #f_filter_all
          SetToolBarButtonState(#tb_main_nr,#f_filter_all,1)
    EndSelect
    ;
    SetToolBarButtonState(#tb_main_nr,#f_splitter_zoom,splitter_max)
    SetToolBarButtonState(#tb_main_nr,#f_search_extra,search_extra)
    SetToolBarButtonState(#tb_main_nr,#f_show_keepontop,show_keepontop)
    ;
    ; don't remember why i commented this part out?
    ;
    ;   If filter_type = #f_filter_categorized
    ;     x_toolbar_enablebutton(tb_main_h,#f_search_min)
    ;     x_toolbar_enablebutton(tb_main_h,#f_search_plus)
    ;   Else
    ;     x_toolbar_disablebutton(tb_main_h,#f_search_min)
    ;     x_toolbar_disablebutton(tb_main_h,#f_search_plus)
    ;   EndIf
    ;
  EndIf
  ;
  ; update menu when in use
  ;
  If show_menu = #True
    ;
    If search_status = #status_paused
      SetMenuItemState(#m_main_nr,#f_search_pause,1)
    Else
      SetMenuItemState(#m_main_nr,#f_search_pause,0)
    EndIf
    ;
    SetMenuItemState(#m_main_nr,#f_search_toggle,search_wildcards)
    SetMenuItemState(#m_main_nr,#f_search_widen,search_widen)
    SetMenuItemState(#m_main_nr,#f_search_narrow,search_narrow)
    SetMenuItemState(#m_main_nr,#f_search_included,search_included)
    SetMenuItemState(#m_main_nr,#f_search_beginwith,search_beginwith)
    DisableMenuItem(#m_main_nr,#f_search_beginwith,search_wildcards)
    DisableMenuItem(#m_main_nr,#f_search_widen,x_not(search_wildcards))
    DisableMenuItem(#m_main_nr,#f_search_narrow,x_not(search_wildcards))
    ;
    SetMenuItemState(#m_main_nr,#f_search_extra,search_extra)
    ;
    SetMenuItemState(#m_main_nr,#f_filter_categorized,0)
    SetMenuItemState(#m_main_nr,#f_filter_procedure,0)
    SetMenuItemState(#m_main_nr,#f_filter_structure,0)
    SetMenuItemState(#m_main_nr,#f_filter_constant,0)
    SetMenuItemState(#m_main_nr,#f_filter_variable,0)
    SetMenuItemState(#m_main_nr,#f_filter_all,0)
    ;
    Select filter_type
        Case #f_filter_categorized
          SetMenuItemState(#m_main_nr,#f_filter_categorized,1)
        Case #f_filter_procedure
          SetMenuItemState(#m_main_nr,#f_filter_procedure,1)
        Case #f_filter_structure
          SetMenuItemState(#m_main_nr,#f_filter_structure,1)
        Case #f_filter_constant
          SetMenuItemState(#m_main_nr,#f_filter_constant,1)
        Case #f_filter_variable
          SetMenuItemState(#m_main_nr,#f_filter_variable,1)
        Case #f_filter_all
          SetMenuItemState(#m_main_nr,#f_filter_all,1)
    EndSelect
    ;
    SetMenuItemState(#m_main_nr,#f_splitter_zoom,splitter_max)
    ;
    SetMenuItemState(#m_main_nr,#f_show_menu,show_menu)
    SetMenuItemState(#m_main_nr,#f_show_buttons,show_buttons)
    SetMenuItemState(#m_main_nr,#f_show_toolbar,show_toolbar)
    SetMenuItemState(#m_main_nr,#f_show_statusbar,show_statusbar)
    SetMenuItemState(#m_main_nr,#f_show_keepontop,show_keepontop)
    SetMenuItemState(#m_main_nr,#f_show_darkercolors,show_darkercolors)
    ;
    SetMenuItemState(#m_main_nr,#f_prep_savebackup,prep_savebackup)
    SetMenuItemState(#m_main_nr,#f_prep_addconstants,prep_addconstants)
    SetMenuItemState(#m_main_nr,#f_prep_thinbuilds,prep_thinbuilds)
    SetMenuItemState(#m_main_nr,#f_prep_multiline,prep_multiline)
    SetMenuItemState(#m_main_nr,#f_log_maintain,log_maintain)
    SetMenuItemState(#m_main_nr,#f_log_showonerror,log_showonerror)
    SetMenuItemState(#m_main_nr,#f_log_showoncmd,log_showoncmd)
    ;
    SetMenuItemState(#m_main_nr,#f_config_saveonexit,config_saveonexit)
    ;
    ; avoid a lockout
    ;
    If show_buttons = #False And show_toolbar = #False
      DisableMenuItem(#m_main_nr,#f_show_menu,1)
    Else
      DisableMenuItem(#m_main_nr,#f_show_menu,0)
    EndIf
  EndIf
  ;
  ; update statusbar when in use
  ;
  If IsStatusBar(#sb_main_nr)
    Select search_status
        Case #status_ready
          StatusBarImage(#sb_main_nr,0,i_led_green_h)
          StatusBarText(#sb_main_nr,1," ready")
        Case #status_searching
          StatusBarImage(#sb_main_nr,0,i_led_darkgreen_h)
          StatusBarText(#sb_main_nr,1," searching")
        Case #status_paused
          StatusBarImage(#sb_main_nr,0,i_led_yellow_h)
          StatusBarText(#sb_main_nr,1," on hold")
        Case #status_error
          StatusBarImage(#sb_main_nr,0,i_led_red_h)
    EndSelect
    StatusBarText(#sb_main_nr,2," "+search_string)
  EndIf
  ;
EndProcedure

Procedure update_listpanel(forceupdate.i)                  ; update listpanel and associated arrays
  Protected p.i, nnn.i, nn.i, n.i
  Protected p_all.i, p_constant.i, p_variable.i, p_procedure.i, p_structure.i
  Protected list_x.i
  ;
  ; wildcard mode should always bring up 'all' list - took the following out in 4984, catagorization seems to work somewhat
  ; even with wildcards...
  ;
  ;   If search_wildcards = #True And filter_type <> #f_filter_all
  ;     filter_type = #f_filter_all
  ;     reflect_settings()
  ;   EndIf
  ;
  ; note: any change in settings (prefs) or filter causes a redraw
  ;
  If old_filter_type <> filter_type
    _ Or old_search_firstnr <> search_firstnr
    _ Or old_search_extra <> search_extra
    _ Or hit_n < old_n
    old_filter_type = filter_type
    old_search_firstnr = search_firstnr
    old_search_extra = search_extra
    old_n = 0
    old_structure_n = 0
    old_procedure_n = 0
    old_variable_n = 0
    old_constant_n = 0
    old_files_p = 0
    ClearGadgetItems(#g_listpanel)
    clear_listarray()
  EndIf
  ;
  ; what is displayed depends on filter mode
  ;
  ;
  Select filter_type
      Case #f_filter_all
        ;
        ; any entry
        ;
        ; this one is colour coded, though there's no 100% detection
        ; as usual the added fluff is a bit of a hack :-/
        ;
        If list_n = 0 And search_extra And hit_n > 0
          AddGadgetItem(#g_listpanel,-1,"")
          List(0)\style = #font_bold
          list_n = 1
          SetGadgetItemText(#g_listpanel,0,"All ("+Str(hit_n)+")",0)
        EndIf
        While list_n < #list_max And old_n < hit_n
          old_n = old_n+1
          If search_extra And hit(old_n)\file <> hit(old_n-1)\file
            AddGadgetItem(#g_listpanel,-1,"")
            List(list_n)\background = col_white
            List(list_n)\file = ""
            list_n = list_n+1
            AddGadgetItem(#g_listpanel,-1,hit(old_n)\file)
            List(list_n)\background = col_white
            List(list_n)\style = #font_bold
            List(list_n)\file = hit(old_n)\file
            List(list_n)\line = hit(old_n)\line
            List(list_n)\type = hit(old_n)\type
            List(list_n)\seek_pos = hit(old_n)\seek_pos
            List(list_n)\seek_line = hit(old_n)\seek_line
            list_n = list_n+1
            AddGadgetItem(#g_listpanel,-1,"")
            List(list_n)\background = col_white
            List(list_n)\style = #font_bold
            List(list_n)\file = hit(old_n)\file
            List(list_n)\line = hit(old_n)\line
            List(list_n)\type = hit(old_n)\type
            List(list_n)\seek_pos = hit(old_n)\seek_pos
            List(list_n)\seek_line = hit(old_n)\seek_line
            list_n = list_n+1
          EndIf
          List(list_n)\file = hit(old_n)\file
          List(list_n)\line = hit(old_n)\line
          List(list_n)\type = hit(old_n)\type
          List(list_n)\seek_pos = hit(old_n)\seek_pos
          List(list_n)\seek_line = hit(old_n)\seek_line
          Select hit(old_n)\type
              Case #f_filter_procedure
                List(list_n)\background = col_pink
              Case #f_filter_structure
                List(list_n)\background = col_yellow
              Case #f_filter_constant
                List(list_n)\background = col_blue
              Case #f_filter_variable
                List(list_n)\background = col_green
              Case #f_filter_all
                List(list_n)\background = col_white
          EndSelect
          list_n = list_n+1
          AddGadgetItem(#g_listpanel,-1,hit(old_n)\String)
        Wend
        ;
      Case #f_filter_procedure
        ;
        ; procedures
        ;
        If list_n = 0 And search_extra And hit_procedure_n > 0
          AddGadgetItem(#g_listpanel,-1,"")
          AddGadgetItem(#g_listpanel,-1,"")
          List(0)\style = #font_bold
          list_n = 2
          SetGadgetItemText(#g_listpanel,0,"Procedures ("+Str(hit_procedure_n)+")",0)
        EndIf
        While list_n < #list_max And old_n < hit_n
          old_n = old_n+1
          If hit(old_n)\type = #f_filter_procedure
            List(list_n)\file = hit(old_n)\file
            List(list_n)\line = hit(old_n)\line
            List(list_n)\type = hit(old_n)\type
            List(list_n)\seek_pos = hit(old_n)\seek_pos
            List(list_n)\seek_line = hit(old_n)\seek_line
            List(list_n)\background = col_pink
            list_n = list_n+1
            AddGadgetItem(#g_listpanel,-1,hit(old_n)\String)
          EndIf
        Wend
        ;
      Case #f_filter_structure
        ;
        ; structures
        ;
        If list_n = 0 And search_extra And hit_structure_n > 0
          AddGadgetItem(#g_listpanel,-1,"")
          AddGadgetItem(#g_listpanel,-1,"")
          List(0)\style = #font_bold
          list_n = 2
          SetGadgetItemText(#g_listpanel,0,"Structures ("+Str(hit_structure_n)+")",0)
        EndIf
        While list_n < #list_max And old_n < hit_n
          old_n = old_n+1
          If hit(old_n)\type = #f_filter_structure
            List(list_n)\file = hit(old_n)\file
            List(list_n)\line = hit(old_n)\line
            List(list_n)\type = hit(old_n)\type
            List(list_n)\seek_pos = hit(old_n)\seek_pos
            List(list_n)\seek_line = hit(old_n)\seek_line
            List(list_n)\background = col_yellow
            list_n = list_n+1
            AddGadgetItem(#g_listpanel,-1,hit(old_n)\String)
          EndIf
        Wend
        ;
      Case #f_filter_constant
        ;
        ; constants
        ;
        If list_n = 0 And search_extra And hit_constant_n > 0
          AddGadgetItem(#g_listpanel,-1,"")
          AddGadgetItem(#g_listpanel,-1,"")
          List(0)\style = #font_bold
          list_n = 2
          SetGadgetItemText(#g_listpanel,0,"Constants ("+Str(hit_constant_n)+")",0)
        EndIf
        While list_n < #list_max And old_n < hit_n
          old_n = old_n+1
          If hit(old_n)\type = #f_filter_constant
            List(list_n)\file = hit(old_n)\file
            List(list_n)\line = hit(old_n)\line
            List(list_n)\type = hit(old_n)\type
            List(list_n)\seek_pos = hit(old_n)\seek_pos
            List(list_n)\seek_line = hit(old_n)\seek_line
            List(list_n)\background = col_blue
            list_n = list_n+1
            AddGadgetItem(#g_listpanel,-1,hit(old_n)\String)
          EndIf
        Wend
        ;
      Case #f_filter_variable
        ;
        ; variables
        ;
        If list_n = 0 And search_extra And hit_variable_n > 0
          AddGadgetItem(#g_listpanel,-1,"")
          AddGadgetItem(#g_listpanel,-1,"")
          List(0)\style = #font_bold
          list_n = 2
          SetGadgetItemText(#g_listpanel,0,"Variables ("+Str(hit_variable_n)+")",0)
        EndIf
        While list_n < #list_max And old_n < hit_n
          old_n = old_n+1
          If hit(old_n)\type = #f_filter_variable
            List(list_n)\file = hit(old_n)\file
            List(list_n)\line = hit(old_n)\line
            List(list_n)\type = hit(old_n)\type
            List(list_n)\seek_pos = hit(old_n)\seek_pos
            List(list_n)\seek_line = hit(old_n)\seek_line
            List(list_n)\background = col_green
            list_n = list_n+1
            AddGadgetItem(#g_listpanel,-1,hit(old_n)\String)
          EndIf
        Wend
        ;
      Case #f_filter_categorized
        ;
        ; first n picks of every category
        ;
        ; took me quite a rewrite to optimize this, but it's done! no more empty lines, no missed updates, only flashes every 300th hit
        ;
        If search_extra
          list_x = -1
          list_x = list_x + x_sgn(hit_procedure_n)*3
          list_x = list_x + x_sgn(hit_constant_n)*3
          list_x = list_x + x_sgn(hit_variable_n)*3
          list_x = list_x + x_sgn(hit_structure_n)*3
          list_x = list_x + 3
        Else
          list_x = 0
        EndIf
        list_x = list_x + x_min(search_firstnr,hit_procedure_n)
        list_x = list_x + x_min(search_firstnr,hit_constant_n)
        list_x = list_x + x_min(search_firstnr,hit_variable_n)
        list_x = list_x + x_min(search_firstnr,hit_structure_n)
        list_x = list_x + x_min(4*search_firstnr,hit_n)
        ;
        While list_n < list_x
          AddGadgetItem(#g_listpanel,-1,"")
          list_n = list_n+1
        Wend
        ;
        If ( hit_procedure_n > old_procedure_n And old_procedure_n < search_firstnr ) _
            Or ( hit_structure_n > old_structure_n And old_structure_n < search_firstnr ) _
            Or ( hit_constant_n > old_constant_n And old_constant_n < search_firstnr ) _
            Or ( hit_variable_n > old_variable_n And old_variable_n < search_firstnr ) _
            Or ( hit_n > old_n And hit_n <= list_n ) _
            Or ( hit_n > old_n+200 ) _
            Or ( old_search_status <> search_status ) _
            Or ( forceupdate <> 0 And files_n > 0 )
          ;
          p = 0
          If hit_procedure_n > 0
            If search_extra
              SetGadgetItemText(#g_listpanel,p,"Procedures ("+Str(x_min(search_firstnr,hit_procedure_n))+"/"+Str(hit_procedure_n)+")",0)
              List(p)\background = col_white
              List(p)\style = #font_bold
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
              SetGadgetItemText(#g_listpanel,p,"",0)
              List(p)\background = col_white
              List(p)\style = #font_normal
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
            EndIf
            nn = 0
            nnn = 0
            While nnn < hit_n And nn < search_firstnr
              nnn = nnn+1
              If hit(nnn)\type = #f_filter_procedure
                nn = nn+1
                SetGadgetItemText(#g_listpanel,p,hit(nnn)\string,0)
                List(p)\background = col_pink
                List(p)\style = #font_normal
                List(p)\type = #f_filter_procedure
                List(p)\file = hit(nnn)\file
                List(p)\line = hit(nnn)\line
                List(p)\seek_pos = hit(nnn)\seek_pos
                List(p)\seek_line = hit(nnn)\seek_line
                p = p+1
              EndIf
            Wend
          EndIf
          If hit_structure_n > 0
            If search_extra
              If p > 0
                SetGadgetItemText(#g_listpanel,p,"",0)
                List(p)\background = col_white
                List(p)\style = #font_normal
                List(p)\file = ""
                List(p)\type = 0
                p = p+1
              EndIf
              SetGadgetItemText(#g_listpanel,p,"Structures ("+Str(x_min(search_firstnr,hit_structure_n))+"/"+Str(hit_structure_n)+")",0)
              List(p)\background = col_white
              List(p)\style = #font_bold
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
              SetGadgetItemText(#g_listpanel,p,"",0)
              List(p)\background = col_white
              List(p)\style = #font_normal
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
            EndIf
            nn = 0
            nnn = 0
            While nnn < hit_n And nn < search_firstnr
              nnn = nnn+1
              If hit(nnn)\type = #f_filter_structure
                nn = nn+1
                SetGadgetItemText(#g_listpanel,p,hit(nnn)\string,0)
                List(p)\background = col_yellow
                List(p)\style = #font_normal
                List(p)\type = #f_filter_structure
                List(p)\file = hit(nnn)\file
                List(p)\line = hit(nnn)\line
                List(p)\seek_pos = hit(nnn)\seek_pos
                List(p)\seek_line = hit(nnn)\seek_line
                p = p+1
              EndIf
            Wend
          EndIf
          If hit_constant_n > 0
            If search_extra
              If p > 0
                SetGadgetItemText(#g_listpanel,p,"",0)
                List(p)\background = col_white
                List(p)\style = #font_normal
                List(p)\file = ""
                List(p)\type = 0
                p = p+1
              EndIf
              SetGadgetItemText(#g_listpanel,p,"Constants ("+Str(x_min(search_firstnr,hit_constant_n))+"/"+Str(hit_constant_n)+")",0)
              List(p)\background = col_white
              List(p)\style = #font_bold
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
              SetGadgetItemText(#g_listpanel,p,"",0)
              List(p)\background = col_white
              List(p)\style = #font_normal
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
            EndIf
            nn = 0
            nnn = 0
            While nnn < hit_n And nn < search_firstnr
              nnn = nnn+1
              If hit(nnn)\type = #f_filter_constant
                nn = nn+1
                SetGadgetItemText(#g_listpanel,p,hit(nnn)\string,0)
                List(p)\background = col_blue
                List(p)\style = #font_normal
                List(p)\type = #f_filter_constant
                List(p)\file = hit(nnn)\file
                List(p)\line = hit(nnn)\line
                List(p)\seek_pos = hit(nnn)\seek_pos
                List(p)\seek_line = hit(nnn)\seek_line
                p = p+1
              EndIf
            Wend
          EndIf
          If hit_variable_n > 0
            If search_extra
              If p > 0
                SetGadgetItemText(#g_listpanel,p,"",0)
                List(p)\background = col_white
                List(p)\style = #font_normal
                List(p)\file = ""
                List(p)\type = 0
                p = p+1
              EndIf
              SetGadgetItemText(#g_listpanel,p,"Variables ("+Str(x_min(search_firstnr,hit_variable_n))+"/"+Str(hit_variable_n)+")",0)
              List(p)\background = col_white
              List(p)\style = #font_bold
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
              SetGadgetItemText(#g_listpanel,p,"",0)
              List(p)\background = col_white
              List(p)\style = #font_normal
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
            EndIf
            nn = 0
            nnn = 0
            While nnn < hit_n And nn < search_firstnr
              nnn = nnn+1
              If hit(nnn)\type = #f_filter_variable
                nn = nn+1
                SetGadgetItemText(#g_listpanel,p,hit(nnn)\string,0)
                List(p)\background = col_green
                List(p)\style = #font_normal
                List(p)\type = #f_filter_variable
                List(p)\file = hit(nnn)\file
                List(p)\line = hit(nnn)\line
                List(p)\seek_pos = hit(nnn)\seek_pos
                List(p)\seek_line = hit(nnn)\seek_line
                p = p+1
              EndIf
            Wend
          EndIf
          ;
          If search_extra
            If p > 0
              SetGadgetItemText(#g_listpanel,p,"",0)
              List(p)\background = col_white
              List(p)\style = #font_normal
              List(p)\file = ""
              List(p)\type = 0
              p = p+1
            EndIf
            SetGadgetItemText(#g_listpanel,p,"All ("+Str(x_min(hit_n,list_n-p-2))+"/"+Str(hit_n)+")",0)
            List(p)\background = col_white
            List(p)\style = #font_bold
            List(p)\file = ""
            List(p)\type = 0
            p = p+1
            SetGadgetItemText(#g_listpanel,p,"",0)
            List(p)\background = col_white
            List(p)\style = #font_normal
            List(p)\file = ""
            List(p)\type = 0
            p = p+1
          EndIf
          
          nnn = 0
          While nnn < hit_n And p < list_n
            nnn = nnn+1
            SetGadgetItemText(#g_listpanel,p,hit(nnn)\string,0)
            List(p)\background = col_white
            List(p)\style = #font_normal
            List(p)\type = #f_filter_all
            List(p)\file = hit(nnn)\file
            List(p)\line = hit(nnn)\line
            List(p)\seek_pos = hit(nnn)\seek_pos
            List(p)\seek_line = hit(nnn)\seek_line
            p = p+1
          Wend
          ;
        EndIf
        ;
  EndSelect
  ;
  old_n = hit_n
  old_procedure_n = hit_procedure_n
  old_structure_n = hit_structure_n
  old_constant_n = hit_constant_n
  old_variable_n = hit_variable_n
  old_files_p = files_p
  old_search_status = search_status
  ;
EndProcedure

Procedure update_codepanel(nr.i)                           ; remember entry in codepanel, -1 to detect, >= 0 to select
  Protected n.i, l.i, p.i, f.s, x.s, seek.i, seek_line.i, line.i, c.i, q.i
  ;
  q = -1                                                    ; used to remember the entry in the codepanel that shows the hit
  ;
  If nr >= 0                                                ; specific entry to show
    nr = x_min(nr,list_n)                                   ; limit it to what's on screen
    list_selected = nr                                      ; store for eventual reuse
    SetGadgetState(#g_listpanel,nr)                         ; mark appropriate line in listpanel
    x_setlisticonvisibleline(#g_listpanel,nr)               ; make sure that line is visible
  Else
    nr = GetGadgetState(#g_listpanel)
  EndIf
  If nr = -1
    nr = 0
  EndIf
  list_selected = nr
  hit_file = List(nr)\file
  hit_line = List(nr)\line
  hit_type = List(nr)\type
  seek_pos = List(nr)\seek_pos
  seek_line = List(nr)\seek_line
  ;
  If hit_type = 0                                           ; no real entry on this line
    ;
    ; added in 1.12x, wipes the codepanel when the entry on the list panel contains 'extra' 'fluff'
    ; ie. a line with non-relevant information is shown
    ;
    clear_codearray()                                       ; clear array
    ClearGadgetItems(#g_codepanel)                          ; clear list
    ;
  Else                                                      ; entry on this line
    ;
    SendMessage_(g_codepanel_h,#WM_SETREDRAW,#False,0)      ; speed up by first disabling gadget redraws
    ;
    Select hit_type
        Case #f_filter_all
          c = col_grey
        Case #f_filter_constant
          c = col_blue
        Case #f_filter_procedure
          c = col_pink
        Case #f_filter_variable
          c = col_green
        Case #f_filter_structure
          c = col_yellow
    EndSelect
    ;
    clear_codearray()                                       ; clear array
    ClearGadgetItems(#g_codepanel)                       ; clear list
    ;
    p = 0
    If search_extra                                         ; add info if fluff was enabled
      AddGadgetItem(#g_codepanel,p,hit_file)
      code(p)\style = #font_bold
      p = p+1
      x = FormatDate("%dd/%mm/%yyyy %hh:%ii:%ss",GetFileDate(hit_file,#PB_Date_Modified))+" "+Str(FileSize(hit_file))+" bytes"
      AddGadgetItem(#g_codepanel,p,x)
      code(p)\style = #font_bold
      p = p+1
      AddGadgetItem(#g_codepanel,p,"")
      p = p+1
    EndIf
    ;
    If ReadFile(2,hit_file)
      If splitter_max
        ;
        ; zoom is active so load whole file
        ;
        l = 1
        While x_not(Eof(2))
          x = ReadString(2)
          AddGadgetItem(#g_codepanel,p,x)
          If l = hit_line
            code(p)\background = c
            q = p
          EndIf
          l = l+1
          p = p+1
        Wend
        ;
        SetGadgetItemText(#g_codepanel,-1,hit_file,0)                  ; update column title
        ;
      Else
        ;
        ; actual number of lines is depending on value of search_firstnr
        ; (this is for those users with limited screen real estate)
        ;
        If seek_pos > 0
          FileSeek(2,seek_pos)
          AddGadgetItem(#g_codepanel,p,"...")
          code(p)\type = 1
          p = p+1
        EndIf
        l = seek_line
        While x_not(Eof(2)) And l < hit_line-search_firstnr
          l = l+1
          x = ReadString(2)
        Wend
        While x_not(Eof(2)) And l < hit_line
          x = ReadString(2)
          If search_extra
            AddGadgetItem(#g_codepanel,p,x)
            p = p+1
          EndIf
          l = l+1
        Wend
        If x_not(Eof(2))
          x = ReadString(2)
          AddGadgetItem(#g_codepanel,p,x)
          code(p)\background = c
          q = p
          p = p+1
        EndIf
        While x_not(Eof(2)) And l < hit_line+5*search_firstnr
          x = ReadString(2)
          AddGadgetItem(#g_codepanel,p,x)
          p = p+1
          l = l+1
        Wend
        If Loc(2) < Lof(2)
          AddGadgetItem(#g_codepanel,p,"...")
          code(p)\type = 1
          p = p+1
        EndIf
        ;
        SetGadgetItemText(#g_codepanel,-1,"Code",0)              ; update column title
        ;
      EndIf
      ;
      CloseFile(2)
    EndIf
    ;
    x_setlisticontopline(#g_codepanel,x_max(0,q-5))
    x_setlisticonvisibleline(#g_codepanel,q)                         ; make sure line is visible
    SetGadgetState(#g_codepanel,q)                                   ; select that line
    SendMessage_(g_codepanel_h,#WM_SETREDRAW,#True,0)                ; switch gadget updates back on
    ;
  EndIf
  ;
EndProcedure

Procedure draw()                                           ; draw, redraw or resize all windows And gadgets
  Protected x.i, h.i, w.i, y.i, button_height.i, button_width.i
  Protected x0.i, x1.i, x2.i, x3.i, x4.i, x5.i, x6.i, x7.i, x8.i, x9.i, x10.i
  Protected x11.i, x12.i, x13.i, x14.i, x15.i, x16.i, x17.i
  Protected y1.i, y2.i, y3.i, h1.i, h2.i, t.i, width.i, height.i
  Static old_font_name.s, old_font_size.i
  ;
  ; *** avoid a lockout
  ;
  If show_buttons = #False And show_toolbar = #False
    show_menu = #True
  EndIf
  ;
  ; *** create or redraw main window
  ;
  ; all drawing and resizing is done in here
  ; to update the gadgets (show if they are toggled etc.) call reflect_settings()
  ;
  ; first define the looks
  ;
  button_height = 22
  button_width = 22
  ;
  If IsWindow(#w_main_nr)                      ; if there is a window
    ;
    ; restore and bring to the foreground if it was minimized before
    ;
    If IsIconic_(w_main_h)
      ShowWindow_(w_main_h,#SW_RESTORE)
      SetForegroundWindow_(w_main_h)
    EndIf
    ;
    ; a check could be added to only resize objects if appropriate dimension changed
    ;
    w_main_maximized = IsZoomed_(w_main_h)
    If w_main_maximized = #False
      w_main_x = WindowX(#w_main_nr)
      w_main_y = WindowY(#w_main_nr)
      w_main_width = WindowWidth(#w_main_nr)
      w_main_height = WindowHeight(#w_main_nr)
    EndIf
    ;
    ; make it topmost if needed
    ;
    If GetForegroundWindow_() <> w_main_h
      If show_keepontop
        SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
        SetForegroundWindow_(w_main_h)
      Else
        SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
        SetForegroundWindow_(w_main_h)
      EndIf
    EndIf
    ;
  Else                                         ; if there is no window yet
    ;
    w_main_h.i = OpenWindow(#w_main_nr,w_main_x,w_main_y,w_main_width,w_main_height,"CodeCaddy "+#codecaddy_version,#PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget)
    SmartWindowRefresh(#w_main_nr,#True)
    ;
    If w_main_maximized
      ShowWindow_(w_main_h,#SW_SHOWMAXIMIZED)
    EndIf
    ;
    draw()
    SetWindowCallback(@callback_handler())
    ;
    x_window_todesktop(#w_main_nr)             ; make sure it doesn't stay outside desktop boundaries
    ;
    ; make it topmost if needed
    ;
    If show_keepontop
      SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
      SetForegroundWindow_(w_main_h)
    Else
      SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
      SetForegroundWindow_(w_main_h)
    EndIf
    ;
    ; following line is supposed to make things smoother... (source el choni)
    ; looks like it delays redrawing gadgets until we've stopped resizing / moving the window
    ;
    ; SetWindowLong_(w_main_h, #GWL_STYLE, GetWindowLong_(w_main_h, #GWL_STYLE)|#WS_CLIPCHILDREN)
    ;
    ; keyboardshortcuts - file
    ;
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Escape,#f_file_exit)
    ;
    ; keyboardshortcuts - search
    ;
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F2,#f_search_window)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F|#PB_Shortcut_Control,#f_search_window)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F,#f_search_window)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F3,#f_search_next)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Control|#PB_Shortcut_Right,#f_search_next)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Shift|#PB_Shortcut_F3,#f_search_previous)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Control|#PB_Shortcut_Left,#f_search_previous)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F5,#f_splitter_zoom)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Z,#f_splitter_zoom)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Return,#f_splitter_zoom)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_I,#f_search_extra)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Add,#f_search_plus)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Subtract,#f_search_min)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Space,#f_search_pause)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_G,#f_filter_categorized)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_P,#f_filter_procedure)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_S,#f_filter_structure)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_C,#f_filter_constant)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_V,#f_filter_variable)
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_A,#f_filter_all)
    ;
    ; using F8 for testing purposes, comment out line below before building a new version
    ;
    ; AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F8,#f_tools_thinner)
    ;
    ; keyboardshortcuts - tools
    ;
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F9,#f_tools_codesync)
    ;
    ; keyboardshortcuts - options
    ;
    ; keyboardshortcuts - help
    ;
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F1,#f_quickhelp)
    ;
    ; keyboardshortcuts - other
    ;
    AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Control|#PB_Shortcut_C,#f_copy)
    ;
    ; normal and bold fonts
    ;
    font_normal_h = LoadFont(#font_normal,font_name,font_size,0)
    font_bold_h = LoadFont(#font_bold,font_name,font_size,#PB_Font_Bold)
    ;
  EndIf
  ;
  ; menu
  ;
  If show_menu = #False                        ; don't show a menu
    If IsMenu(#m_main_nr)                      ; so hide an existing one
      FreeMenu(#m_main_nr)
    EndIf
  ElseIf IsMenu(#m_main_nr)                    ; show a menu
  Else
    ;
    m_main_h.i = CreateMenu(#m_main_nr,w_main_h)
    ;
    MenuTitle("&Files")
    MenuItem(#f_file_exit,"E&xit")
    ;
    MenuTitle("&Search")
    MenuItem(#f_search_window,"&Find"+#TAB$+"F2")
    MenuItem(#f_search_pause,"Pause"+#TAB$+"Space")
    MenuBar()
    MenuItem(#f_search_previous,"Previous")
    MenuItem(#f_search_next,"&Next"+#TAB$+"F3")
    MenuItem(#f_splitter_zoom,"&Zoom"+#TAB$+"F5")
    MenuItem(#f_search_extra,"Info")
    MenuBar()
    MenuItem(#f_filter_categorized,"Cata&gorized")
    MenuItem(#f_filter_procedure,"&Procedures")
    MenuItem(#f_filter_structure,"&Structures")
    MenuItem(#f_filter_constant,"&Constants")
    MenuItem(#f_filter_variable,"&Variables")
    MenuItem(#f_filter_all,"&All")
    MenuBar()
    MenuItem(#f_search_included,"Process 'included'")
    MenuItem(#f_search_beginwith,"&Begin with")
    MenuItem(#f_search_toggle,"&Wildcards")
    MenuItem(#f_search_widen,"Widen search")
    MenuItem(#f_search_narrow,"Narrow search")
    MenuBar()
    MenuItem(#f_search_files,"E&xtensions and path")
    ;
    MenuTitle("&Tools")
    MenuItem(#f_tools_format,"Format")
    MenuItem(#f_tools_flatten,"Flatten")
    MenuItem(#f_tools_thinner,"Thinner")
    MenuBar()
    MenuItem(#f_tools_codesync,"Codesync"+#TAB$+"F9")
    MenuBar()
    MenuItem(#f_tools_installinpbide,"Install in IDE")
    ;
    MenuTitle("&Options")
    MenuItem(#f_show_menu,"Menu")
    MenuItem(#f_show_toolbar,"Toolbar")
    MenuItem(#f_show_buttons,"Buttons")
    DisableMenuItem(#m_main_nr,#f_show_buttons,#True)
    MenuItem(#f_show_statusbar,"Statusbar")
    MenuItem(#f_show_keepontop,"Keep on top")
    MenuBar()
    MenuItem(#f_prep_savebackup,"Create backups")
    MenuItem(#f_prep_addconstants,"Add constants")
    MenuItem(#f_prep_multiline,"Multiline")
    MenuItem(#f_prep_thinbuilds,"Thin builds")
    MenuItem(#f_log_maintain,"Use logfile")
    MenuItem(#f_log_showonerror,"Display errors")
    MenuItem(#f_show_darkercolors,"Darker colors")
    MenuBar()
    MenuItem(#f_config_saveonexit,"Save config on exit")
    MenuItem(#f_config_savenow,"Save config now")
    MenuBar()
    MenuItem(#f_open_prefs,"&Preferences")
    ;
    MenuTitle("&Help")
    ; MenuItem(#f_help,"&Help")
    MenuItem(#f_quickhelp,"&Quickhelp"+#TAB$+"F1")
    MenuItem(#f_license,"License")
    MenuItem(#f_display_logfile,"&Logfile")
    MenuItem(#f_display_info,"&Info")
    MenuItem(#f_flash,"&Flash")
    MenuBar()
    MenuItem(#f_about,"&About")
  EndIf
  ;
  ; toolbar
  ;
  If show_toolbar = #False
    If IsToolBar(#tb_main_nr)
      FreeToolBar(#tb_main_nr)
    EndIf
  ElseIf IsToolBar(#tb_main_nr)
  Else
    tb_main_h = CreateToolBar(#tb_main_nr,w_main_h)
    ;
    ToolBarImageButton(#f_search_window,i_play_h)
    ToolBarToolTip(#tb_main_nr,#f_search_window,"find")
    x_toolbar_togglebutton(#tb_main_nr,#f_search_pause,i_pause_h,0,"pause")
    x_toolbar_togglebutton(#tb_main_nr,#f_search_toggle,i_char_wildcards_black_h,0,"wildcards")
    ToolBarSeparator()
    ;
    x_toolbar_radiobutton(#tb_main_nr,#f_filter_categorized,i_bullets_numbers_h,0,"categorized")
    x_toolbar_radiobutton(#tb_main_nr,#f_filter_procedure,i_char_p_red_h,0,"procedures")
    x_toolbar_radiobutton(#tb_main_nr,#f_filter_structure,i_char_s_yellow_h,0,"structures")
    x_toolbar_radiobutton(#tb_main_nr,#f_filter_constant,i_char_hash_blue_h,0,"constants")
    x_toolbar_radiobutton(#tb_main_nr,#f_filter_variable,i_char_is_green_h,0,"variables")
    x_toolbar_radiobutton(#tb_main_nr,#f_filter_all,i_char_doubleperiod_black_h,0,"all")
    ToolBarSeparator()
    ;
    ToolBarImageButton(#f_search_previous,i_previous_h)
    ToolBarToolTip(#tb_main_nr,#f_search_previous,"previous")
    ToolBarImageButton(#f_search_next,i_next_h)
    ToolBarToolTip(#tb_main_nr,#f_search_next,"next")
    ToolBarImageButton(#f_splitter_zoom,i_splitter_zoom_h)
    ToolBarToolTip(#tb_main_nr,#f_splitter_zoom,"zoom")
    ToolBarImageButton(#f_search_extra,i_paragraph_info_h)
    ToolBarToolTip(#tb_main_nr,#f_search_extra,"info")
    ToolBarImageButton(#f_search_min,i_paragraph_min_h)
    ToolBarToolTip(#tb_main_nr,#f_search_min,"less results")
    ToolBarImageButton(#f_search_plus,i_paragraph_plus_h)
    ToolBarToolTip(#tb_main_nr,#f_search_plus,"more results")
    ToolBarSeparator()
    ;
    ToolBarImageButton(#f_copy,i_edit_copy_h)
    ToolBarToolTip(#tb_main_nr,#f_copy,"copy")
    ToolBarImageButton(#f_edit,i_purebasic_white_h)
    ToolBarToolTip(#tb_main_nr,#f_edit,"edit")
    ToolBarSeparator()
    ;
    ToolBarImageButton(#f_open_prefs,i_properties_h)
    ToolBarToolTip(#tb_main_nr,#f_open_prefs,"preferences")
    ToolBarImageButton(#f_file_exit,i_exit_h)
    ToolBarToolTip(#tb_main_nr,#f_file_exit,"exit")
    ToolBarImageButton(#f_quickhelp,i_help_h)
    ToolBarToolTip(#tb_main_nr,#f_quickhelp,"help")
    ToolBarSeparator()
    ;
    x_toolbar_togglebutton(#tb_main_nr,#f_show_keepontop,i_pin_h,0,"keep on top")
    ;
  EndIf
  ;
  ; statusbar
  ;
  If show_statusbar = #False
    If IsStatusBar(#sb_main_nr)
      FreeStatusBar(#sb_main_nr)
    EndIf
  ElseIf IsStatusBar(#sb_main_nr)
  Else
    sb_main_h.i = CreateStatusBar(#sb_main_nr,w_main_h)
    AddStatusBarField(20)
    AddStatusBarField(512)
    AddStatusBarField(8192)
  EndIf
  ;
  ; actual available space is depending on toolbars, menus etc.
  ;
  x = spacing_frame
  y = spacing_frame                                ; first element in left upper spot
  w = WindowWidth(#w_main_nr)-spacing_frame*2       ; available width
  h = WindowHeight(#w_main_nr)-spacing_frame*2      ; available height
  ;
  If show_buttons = #True
    h = h-spacing_frame*2-button_height
  EndIf
  If show_menu = #True                    ; compensate for a menu
    h = h-MenuHeight()
  EndIf
  If show_toolbar = #True                 ; compensate for a toolbar
    h = h-ToolBarHeight(#tb_main_nr)
    y = y+ToolBarHeight(#tb_main_nr)
  EndIf
  If show_statusbar = #True               ; compensate for a statusbar
    h = h-StatusBarHeight(#sb_main_nr)
  EndIf
  If splitter_max = #True
    h1 = h
    h2 = h-h1
  Else
    h1 = h*splitter_permileage/1000
    h2 = h-h1
  EndIf
  ;
  ; horizontal steps
  ;
  x0 = x                                  ; search_normal
  x1 = x0+button_width                    ; pause
  x2 = x1+button_width+spacing_buttons    ; categorized
  x3 = x3+button_width                    ; procedure
  x4 = x3+button_width                    ; structure
  x5 = x4+button_width                    ; constant
  x6 = x5+button_width                    ; variable
  x7 = x6+button_width                    ; any
  x8 = x7+button_width+spacing_buttons    ; previous
  x9 = x8+button_width                    ; next
  x10 = x9+button_width                   ; zoom
  x11 = x10+button_width+spacing_buttons  ; fluff
  x12 = x11+button_width+spacing_buttons  ; copy
  x13 = x12+button_width                  ; edit
  x14 = x13+button_width+spacing_buttons  ; preferences
  x15 = x14+button_width                  ; exit
  x16 = x15+button_width                  ; help
  x17 = x16+button_width+spacing_buttons  ; pin / keep on top
  ;
  ; vertical steps, there are two view panels and one row of buttons
  ; notice that some of this stuff made more sense in an earlier incarnation of this program
  ;
  y1 = y                                  ; first a view panel
  y2 = y1+h1+spacing_frame                ; then the next view panel if it exists
  y3 = y2+h2+spacing_frame/2+1            ; it does so buttons go down  little more
  ;
  If IsGadget(#g_splitter)
  Else
    ;
    ; create two listicongadgets with specified font
    ;
    g_codepanel_h = ListIconGadget(#g_codepanel,x,y1,w,h1,"Code",x_desktops_width,#PB_ListIcon_MultiSelect|#PB_ListIcon_AlwaysShowSelection|#PB_ListIcon_FullRowSelect)
    g_selected_h = ListIconGadget(#g_listpanel,x,y2,w,h2,"List",x_desktops_width,#PB_ListIcon_FullRowSelect)
    SetGadgetFont(#g_codepanel,font_normal_h)
    SetGadgetFont(#g_listpanel,font_normal_h)
    ;
    ; create and apply a splittergadget
    ;
    If splitter_swap = #False
      SplitterGadget(#g_splitter,x,y1,w,h,#g_listpanel,#g_codepanel)
    Else
      SplitterGadget(#g_splitter,x,y1,w,h,#g_codepanel,#g_listpanel)
    EndIf
  EndIf
  ;
  ; resize splitter gadget and reposition the splitter
  ;
  ResizeGadget(#g_splitter,x,y1,w,h)
  If splitter_max = #True
    If splitter_swap = #False
      SetGadgetState(#g_splitter,x_min(h,4))
    Else
      SetGadgetState(#g_splitter,x_max(0,h-4))
    EndIf
  Else
    splitter_permileage = x_max(splitter_permileage,100)
    SetGadgetState(#g_splitter,h*splitter_permileage/1000)
  EndIf
  ;
  ; hide / unhide / create / resize buttons
  ;
  If show_buttons = #False
    If IsGadget(#g_open_search)
      FreeGadget(#g_open_search)
      FreeGadget(#g_search_pause)
      FreeGadget(#g_filter_categorized)
      FreeGadget(#g_filter_procedure)
      FreeGadget(#g_filter_structure)
      FreeGadget(#g_filter_constant)
      FreeGadget(#g_filter_variable)
      FreeGadget(#g_filter_all)
      FreeGadget(#g_splitter_zoom)
      FreeGadget(#g_search_extra)
      FreeGadget(#g_previous)
      FreeGadget(#g_next)
      FreeGadget(#g_copy)
      FreeGadget(#g_edit)
      FreeGadget(#g_exit)
      FreeGadget(#g_open_prefs)
      FreeGadget(#g_help)
      FreeGadget(#g_show_keepontop)
    EndIf
  ElseIf IsGadget(#g_open_search)
    ResizeGadget(#g_open_search,x0,y3,-1,-1)
    ResizeGadget(#g_search_pause,x1,y3,-1,-1)
    ResizeGadget(#g_filter_categorized,x2,y3,-1,-1)
    ResizeGadget(#g_filter_procedure,x3,y3,-1,-1)
    ResizeGadget(#g_filter_structure,x4,y3,-1,-1)
    ResizeGadget(#g_filter_constant,x5,y3,-1,-1)
    ResizeGadget(#g_filter_variable,x6,y3,-1,-1)
    ResizeGadget(#g_filter_all,x7,y3,-1,-1)
    ResizeGadget(#g_previous,x8,y3,-1,-1)
    ResizeGadget(#g_next,x9,y3,-1,-1)
    ResizeGadget(#g_splitter_zoom,x10,y3,-1,-1)
    ResizeGadget(#g_search_extra,x11,y3,-1,-1)
    ResizeGadget(#g_copy,x12,y3,-1,-1)
    ResizeGadget(#g_edit,x13,y3,-1,-1)
    ResizeGadget(#g_open_prefs,x14,y3,-1,-1)
    ResizeGadget(#g_exit,x15,y3,-1,-1)
    ResizeGadget(#g_help,x16,y3,-1,-1)
    ResizeGadget(#g_show_keepontop,x17,y3,-1,-1)
  Else
    UseGadgetList(w_main_h)
    ;
    ButtonImageGadget(#g_open_search,x0,y3,button_width,button_height,i_play_h)
    GadgetToolTip(#g_open_search,"find")
    g_search_pause_h.i = x_button_imagetogglebutton(#g_search_pause,x1,y3,button_width,button_height,i_pause_h,0,"pause")
    ;
    g_filter_categorized_h = x_button_imagetogglebutton(#g_filter_categorized,x2,y3,button_width,button_height,i_bullets_numbers_h,0,"categorized")
    g_filter_procedure_h = x_button_imagetogglebutton(#g_filter_procedure,x3,y3,button_width,button_height,i_char_p_red_h,0,"procedures")
    g_filter_structure_h = x_button_imagetogglebutton(#g_filter_structure,x4,y3,button_width,button_height,i_char_s_yellow_h,0,"categorized")
    g_filter_constant_h = x_button_imagetogglebutton(#g_filter_constant,x5,y3,button_width,button_height,i_char_hash_blue_h,0,"constants")
    g_filter_variable_h = x_button_imagetogglebutton(#g_filter_variable,x6,y3,button_width,button_height,i_char_is_green_h,0,"varables")
    g_filter_all_h = x_button_imagetogglebutton(#g_filter_all,x7,y3,button_width,button_height,i_char_doubleperiod_black_h,0,"all")
    ;
    ButtonImageGadget(#g_previous,x8,y3,button_width,button_height,i_previous_h)
    GadgetToolTip(#g_previous,"previous")
    ButtonImageGadget(#g_next,x9,y3,button_width,button_height,i_next_h)
    GadgetToolTip(#g_next,"next")
    g_splitter_zoom_h = x_button_imagetogglebutton(#g_splitter_zoom,x10,y3,button_width,button_height,i_splitter_zoom_h,splitter_max,"zoom")
    ; g_search_extra_h = x_button_imagetogglebutton(#g_search_extra,x11,y3,button_width,button_height,i_search_extra_h,search_extra,"info")
    ;
    ;
    ButtonImageGadget(#g_copy,x11,y3,button_width,button_height,i_edit_copy_h)
    GadgetToolTip(#g_copy,"copy")
    ButtonImageGadget(#g_edit,x12,y3,button_width,button_height,i_purebasic_white_h)
    GadgetToolTip(#g_edit,"edit")
    ButtonImageGadget(#g_open_prefs,x13,y3,button_width,button_height,i_properties_h)
    GadgetToolTip(#g_open_prefs,"preferences")
    ButtonImageGadget(#g_exit,x14,y3,button_width,button_height,i_exit_h)
    GadgetToolTip(#g_exit,"exit")
    ButtonImageGadget(#g_help,x15,y3,button_width,button_height,i_help_h)
    GadgetToolTip(#g_help,"help")
    ;
    g_show_keepontop_h = x_button_imagetogglebutton(#g_show_keepontop,x16,y3,button_width,button_height,i_pin_h,show_keepontop,"keep on top")
  EndIf
  ;
  If old_font_name <> font_name Or old_font_size <> font_size
    ;
    font_normal_h = LoadFont(#font_normal,font_name,font_size,0)
    font_bold_h = LoadFont(#font_bold,font_name,font_size,#PB_Font_Bold)
    ;
    t = x_getlisticontopline(#g_codepanel)
    SetGadgetFont(#g_codepanel,font_normal_h)
    x_setlisticontopline(#g_codepanel,t)
    ;
    t = x_getlisticontopline(#g_listpanel)
    SetGadgetFont(#g_listpanel,font_normal_h)
    x_setlisticontopline(#g_listpanel,t)
    ;
    old_font_name = font_name
    old_font_size = font_size
  EndIf
  ;
  ;
  ; *** prefs window ***
  ;
  ;
  If IsWindow(#w_prefs_nr)
    If show_prefs = #False                   ; window but not wanted, close it
      CloseWindow(#w_prefs_nr)
    EndIf
  Else
    If show_prefs = #False                   ; no window and not wanted, don't do anything
    Else                                     ; no window but requested, open and draw
      ;
      ; window did not exist yet, open it and create all
      ;
      width = 418
      height = 480
      If show_nearbydialogs
        x = WindowX(#w_main_nr)+40
        y = WindowY(#w_main_nr)+40
        w_prefs_h = OpenWindow(#w_prefs_nr,x,y,width,height,"CodeCaddy - Preferences",#PB_Window_SystemMenu,w_main_h)
      Else
        w_prefs_h = OpenWindow(#w_prefs_nr,x,y,width,height,"CodeCaddy - Preferences",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,w_main_h)
        ;
        ; save 6107 rewrite to 4.x: i don't think i'm actually using these two anymore?
        ;
        ; x = WindowX()
        ; y = WindowY()
        ;
      EndIf
      x_window_todesktop(#w_prefs_nr,-1,20)
      ;
      ; add keyboard shortcuts
      ;
      AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_Escape,#g_prefs_cancel)
      ;
      ; next line messes up with my editor gadgets in prefs...
      ; so unfortunately this specific shortcut and default button have to go :-(
      ;
      ; AddKeyboardShortcut(#w_prefs_nr,#PB_Shortcut_Return,#f_prefs_ok)
      ;
      PanelGadget(#g_prefs_panel,8,8,width-16,height-44)
        ;
        ;
        ; user interface
        ;
        AddGadgetItem(#g_prefs_panel,-1,"User Interface")
        x = 16
        y = 12
        w = width-48
        h = 3*24+30
        FrameGadget(#g_prefs_controls_f,x,y,w,h,"Controls")
        x = x+16
        y = y+24
        w = w-32
        CheckBoxGadget(#g_prefs_show_menu,x,y,w/2,16,"Menu")
        CheckBoxGadget(#g_prefs_show_statusbar,x+w/2,y,w/2,16,"Statusbar")
        y = y+24
        CheckBoxGadget(#g_prefs_show_toolbar,x,y,w/2,16,"Toolbar")
        CheckBoxGadget(#g_prefs_show_keepontop,x+w/2,y,w/2,16,"Keep on top")
        y = y+24
        CheckBoxGadget(#g_prefs_show_buttons,x,y,w/2,16,"Buttons")
        DisableGadget(#g_prefs_show_buttons,#True)
        CheckBoxGadget(#g_prefs_show_nearbydialogs,x+w/2,y,w/2,16,"Nearby dialogs")
        ;
        x = 16
        y = y+40
        w = width-48
        h = 3*24+30+12
        FrameGadget(#g_prefs_appearance_f,x,y,w,h,"Appearance")
        x = x+16
        y = y+24
        w = w-32
        SpinGadget(#g_prefs_spacing_frame,x,y,32,16,0,20,#PB_Spin_Numeric)
        TextGadget(#g_prefs_spacing_frame_t,x+40,y,w-40,16,"Space around controls")
        y = y+24
        SpinGadget(#g_prefs_spacing_buttons,x,y,32,16,0,20,#PB_Spin_Numeric)
        TextGadget(#g_prefs_spacing_buttons_t,x+40,y,w-40,16,"Space between button groups")
        y = y+28
        ButtonGadget(#g_prefs_font,x,y,60,24,"Font")
        TextGadget(#g_prefs_font_t,x+68,y+5,w-80,16,prefs_font_name+" "+Str(prefs_font_size))
        ;
        w = width-48
        x = 16
        y = y+48
        h = 30+24*3
        FrameGadget(#g_prefs_search_options,x,y,w,h,"Search results")
        x = x+16
        y = y+24
        w = w-32
        SpinGadget(#g_prefs_search_firstnr,x,y,32,16,0,10,#PB_Spin_Numeric)
        TextGadget(#g_prefs_search_firstnr_t,x+40,y,160,16,"Results per category")
        CheckBoxGadget(#g_prefs_search_extra,x+w/2,y,w/2,16,"Info")
        y = y+24
        CheckBoxGadget(#g_prefs_show_darkercolors,x+w/2,y,w/2,16,"Darker colours")
        y = y+24
        CheckBoxGadget(#g_prefs_show_unzoom,x+w/2,y,w/2,16,"Unzoom on next")
        ;
        y = y+44
        x = x-16
        w = w+32
        CheckBoxGadget(#g_prefs_config_saveonexit,x,y,w,16,"Save config on exit")
        ;
        ;
        ; backup
        ;
        AddGadgetItem(#g_prefs_panel,-1,"Backup")
        x = 16
        y = 12
        w = width-48
        h = 14
        TextGadget(#g_prefs_backup_t,x,y,w,h,"CodeCaddy can create backups of your source files.")
        y = y+28
        h = 4*24+30
        FrameGadget(#g_prefs_backup_what_f,x,y,w,h,"What")
        x = x+16
        y = y+24
        w = w-32
        SpinGadget(#g_prefs_save_max,x,y,32,16,10,1000,#PB_Spin_Numeric)
        TextGadget(#g_prefs_save_max_t,x+40,y,w-40,16,"Number of backups to keep")
        y = y+24
        SpinGadget(#g_prefs_save_length,x,y,32,16,3,6,#PB_Spin_Numeric)
        TextGadget(#g_prefs_save_length_t,x+40,y,w-40,16,"Number of digits in backup counter")
        y = y+24
        CheckBoxGadget(#g_prefs_save_excludebuilds,x,y,w,16,"Keep build backups")
        y = y+24
        CheckBoxGadget(#g_prefs_save_excludesnapshots,x,y,w,16,"Keep snapshot backups")
        ;
        x = 16
        y = y+42
        w = w+32
        h = 2*24+30
        FrameGadget(#g_prefs_backup_where_f,x,y,w,h,"Where")
        x = x+16
        y = y+24
        w = w-32
        CheckBoxGadget(#g_prefs_save_baktobackup,x,y,w,16,"Store .bak files in separate folder '_backup'")
        y = y+24
        CheckBoxGadget(#g_prefs_save_cdytobackup,x,y,w,16,"Store .cdy files in separate folder '_backup'")
        ;
        x = 16
        y = y+42
        w = w+32
        h = 2*24+30
        FrameGadget(#g_prefs_backup_when_f,x,y,w,h,"When")
        x = x+16
        y = y+24
        w = w-32
        SpinGadget(#g_prefs_compilerun_savefrequency,x,y,32,16,1,50,#PB_Spin_Numeric)
        TextGadget(#g_prefs_compilerun_savefrequency_t,x+40,y,w-40,16,"Every 'n'th time on compile/run")
        y = y+24
        SpinGadget(#g_prefs_compilerun_autosaveinterval,x,y,32,16,0,1000,#PB_Spin_Numeric)
        TextGadget(#g_prefs_compilerun_autosaveinterval_t,x+40,y,w-40,16,"After 'n' seconds on next compile/run")
        ;
        x = 16
        y = y+50
        w = w+32
        h = 64
        TextGadget(#g_prefs_backup_note_t,x,y,w,h,"Counters are stored in <sourcename>.cdy files. See the help " + _
          "function for more information.")
        ;
        ;
        ; pre-processing
        ;
        AddGadgetItem(#g_prefs_panel,-1,"Pre-Process")
        x = 16
        y = 12
        w = width-48
        h = 26
        TextGadget(#g_prefs_prep_t,x,y,w,h,"Upon run or build time CodeCaddy can insert constants and " + _
          "pre-process your source code just before passing it on to the PureBasic compiler.")
        y = y+h+16
        h = 6*24+30
        FrameGadget(#g_prefs_prep_generic_f,x,y,w,h,"Pre-Processing")
        x = x+16
        y = y+24
        w = w-32
        CheckBoxGadget(#g_prefs_prep_savebackup,x,y,w,16,"Create backups")
        y = y+24
        CheckBoxGadget(#g_prefs_prep_addconstants,x,y,w,16,"Add build and save constants")
        y = y+24
        CheckBoxGadget(#g_prefs_prep_multiline,x,y,w,16,"Support line continuation char '_'")
        y = y+24
        CheckBoxGadget(#g_prefs_prep_keepsync,x,y,w,16,"Add empty lines at continuation points for debugging")
        y = y+24
        CheckBoxGadget(#g_prefs_prep_thinbuilds,x,y,w,16,"Remove unused procedures and macros from builds")
        y = y+24
        CheckBoxGadget(#g_prefs_prep_thindeep,x,y,w,16,"Remove all spaces, comments, and empty lines")
        ;
        x = 16
        y = y+50
        w = w+32
        h = 160
        TextGadget(#g_prefs_prep_note_t,x,y,w,h,"To use this feature some external tools have to be added " + _
          "to PureBasic IDE / tools / config tools."+#CRLF$+#CRLF$+"Counters are stored in <sourcename>.cdy " + _
          "files. In your code you can use #codecaddy_save_nr and other constants to add build information " + _
          "to your final executable. See the 'backup' tab for the locations where these files are stored." + _
          #CRLF$+#CRLF$+"Comments after the line continuation character are allowed. Line continuation is " + _
          "not supported in 'included' files. For more information see the help function.")
        ;
        ;
        ; other
        ;
        AddGadgetItem(#g_prefs_panel,-1,"Other")
        x = 16
        y = 12
        w = width-48
        h = 4*24+30
        FrameGadget(#g_prefs_format_f,x,y,w,h,"Format source")
        x = x+16
        y = y+24
        w = w-32
        TextGadget(#g_prefs_format_indent_t,x,y,w-32,16,"Format indent")
        SpinGadget(#g_prefs_format_indent,x+w-32,y,32,16,2,9,#PB_Spin_Numeric)
        y = y+24
        CheckBoxGadget(#g_prefs_format_smart,x,y,w,16,"Detect colon, comment and line continuation")
        y = y+24
        CheckBoxGadget(#g_prefs_format_multiline,x,y,w-32,16,"Reformat continued line (indent from preceding)")
        SpinGadget(#g_prefs_format_multiline_indent,x+w-32,y,32,16,0,6,#PB_Spin_Numeric)
        y = y+24
        CheckBoxGadget(#g_prefs_format_procedure,x,y,w-32,16,"Add whitespace after Procedure definitions")
        SpinGadget(#g_prefs_format_procedure_space,x+w-32,y,32,16,0,200,#PB_Spin_Numeric)
        ;
        x = 16
        y = y+40
        w = width-48
        h = 4*26+32
        FrameGadget(#g_prefs_codesync_f,x,y,w,h,"Codesync")
        x = x+16
        w = w-32
        h = 20
        y = y+24
        TextGadget(#g_prefs_codesync_folder1_t,x,y,40,16,"Folder 1")
        StringGadget(#g_prefs_codesync_folder1,x+50,y-2,w-72,h,codesync_folder1)
        ButtonImageGadget(#g_prefs_codesync_select1,x+w-18,y,18,18,i_char_doubleperiod_black_h)
        y = y+26
        TextGadget(#g_prefs_codesync_folder2_t,x,y,40,16,"Folder 2")
        StringGadget(#g_prefs_codesync_folder2,x+50,y-2,w-72,h,codesync_folder2)
        ButtonImageGadget(#g_prefs_codesync_select2,x+w-18,y,18,18,i_char_doubleperiod_black_h)
        y = y+28
        TextGadget(#g_prefs_codesync_filter_t,x,y,40,16,"Filter")
        StringGadget(#g_prefs_codesync_filter,x+50,y-2,w-120,h,codesync_filter)
        TextGadget(#g_prefs_codesync_baklimit_t,x+w-60,y,35,16,".bak")
        SpinGadget(#g_prefs_codesync_baklimit,x+w-32,y,32,16,1,20,#PB_Spin_Numeric)
        y = y+28
        CheckBoxGadget(#g_prefs_codesync_confirmation,x,y,w,16,"Confirm all overwrites of non .bak .pb .cdy files")
        ;
        x = 16
        y = y+40
        w = width-48
        h = 3*24+30
        FrameGadget(#g_prefs_commandline_f,x,y,w,h,"Commandline")
        x = x+16
        y = y+24
        w = w-32
        CheckBoxGadget(#g_prefs_log_maintain,x,y,w,16,"Use logfile")
        y = y+24
        CheckBoxGadget(#g_prefs_log_showoncmd,x,y,w,16,"Show logfile")
        y = y+24
        CheckBoxGadget(#g_prefs_log_showonerror,x,y,w,16,"Show logfile on errors")
        ;
        ;
        ; keywords
        ;
        AddGadgetItem(#g_prefs_panel,-1,"Keywords")
        x = 16
        y = 12
        w = width-52
        h = 40
        TextGadget(#g_prefs_keywords_t,x,y,w,h,"Keywords used for reformatting. Keywords under 'up' will " + _
          "increase the margin, under 'down' will decrease the margin. By listing them under increase and " + _
          "decrease an inverse indent can be realised. Entries are separated by '|'.")
        y = y+h+14
        h = height/4-70
        h = h+10
        TextGadget(#g_prefs_keywords_up_t,x,y,w,16,"Increase")
        y = y+20
        x_editorgadget(#g_prefs_keywords_up,x,y,w,h,"","",#x_gadget_notify | #x_gadget_wordwrap)
        y = y+h+14
        TextGadget(#g_prefs_keywords_down_t,x,y,w,16,"Decrease")
        y = y+20
        x_editorgadget(#g_prefs_keywords_down,x,y,w,h,"","",#x_gadget_notify | #x_gadget_wordwrap)
        y = y+h+14
        TextGadget(#g_prefs_keywords_doubleup_t,x,y,w,16,"Double increase")
        h = h-20
        y = y+20
        x_editorgadget(#g_prefs_keywords_doubleup,x,y,w,h,"","",#x_gadget_notify | #x_gadget_wordwrap)
        y = y+h+14
        TextGadget(#g_prefs_keywords_doubledown_t,x,y,w,16,"Double decrease")
        y = y+20
        x_editorgadget(#g_prefs_keywords_doubledown,x,y,w,h,"","",#x_gadget_notify | #x_gadget_wordwrap)
        ;
        ;
        ; search
        ;
        AddGadgetItem(#g_prefs_panel,-1,"Search")
        x = 16
        y = 12
        w = width-52
        h = 40
        TextGadget(#g_prefs_search_local_t,x,y,w,h,"Ctrl+F1 starts with the current source " + _
          "followed by any 'included' files. It will then continue with all files listed " + _
          "under 'basic'. The 'extended' list will only be searched after a pause. Use ++ " + _
          "to include all subdirectories.")
        y = y+h+14
        h = 14
        TextGadget(#g_prefs_search_current_t,x,y,w,h,"Current source:")
        y = y+20
        If file = ""
          TextGadget(#g_prefs_search_current,x,y,w,h,"(none)")
        Else
          TextGadget(#g_prefs_search_current,x,y,w,h,file)
        EndIf
        y = y+28
        h = 113
        TextGadget(#g_prefs_search_basic_t,x,y,w,16,"Basic")
        y = y+20
        x_editorgadget(#g_prefs_search_basic,x,y,w,h,"","",#x_gadget_notify)
        ButtonImageGadget(#g_prefs_search_basic_file,w-22,y-20,18,18,i_char_is_black_h)
        ButtonImageGadget(#g_prefs_search_basic_folder,w-4,y-20,18,18,i_char_asterix_black_h)
        y = y+h+14
        TextGadget(#g_prefs_search_extended_t,x,y,w,16,"Extended")
        y = y+20
        x_editorgadget(#g_prefs_search_extended,x,y,w,h,"","",#x_gadget_notify)
        ButtonImageGadget(#g_prefs_search_extended_file,w-22,y-20,18,18,i_char_is_black_h)
        ButtonImageGadget(#g_prefs_search_extended_folder,w-4,y-20,18,18,i_char_asterix_black_h)
        ;
        ;
        ; web
        ;
        AddGadgetItem(#g_prefs_panel,-1,"Web")
        x = 16
        y = 12
        w = width-52
        h = 28
        TextGadget(#g_prefs_web_t,x,y,w,h,"Alt+F1 launches your browser. The type of keyword can trigger different searches. " + _
          "Use %keyword% as placeholder for the keyword.")
        y = y+h+14
        h = 14
        TextGadget(#g_prefs_web_keyword_t,x,y,w,h,"Current keyword:")
        y = y+h+6
        h = 14
        If file = ""
          TextGadget(#g_prefs_web_keyword,x,y,w,h,"(none)")
        Else
          TextGadget(#g_prefs_web_keyword,x,y,w,h,search_string)
        EndIf
        y = y+h+14
        h = 14
        TextGadget(#g_prefs_web_browser_t,x,y,w,16,"Browser")
        y = y+h+6
        h = 20
        x_editorgadget(#g_prefs_web_browser,x,y,w,h,"","",#x_gadget_notify)
        y = y+h+14
        h = 14
        TextGadget(#g_prefs_web_empty_t,x,y,w,16,"Sites to launch on empty keyword")
        y = y+h+6
        h = 34
        x_editorgadget(#g_prefs_web_empty,x,y,w,h,"","",#x_gadget_notify)
        y = y+h+14
        h = 14
        TextGadget(#g_prefs_web_underscore_t,x,y,w,16,"Sites to launch when keyword ends on underscore")
        y = y+h+6
        h = 58
        x_editorgadget(#g_prefs_web_underscore,x,y,w,h,"","",#x_gadget_notify)
        y = y+h+14
        h = 14
        TextGadget(#g_prefs_web_other_t,x,y,w,16,"Sites to launch on other keywords")
        y = y+h+6
        h = 58
        x_editorgadget(#g_prefs_web_other,x,y,w,h,"","",#x_gadget_notify)
        ;
      CloseGadgetList()
      ;
      ; buttons
      ;
      w = 60
      x = width-5*(w+4)
      y = height-28
      h = 24
      ButtonGadget(#g_prefs_reset,x,y,w,h,"Reset")
      x = x+w+4
      ButtonGadget(#g_prefs_save,x,y,w,h,"Save")
      x = x+w+4
      ButtonGadget(#g_prefs_apply,x,y,w,h,"Apply")
      x = x+w+4
      ButtonGadget(#g_prefs_ok,x,y,w,h,"Ok")
      x = x+w+4
      ButtonGadget(#g_prefs_cancel,x,y,w,h,"Cancel")
      ;
    EndIf
    ;
  EndIf
  ;
  update_listpanel(0)
  ;
EndProcedure

Procedure remember_selected()                              ; remember entry in listpanel
  ;
  ; remember where we are in the listpanel by name
  ; (so we can find the proper entry back after changing view etc.)
  ;
  list_selected = GetGadgetState(#g_listpanel)
  list_n_old = list_n
  If list_selected >= 0
    hit_file = List(list_selected)\file                ; file found
    hit_line = List(list_selected)\line                ; line where the search phrase was found
    hit_type = List(list_selected)\type                ; type of hit (filter)
    seek_pos = List(list_selected)\seek_pos            ; seek pos in file
    seek_line = List(list_selected)\seek_line          ; line associated with seek pos
  EndIf
  ;
EndProcedure

Procedure findback_selected()                              ; go back to the remembered entry
  Protected n.i, r.f
  ;
  ; look for the entry we 'remembered' and if we find it, jump there
  ;
  If list_selected > 0                                  ; calculate approx position in case findback fails
    r = list_selected / list_n
  Else
    r = 0
  EndIf
  ;
  update_listpanel(1)                                   ; redraw, execute any size changes, update lists
  ;
  If list_selected >= 0
    ;
    ; update the listpanel
    ;
    If list_n > list_n_old                              ; list got bigger
      n = list_selected
      list_selected = -1
      While n <= list_n                                 ; look for the new entry
        If List(n)\file = hit_file _
            AND List(n)\line = hit_line _
            AND List(n)\type = hit_type _
            AND List(n)\seek_pos = seek_pos _
            AND List(n)\seek_line = seek_line
          list_selected = n                             ; found it
          n = list_n
        EndIf
        n=n+1
      Wend
    ElseIf list_n < list_n_old                          ; list got smaller
      n = list_selected
      list_selected = -1
      While n >= 0                                      ; look for the new entry
        If List(n)\file = hit_file _
            AND List(n)\line = hit_line _
            AND List(n)\type = hit_type _
            AND List(n)\seek_pos = seek_pos _
            AND List(n)\seek_line = seek_line
          list_selected = n                             ; found it
          n = 0
        EndIf
        n=n-1
      Wend
    EndIf
    list_n_old = list_n
    ;
    If list_selected = -1                               ; didn't find anything
      list_selected = r*list_n                          ; so the new position is relative to the old one
    EndIf
  EndIf
  ;
  ; remove eventual splitmode
  ;
  If splitter_max
    splitter_max = #False
    draw()
    reflect_settings()
  EndIf
  ;
  ; update codepanel
  ;
  update_codepanel(list_selected)
  ;
EndProcedure

Procedure search_next()                                    ; find the next hit
  Protected f.s, p.i, x.s, s.s, l.i, s_l.i, t.i, n.i, dupe.i, hit.i, x_p.i, x_semicolon.i, x_quote.i, x_bracket.i, x_equal.i
  ;
  ; call search_start() one time then repeat calling this routine to empty the list
  ;
  ; as x_dir() is used to retrieve a large number of files / folders reaction speed may be
  ; inconsistent, better not do searches that are too deep...
  ;
  If hit_n = #list_max
    ;
    search_status = #status_error
    If IsStatusBar(#sb_main_nr)
      StatusBarText(#sb_main_nr,1," limit reached ("+Str(#list_max)+" hits)")
      StatusBarImage(#sb_main_nr,0,i_led_red_h)
    EndIf
    update_listpanel(1)
    ;
  ElseIf files_n = 0 Or files_p > files_n-1
    ;
    ; we're done for now...
    ;
    search_status = #status_ready
    If IsStatusBar(#sb_main_nr)
      StatusBarText(#sb_main_nr,1," done")
    EndIf
    update_listpanel(1)
    ;
  Else
    ;
    SelectElement(files(),files_p)                         ; so files_p points to current entry to be processed
    f = files()
    If f = ""                                              ; emtpy line
      files_p = files_p+1
    ElseIf f = "< extended >"                              ; start of the extended section
      files_p = files_p+1
    ElseIf f = "< basic >"                                 ; start of the basic section
      files_p = files_p+1
    ElseIf f = "< end >"                                   ; reached the end
      files_p = files_n
    ElseIf f = "< file >"                                  ; the file entry and eventual includes
      files_p = files_p+1
    ElseIf f = "< start >"                                 ; start
      files_p = files_p+1
    ElseIf f = "< pause >"                                 ; pause
      ;
      ; pause between basic and extended
      ;
      files_p = files_p+1
      search_status = #status_paused
      If IsStatusBar(#sb_main_nr)
        StatusBarText(#sb_main_nr,1," on hold")
      EndIf
      reflect_settings()
      ;
    Else
      ;
      ; it's either a real file or a path/pattern thing
      ;
      If IsStatusBar(#sb_main_nr)
        If files_n > 0
          StatusBarText(#sb_main_nr,1,Str(100*files_p/files_n)+"% "+ _
            Str(hit_constant_n+hit_procedure_n+hit_structure_n+hit_variable_n)+"/"+ _
            Str(hit_n)+" "+Str(files_p)+"/"+Str(files_n)+" "+f)
        EndIf
        StatusBarImage(#sb_main_nr,0,i_led_darkgreen_h)
      EndIf
      ;
      If Right(f,2) = "++"                                 ; it's a driller
        f = Trim(x_chop(f,0,2))
        x_dir_filefolder(f,"*.*",200,50000)                ; so let's drill and grab maximal 50000 files
      Else
        x_dir_filefolder(f,"*.*",0,50000)                  ; no driller, don't drill, grab maximal 50000 files
      EndIf
      ;
      ; got all matching files
      ;
      If x_dir_n = 0
        ;
        ; non-match, process next entry
        ;
        files_p = files_p+1
        ;
      ElseIf x_dir_n > 1                                   ; multiple entries
        ;
        ; multiple entries, which means it was a path/pattern thing, need to store all
        ; (each entry will be processed on subsequent calls)
        ;
        DeleteElement(files())                             ; delete the pattern / file used as input
        files_n = files_n-1
        n = 0
        While n < x_dir_n
          AddElement(files())                              ; add all found entries
          SelectElement(x_dir_file(),n)
          files() = x_dir_file()\name
          files_n = files_n+1
          n = n+1
        Wend
        ;
      ElseIf x_dir_n = 1
        ;
        ; process a found file
        ;
        SelectElement(x_dir_file(),0)
        f = x_dir_file()\name
        ;
        ; first look for duplicates
        ;
        dupe = #False
        p = 0
        While p < files_p
          SelectElement(files(),p)
          If files() = f
            dupe = #True
            p = files_p
          EndIf
          p = p+1
        Wend
        If dupe = #True
          ;
          ; remove duplicates
          ;
          SelectElement(files(),files_p)
          DeleteElement(files())
          files_n = files_n-1
          ;
        Else
          ;
          ; got a valid filename, let's try to open and search it
          ;
          SelectElement(files(),files_p)
          files() = f                                                ; store for duplicate detection
          files_p = files_p+1                                        ; okay, we're ready for the next entry
          If hit_n < #list_max And ReadFile(1,f)                     ; there's still space in the list and we can open the file
            ;
            For n = 0 To #seek_buffer                                ; reset all elements of seek buffer
              seek_buffer_pos(n) = 0
              seek_buffer_line(n) = 1
            Next n
            ;
            l = 1
            s = LCase(Trim(search_string))
            s_l = Len(s)
            While x_not(Eof(1)) And hit_n < #list_max
              ;
              ; i might (have to) add some sort of protection against reading binaries etc. in here
              ;
              For n = #seek_buffer To 1 Step -1                      ; shift all seek data
                seek_buffer_pos(n) = seek_buffer_pos(n-1)
                seek_buffer_line(n) = seek_buffer_line(n-1)
              Next n
              seek_buffer_pos(0) = Loc(1)                            ; seek buffer helps in displaying a few lines before the hit
              seek_buffer_line(0) = l                                ; line number associated to seek position
              ;
              x = Trim(ReadString(1))                                ; retrieve a line
              l = l+1                                                ; increase line counter
              ;
              hit = #False                                           ; flag if search string found
              ;
              If search_wildcards = #False
                x_p = FindString(LCase(x),s,1)
                If x_p > 0
                  hit = #True                                        ; a match using simple find, begin with detection is done further down below
                EndIf
              Else                                                   ; wildcards match which could have been widened or narrowed down
                If search_narrow
                  hit = x_matchpatternx(x,s,#x_parse_anycase,search_widen,"+-/ ()*^")     ; narrowed down (filtering certain characters)
                Else
                  hit = x_matchpatternx(x,s,#x_parse_anycase,search_widen,"")             ; not narrowed down (any characters)
                EndIf
              EndIf
              ;
              If hit = #True
                ;
                t = #f_filter_all                                    ; use this as default type
                ;
                ; it's a hit but we still need to identify it, first avoid false positives
                ;
                If hit = #True And search_wildcards = #False And search_beginwith = #True
                  x_semicolon = FindString(x,";",1)
                  If x_semicolon > 0 And x_semicolon < x_p
                    hit = #False
                  Else
                    x_quote = FindString(x,Chr(34),1)
                    If x_quote > 0 And x_quote < x_p
                      hit = #False
                    Else
                      x_bracket = FindString(x,"(",1)
                      If x_bracket > 0 And x_bracket < x_p
                        hit = #False
                      Else
                        x_equal = FindString(x,"=",1)
                        If x_equal > 0 And x_equal < x_p
                          hit = #False
                        EndIf
                      EndIf
                    EndIf
                  EndIf
                EndIf
                If Left(x,1) = ";"                                               ; comment lines are not considered proper hits
                  hit = #False
                EndIf
                ;
                If hit = #True
                  ;
                  ; didn't figure it out yet, now try to identify it
                  ; code is a bit horrible but this happens when fooling around too much...
                  ;
                  hit = #False                                                   ; now use the hit flag to identify it
                  ;
                  x_parse(x," ",#x_parse_eol|#x_parse_lcase|#x_parse_trim)
                  ;
                  If x_parsed = "procedure" Or Left(x_parsed,10) = "procedure."  ; a procedure definition
                    t = #f_filter_procedure
                    If Left(x_parse,s_l) = s Or search_beginwith = #False
                      hit_procedure_n = hit_procedure_n+1
                      hit = #True
                    EndIf
                    ;
                  ElseIf Left(x_parsed,9) = "structure"                          ; a structure definition
                    t = #f_filter_structure
                    If Left(x_parse,s_l) = s Or search_beginwith = #False
                      hit_structure_n = hit_structure_n+1
                      hit = #True
                    EndIf
                    ;
                  ElseIf Left(x_parsed,1) = "#"                                  ; a constant defintion
                    t = #f_filter_constant
                    If Left(x_parsed,s_l) = s Or Mid(x_parsed,2,s_l) = s Or search_beginwith = #False
                      hit_constant_n = hit_constant_n+1
                      hit = #True
                    EndIf
                    ;
                  Else
                    ;
                    ; variables are more complex, use hit = #true to flag if it's a valid hit
                    ;
                    If x_parsed = "global" Or x_parsed = "dim" Or x_parsed = "shared" Or x_parsed = "static" Or x_parsed = "protected"
                      t = #f_filter_variable
                      If FindString(x," "+s,1) > 0 Or FindString(x,","+s,1) > 0 Or search_beginwith = #False
                        hit = #True
                      EndIf
                    Else
                      If x_bracket = 0 And x_equal = 0 And FindString(x,".",1) > 0
                        hit = #True
                      ElseIf x_bracket = 0 And x_equal > 0
                        hit = #True
                      ElseIf x_bracket > x_equal And x_equal > 0
                        hit = #True
                      EndIf
                      If hit = #True
                        t = #f_filter_variable
                        If Left(x_parsed,s_l) <> s And search_beginwith = #True
                          hit = #False
                        EndIf
                      EndIf
                    EndIf
                    If hit = #True
                      hit_variable_n = hit_variable_n+1
                    EndIf
                  EndIf
                EndIf
                ;
                ; now add it to the array
                ;
                hit_n = hit_n+1
                hit(hit_n)\file = f                         ; store filename
                hit(hit_n)\string = x                       ; line that contains the match
                If hit = #True
                  hit(hit_n)\type = t                       ; type
                Else
                  hit(hit_n)\type = #f_filter_all
                EndIf
                hit(hit_n)\line = l-1                       ; store line number of hit
                hit(hit_n)\seek_pos = seek_buffer_pos(10)   ; store seek point
                hit(hit_n)\seek_line = seek_buffer_line(10) ; store line number of seek point
                ;
              EndIf
              ;
            Wend
            CloseFile(1)
            update_listpanel(0)
          EndIf
        EndIf
      EndIf
      
      
    EndIf
  EndIf
EndProcedure

Procedure search_start()                                   ; start the search
  Protected n.i, x.s, y.s, p.i
  ;
  ; *** start the search
  ;
  ; search_start grabs all files using set parameters, and filters out duplicate filenames
  ; it then sets up parameters necessary for search_next()
  ;
  If search_string <> ""
    ;
    ; wipe lists
    ;
    clear_allarrays()
    ;
    ; reset counters
    ;
    hit_n = 0
    hit_procedure_n = 0
    hit_constant_n = 0
    hit_variable_n = 0
    hit_structure_n = 0
    old_n = 0
    old_procedure_n = 0
    old_constant_n = 0
    old_variable_n = 0
    old_structure_n = 0
    old_files_p = 0
    old_filter_type = -2 ; make sure listpanel is rebuild
    ;
    ; add filename source code to the list
    ;
    ClearList(files())
    files_n = 0
    AddElement(files())
    files_n = files_n+1
    files() = "< start >"                                   ; separator
    AddElement(files())
    files_n = files_n+1
    files() = "< file >"                                    ; separator
    ;
    ; file = "D:\files\software\purebasic\_projects\codecaddy\codecaddy.PB"    ; only for debugging / testing
    ; file = "c:\software\purebasic\_projects\codecaddy\codecaddy.PB"          ; only for debugging / testing
    ;
    If file <> ""
      AddElement(files())
      files() = file                                        ; first insert current source name
      files_n = files_n+1
      If ReadFile(1,file)                                   ; then add all (x)includes
        While x_not(Eof(1))
          x = Trim(LCase(ReadString(1)))
          If Left(x,11) = "includefile" Or Left(x,12) = "xincludefile"
            If x_parse(x,Chr(34),#x_parse_trim|#x_parse_eol)
              If x_parsestring(Chr(34))
                y = GetPathPart(file)
                x = x_parsed
                While Left(x,3)="..\" And Len(x) > 3
                  x = Mid(x,4,4096)
                  p = x_rfindstring(x_chop(y,0,1),"\")
                  y = Mid(y,1,p)
                Wend
                y = y+x
                AddElement(files())
                files_n = files_n+1
                files() = y
              EndIf
            EndIf
          EndIf
        Wend
        CloseFile(1)
      EndIf
    EndIf
    ;
    AddElement(files())
    files() = "< basic >"                                    ; separator
    files_n = files_n+1
    ;
    ; add all paths under 'basic' to search
    ;
    search_basic_n = x_parsefield(search_basic,"|",#x_parse_eol|#x_parse_trim)
    n = 0
    While n < search_basic_n
      n = n+1
      AddElement(files())
      files_n = files_n+1
      files() = x_parse_field(n)                             ; add all entries from basic paths to search
    Wend
    AddElement(files())
    files_n = files_n+1
    files() = "< pause >"                                    ; separator
    ;
    ; add all paths under 'extended' to search
    ;
    AddElement(files())
    files_n = files_n+1
    files() = "< extended >"                                 ; separator
    ;
    search_extended_n = x_parsefield(search_extended,"|",#x_parse_eol|#x_parse_trim)
    n = 0
    While n < search_extended_n
      n = n+1
      AddElement(files())
      files_n = files_n+1
      files() = x_parse_field(n)                             ; add all entries from extended list
    Wend
    AddElement(files())
    files_n = files_n+1
    files() = "< end >"                                      ; end of list marker
    ;
    ; last preparations...
    ;
    search_status = #status_searching                        ; inform gui and mainloop we're running a search
    reflect_settings()
    files_p = 0                                              ; start at the beginning of the list
    ;
    ; okay, we're now all setup, now all we have to do is run the regular eventloop with or without
    ; waiting for events, and let search_next() fill everything in...
    ;
    ; finally, we need to check the filter type, and update the screen accordingly, if we just displayed
    ; for example a help file or log file we want to make sure the top half of the screen now will show
    ; the matches found
    ;
    If filter_type = < 0
      filter_type = #f_filter_categorized
    EndIf
    ;
  EndIf
  ;
EndProcedure

Procedure search_window()                                  ; search window
  Protected w_search_h.i, width.i, height.i, x.i, y.i, w.i, h.i
  Protected event.i, action.i
  ;
  ; *** open new window that allows entering data and starting find action
  ;
  ; note: this one may become optional when a find box can be added to the buttonbar at the
  ; bottom... not yet implemented though, if it ever will...
  ;
  width = 400
  height = 228
  ;
  If show_keepontop = #True
    SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
  EndIf
  EnableWindow_(w_main_h,#False)
  If show_nearbydialogs And w_main_h > 0
    w_main_maximized = IsZoomed_(w_main_h)
    If w_main_maximized = #False
      w_main_x = WindowX(#w_main_nr)
      w_main_y = WindowY(#w_main_nr)
      w_main_width = WindowWidth(#w_main_nr)
      w_main_height = WindowHeight(#w_main_nr)
    EndIf
    w_search_h = OpenWindow(#w_search_nr,WindowX(#w_main_nr)+40,WindowY(#w_main_nr)+40,width,height,"CodeCaddy - Search",#PB_Window_SystemMenu,w_main_h)
  Else
    w_search_h = OpenWindow(#w_search_nr,10,10,width,height,"CodeCaddy - Search",#PB_Window_ScreenCentered|#PB_Window_SystemMenu,w_main_h)
  EndIf
  x_window_todesktop(#w_search_nr)
  SetWindowPos_(w_search_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE)
  AddKeyboardShortcut(#w_search_nr,#PB_Shortcut_Escape,#f_search_cancel)
  AddKeyboardShortcut(#w_search_nr,#PB_Shortcut_Return,#f_search_start)
  ;
  x = 16
  y = 16
  w = 50
  h = 20
  TextGadget(#g_search_findstring_t,x,y+2,w,h,"Search for")
  x = x+w+10
  w = width-16-x
  StringGadget(#g_search_findstring,x,y,w,h,search_string)
  ;
  x = 16
  w = width-32
  y = y+h+16
  FrameGadget(#g_search_options,x,y,w,height-96,"Options")
  x = 32
  y = y+24
  w = w-32
  CheckBoxGadget(#g_search_included,x,y,w,16,"Process files 'included' in source")
  SetGadgetState(#g_search_included,search_included)
  y = y+20
  CheckBoxGadget(#g_search_beginwith,x,y,w,16,"Begin with search phrase (only for categorized views)")
  SetGadgetState(#g_search_beginwith,search_beginwith)
  DisableGadget(#g_search_beginwith,search_wildcards)
  y = y+20
  CheckBoxGadget(#g_search_wildcards,x,y,w,16,"Wildcards and patterns *?| (may affect categorization)")
  SetGadgetState(#g_search_wildcards,search_wildcards)
  y = y+20
  CheckBoxGadget(#g_search_widen,x,y,w,16,"Widen search (trim and surround by *)")
  SetGadgetState(#g_search_widen,search_widen)
  DisableGadget(#g_search_widen,x_not(search_wildcards))
  y = y+20
  CheckBoxGadget(#g_search_narrow,x,y,w,16,"Narrow search (exclude +-*^/() unless part of pattern)")
  SetGadgetState(#g_search_narrow,search_narrow)
  DisableGadget(#g_search_narrow,x_not(search_wildcards))
  ;
  w = 60
  h = 24
  y = height-h-4
  x = width-2*(w+4)
  ButtonGadget(#g_search_start,x,y,w,h,"Start",#PB_Button_Default)
  x = x+w+4
  ButtonGadget(#g_search_cancel,x,y,w,h,"Cancel")
  ;
  SetActiveGadget(#g_search_findstring)
  SendMessage_(GadgetID(#g_search_findstring),#EM_SETSEL,0,-1)
  ;
  Repeat
    ;
    action = 0
    event = WaitWindowEvent()
    ;
    If EventWindow() = #w_search_nr
      Select event
          Case #PB_Event_Menu
            action = EventMenu()
          Case #PB_Event_Gadget
            Select EventGadget()
                Case #g_search_wildcards
                  search_wildcards = x_not(search_wildcards)
                  SetGadgetState(#g_search_wildcards,search_wildcards)
                  DisableGadget(#g_search_beginwith,search_wildcards)
                  DisableGadget(#g_search_widen,x_not(search_wildcards))
                  DisableGadget(#g_search_narrow,x_not(search_wildcards))
                Case #g_search_widen
                  search_widen = x_not(search_widen)
                  SetGadgetState(#g_search_widen,search_widen)
                Case #g_search_narrow
                  search_narrow = x_not(search_narrow)
                  SetGadgetState(#g_search_narrow,search_narrow)
                Case #g_search_beginwith
                  search_beginwith = x_not(search_beginwith)
                  SetGadgetState(#g_search_beginwith,search_beginwith)
                Case #g_search_included
                  search_included = x_not(search_included)
                  SetGadgetState(#g_search_included,search_included)
                Case #g_search_start
                  action = #f_search_start
                Case #g_search_cancel
                  action = #f_search_cancel
            EndSelect
          Case #PB_Event_CloseWindow
            action = #f_search_cancel
      EndSelect
      ;
      If action = #f_search_start
        search_string = GetGadgetText(#g_search_findstring)
        search_start()
      EndIf
      ;
    EndIf
  Until action <> 0
  ;
  ; ok we're done return to main window
  ;
  reflect_settings()
  EnableWindow_(w_main_h,#True)
  If GetForegroundWindow_() <> w_main_h
    If show_keepontop
      SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
      SetForegroundWindow_(w_main_h)
    Else
      SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
      SetForegroundWindow_(w_main_h)
    EndIf
  EndIf
  CloseWindow(#w_search_nr)
EndProcedure

Procedure showoff()                                        ; not used
  Static timer.i, trigger.i
  Protected n.i, w.i, h.i
  ;
  ; getickcount_() returns an increasing number, it's a counter in millisecs
  ; and could wrap around after 50 days or so :-)
  ;
  timer = GetTickCount_()
  If timer > #wrapalert
    ;
    ; ah, the 50 day wrap around
    ; we'll wait until we've passed the danger zone, actually this is ugly
    ; and will cause a 6 * interval time hickup once every 50 days... oh well,
    ; that ain't too bad :-)
    ;
    trigger = 0-#wrapalert
    ;
  ElseIf timer > trigger+#interval*2
    ;
    ; fresh start, wrap, or behind, we'll set trigger in such a way it will cause an action next time
    ;
    trigger = timer
    ;
  ElseIf timer > trigger
    ;
    ; ah time to do something
    ;
    ; the next trigger moment is based upon the old one plus interval
    ; we don't use the timer + interval as that may be later or earlier due to other
    ; things windows is doing in fore or background
    ;
    trigger = trigger+#interval
    ;
    ; so now the show_off code
    ;
    ; sorry, nothing here...
    ;
  EndIf
  ;
EndProcedure

Procedure display_about()                                  ; display about info
  Protected x.i, y.i, s.s, p.i, w.i, h.i
  ;
  w_main_maximized = IsZoomed_(w_main_h)
  If w_main_maximized = #False
    w_main_x = WindowX(#w_main_nr)
    w_main_y = WindowY(#w_main_nr)
    w_main_width = WindowWidth(#w_main_nr)
    w_main_height = WindowHeight(#w_main_nr)
  EndIf
  ;
  w = 440
  h = 440
  If show_nearbydialogs
    w_about_h = OpenWindow(#w_about_nr,WindowX(#w_main_nr)+40,WindowY(#w_main_nr)+40,w-4,h-4,"CodeCaddy - About",#PB_Window_SystemMenu,w_main_h)
  Else
    w_about_h = OpenWindow(#w_about_nr,40,40,w-4,h-4,"CodeCaddy - About",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,w_main_h)
  EndIf
  x_window_todesktop(#w_about_nr,-1,20)
  LoadFont(1,"Courier",9)
  ;
  i_about_h = CreateImage(#i_about,w,h)
  ;
  StartDrawing(ImageOutput(#i_about))
    DrawingMode(0)
    FrontColor(RGB(255,255,255))
    Box(0,0,w,h)
    DrawImage(i_wackoware_h,10,10)
    DrawingMode(0)
    FrontColor(RGB(0,0,0))
    BackColor(RGB(255,255,255))
    p = ?about_text
    s = ""
    x = 120
    y = 20
    DrawingFont(FontID(1))
    DrawText(x,y,"CodeCaddy "+#codecaddy_version+" "+#codecaddy_copyright)
    y = y+15
    s = "(build "+Str(#codecaddy_build_nr)+FormatDate(" %DD.%MM.%YY",#codecaddy_build_date)+" save "+Str(#codecaddy_save_nr)+")"
    DrawText(x,y,s)
    y = y+30
    While x_peekb(p) <> 0
      DrawText(x,y,x_peeks(p,255,#PB_Ascii,#CRLF$))
      p = p+x_peeks_read
      y = y+15
    Wend
  StopDrawing()
  ;
  ImageGadget(#g_about_wackoware,-2,-2,w,h,i_about_h)
  ;
  DataSection
    about_text:
    IncludeBinary("about.txt")
    Data.l 0
  EndDataSection
  ;
EndProcedure

Procedure display_flash()                                  ; show off a little flash help
  Protected flash_filename.s, x.i
  ;
  If #codecaddy_compilerun = #True
    flash_filename = "c:\software\purebasic\_projects\codecaddy\codecaddy.htm"
  Else
    flash_filename = GetPathPart(ProgramFilename())+"codecaddy.htm"
  EndIf
  If x_exist(flash_filename)
    OpenWindow(#w_flash_nr,100,100,800,600+22,"CodeCaddy - Flash",#PB_Window_SystemMenu|#PB_Window_TitleBar|#PB_Window_ScreenCentered,w_main_h)
    WebGadget(#g_flash_webgadget,-10,-15,800+36,600+56,flash_filename)
  Else
    x = MessageRequester("Missing files","Cannot locate the flash introduction. Try the Internet?",#PB_MessageRequester_YesNo)
    If x = #PB_MessageRequester_Yes
      OpenWindow(#w_flash_nr,100,100,800,600+22,"CodeCaddy - Flash",#PB_Window_SystemMenu|#PB_Window_TitleBar,w_main_h)
      WebGadget(#g_flash_webgadget,-10,-15,800+36,600+56,"http://www.xs4all.nl/~bluez/purebasic/codecaddy.htm")
    EndIf
  EndIf
  ;
EndProcedure

Procedure display_quickhelp(license.i)                     ; show help or license information in panel
  Protected p.i, n.i, l.i
  ;
  ; in: license = 0   - help first
  ;               1   - license first
  ;
  ClearGadgetItems(#g_codepanel)
  clear_codearray()
  ;
  SetGadgetItemText(#g_codepanel,-1,"Help",0)
  ;
  AddGadgetItem(#g_codepanel,-1,"")
  ;
  code_n = 1
  p = ?i_quickhelp_text                                   ; pointer to binary included quickhelp_flag
  While x_peekb(p) <> 0                                   ; keep on reading until a zero
    AddGadgetItem(#g_codepanel,-1,x_peeks(p,4000,#PB_Ascii,#CRLF$))
    code_n = code_n+1
    p = p+x_peeks_read
  Wend
  ;
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"")
  ;
  l = code_n+1
  code_n = code_n+2
  ;
  p = ?i_license_text
  While x_peekb(p) <> 0                                   ; keep on reading until a zero
    AddGadgetItem(#g_codepanel,-1,x_peeks(p,4000,#PB_Ascii,#CRLF$))
    code_n = code_n+1
    p = p+x_peeks_read
  Wend
  AddGadgetItem(#g_codepanel,-1,"")
  code_n = code_n+1
  ;
  For n = 0 To l-1
    code(n)\foreground = RGB(0,0,0)
    code(n)\background = RGB(255,255,255)
  Next n
  For n = l To code_n
    code(n)\foreground = RGB(0,0,0)
    code(n)\background = RGB(255,226,226)
  Next n
  ;
  If license
    x_setlisticontopline(#g_codepanel,l)
  EndIf
  ;
  splitter_max = #True
  filter_type = -1
  draw()
  reflect_settings()
  ;
  SetActiveGadget(#g_codepanel)
  ;
  DataSection
    ;
    i_quickhelp_text:
    IncludeBinary "quickhelp.txt"
    Data.l 0
    i_license_text:
    IncludeBinary "license.txt"
    Data.l 0
    ;
  EndDataSection
  ;
EndProcedure

Procedure display_logfile()                                ; show logfile in panel
  ;
  ClearGadgetItems(#g_codepanel)
  clear_codearray()
  ;
  SetGadgetItemText(#g_codepanel,-1,"Logfile (codecaddy.log)",0)
  ;
  code_n = 0
  If x_exist(x_log_filename)
    x_log_close()
    ;
    OpenFile(1,x_log_filename)
    While x_not(Eof(1))
      AddGadgetItem(#g_codepanel,-1,ReadString(1))
      code(code_n)\foreground = col_black
      code(code_n)\background = col_white
      code_n = code_n+1
    Wend
    CloseFile(1)
  EndIf
  x_setlisticonvisibleline(#g_codepanel,code_n-1)
  SetGadgetState(#g_codepanel,code_n-1)
  ;
  splitter_max = #True
  filter_type = -1            ; display is abused :-) for something else, so untoggle search button
  draw()
  reflect_settings()
  ;
  SetActiveGadget(#g_codepanel)
  ;
EndProcedure

Procedure display_info()                                   ; show source / os / program info and config file in the panel
  Protected x.s, path.s, name.s
  ;
  ClearGadgetItems(#g_codepanel)
  clear_codearray()
  ;
  SetGadgetItemText(#g_codepanel,-1,"Info",0)
  ;
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"*** source ***")
  AddGadgetItem(#g_codepanel,-1,"")
  If file = ""
    AddGadgetItem(#g_codepanel,-1,"none")
  Else
    AddGadgetItem(#g_codepanel,-1,"file "+file)
    AddGadgetItem(#g_codepanel,-1,"caddyfile "+caddyfile)
    path = GetPathPart(file)
    name = GetFilePart(file)
    If save_baktobackup = #True
      path = path+"_backup\"
    EndIf
    AddGadgetItem(#g_codepanel,-1,"save nr "+Str(save_nr)+" build nr "+Str(build_nr))
    AddGadgetItem(#g_codepanel,-1,"last save "+path+name+"."+x_strex(save_nr,save_mask)+".bak")
    AddGadgetItem(#g_codepanel,-1,"last build "+path+name+".xxxxx.build"+Str(build_nr)+".bak")
  EndIf
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"*** os / system ***")
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"os "+x_osname+" "+x_osversion+" "+x_osbuild+" "+x_ospack)
  AddGadgetItem(#g_codepanel,-1,"screen(s) "+Str(x_desktops_n)+" desktop origin "+Str(x_desktops_x)+","+Str(x_desktops_y)+" size "+Str(x_desktops_width)+"x"+Str(x_desktops_height))
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"*** codecaddy ***")
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"codecaddy version "+#codecaddy_version+" copyright "+#codecaddy_copyright)
  x = "build "+Str(#codecaddy_build_nr)+FormatDate(" %DD.%MM.%YY",#codecaddy_build_date)+" save "+Str(#codecaddy_save_nr)
  If #codecaddy_compilerun = #True
    x = x+" compile/run"
  EndIf
  AddGadgetItem(#g_codepanel,-1,x)
  AddGadgetItem(#g_codepanel,-1,"using x_lib "+#x_lib_version+" "+#x_lib_copyright)
  AddGadgetItem(#g_codepanel,-1,"path "+GetCurrentDirectory())
  AddGadgetItem(#g_codepanel,-1,"module "+ProgramFilename())
  AddGadgetItem(#g_codepanel,-1,"config "+configfile)
  AddGadgetItem(#g_codepanel,-1,"log "+x_log_filename)
  AddGadgetItem(#g_codepanel,-1,"files "+Str(files_n)+" hits "+Str(hit_n)+" identified "+Str(hit_procedure_n+hit_structure_n+hit_variable_n+hit_constant_n))
  AddGadgetItem(#g_codepanel,-1,"first instance "+Str(first_instance))
  AddGadgetItem(#g_codepanel,-1,"")
  AddGadgetItem(#g_codepanel,-1,"*** codecaddy.cfg ***")
  AddGadgetItem(#g_codepanel,-1,"")
  If x_exist(configfile)
    OpenFile(1,configfile)
    While x_not(Eof(1))
      AddGadgetItem(#g_codepanel,-1,ReadString(1,#PB_UTF8))
    Wend
    CloseFile(1)
  EndIf
  ;
  splitter_max = #True
  filter_type = -1            ; display is abused :-) for something else, so untoggle search button
  draw()
  reflect_settings()
  ;
  SetActiveGadget(#g_codepanel)
  ;
EndProcedure

Procedure main_loop()                                      ; event processing, gui, continuous loop
  Protected s.s, y_basic.i, y_extended.i, dest.s, n.i, cmd.s, par1.s, par2.s, p.i
  Protected action.i, event.i, event_window.i, event_menu.i, event_type.i, event_gadget.i
  Protected height.i, width.i, bytes_read.i
  Protected message_p.i, message_l.i, message.s, message_n.i
  Protected t1.i, t2.i
  ;
  ; *** main repeating loop
  ;
  ; this is the 'default loop' codecaddy will end up in after processing a keyword that
  ; would not lead to an automatic exit
  ;
  ; note: search actions have not been started and gadgets may still have to be filled at this stage!
  ; have to do threads or something like that, hmm... never done that before :-)
  ;
  ;
  ; -----------------------------------------------------------------------------------------------
  ;
  ; PREPARE SCREEN
  ;
  ; -----------------------------------------------------------------------------------------------
  ;
  x_log("start gui")
  ;
  colorset(show_darkercolors)
  draw()
  reflect_settings()
  ;
  ; -----------------------------------------------------------------------------------------------
  ;
  ; ACTIONS TRIGGERED BY COMMAND LINE PARAMETERS
  ;
  ; -----------------------------------------------------------------------------------------------
  ;
  If command = "quickhelp"
    display_quickhelp(0)
  ElseIf command = "info"
    display_info()
  ElseIf command = "find"
    draw()
    search_start()
    If splitter_max
      splitter_max = #False
      reflect_settings()
      update_codepanel(-1)
    EndIf
  EndIf
  ;
  ; -----------------------------------------------------------------------------------------------
  ;
  ; MAIN LOOP
  ;
  ; -----------------------------------------------------------------------------------------------
  ;
  ;
  Repeat
    action = -1
    If search_status = #status_searching
      ;
      ; keep on searching (windows gets timeslices but codecaddy is not going to wait for events and keeps on going)
      ;
      search_next()
      ;
      ; update the display after first succesfull search
      ;
      n = GetGadgetState(#g_listpanel)
      If n = -1                                                          ; ie. gadget is still empty
        If list_n > 0 And List(0)\type <> 0                              ; and we have a valid item on the top line (search results without fluff)
          update_codepanel(0)
          SetActiveGadget(#g_listpanel)
        ElseIf list_n > 2 And List(2)\type <> 0                          ; or we have a valid item on the third line (search results with fluff)
          update_codepanel(2)
          SetActiveGadget(#g_listpanel)
        EndIf
      EndIf
      ;
      ; a 'fresh' search should run at top speed for the first few entries, after that we'll give windows some more timeslices
      ;
      If n < 10
        event = WindowEvent()
      ElseIf n < 20
        event = WaitWindowEvent(10)
      Else
        event = WaitWindowEvent(20)
      EndIf
      ;
    ElseIf IsWindow(#w_about_nr)
      ;
      ; a little background show in the about window (not implemented)
      ;
      showoff()
      Delay(10)
      event = WindowEvent()
      ;
    Else
      ;
      ; regular wait for a windows event
      ;
      event = WaitWindowEvent()
      ;
    EndIf
    ;
    If event <> 0
      ;
      ; -----------------------------------------------------------------------------------------------
      ;
      ; IDENTIFY EVENT AND PROCESS THEM PER WINDOW
      ;
      ; -----------------------------------------------------------------------------------------------
      ;
      event_window = EventWindow()                  ; what window caused the event
      event_type = EventType()                      ; what type is the event
      event_gadget = EventGadget()                  ; what gadget caused it
      event_menu = EventMenu()                      ; what menu caused the event
      ;
      Select event_window
          Case #w_main_nr
            ;
            ;
            ; *** main window events ***
            ;
            ; process all messages
            ;
            Select event
                Case wakeup_message_nr
                  ;
                  ; -----------------------------------------------------------------------------------------------
                  ;
                  ; MAIN WINDOW HANDLES COMMANDS FROM OTHER INSTANCES PER MAILSLOT
                  ;
                  ; -----------------------------------------------------------------------------------------------
                  ;
                  ; the logfile mailslot is first checked and fully emptied
                  ;
                  ;
                  message_n = 0                                                            ; used to store how many messages are left
                  message_l = 0                                                            ; used to store the size of the next message
                  GetMailslotInfo_(mailslot_log_h,0,@message_l,@message_n,0)
                  While message_n > 0                                                        ; for any messages found
                    message_p = AllocateMemory(message_l)                                    ; create space to receive the message
                    bytes_read = 0                                                           ; reserve a long to store the number of bytes read
                    ReadFile_(mailslot_log_h,message_p,message_l,@bytes_read,0)              ; read specified number of bytes from the mailslot handle into the string message.s
                    FreeMemory(message_p)
                    GetMailslotInfo_(mailslot_log_h,0,@message_l,@message_n,0)               ; more to read?
                  Wend
                  ;
                  ; i've now emptied the logfile mailslot, let's continue with the command mailslot (no queueing)
                  ;
                  message_n = 0                                                              ; used to store how many messages are left
                  message_l = 0                                                              ; used to store the size of the next message
                  GetMailslotInfo_(mailslot_command_h,0,@message_l,@message_n,0)
                  If message_n > 0                                                           ; any commands?
                    ;
                    While message_n > 0                                                      ; for any messages found
                      message_p = AllocateMemory(message_l)                                  ; reserve space to receive the message
                      bytes_read = 0
                      ReadFile_(mailslot_command_h,message_p,message_l,@bytes_read,0)        ; read specified number of bytes from the mailslot handle into the string message.s
                      message = x_peeks(message_p,message_l,#PB_UTF8)
                      FreeMemory(message_p)
                      GetMailslotInfo_(mailslot_command_h,0,@message_l,@message_n,0)         ; more to read?
                    Wend
                    ;
                    x_parse(message," ",#x_parse_trim|#x_parse_eol)                          ; x_parsed = 'CMD'
                    If x_parsed <> "CMD"
                      x_log(message)
                      x_log("*** unexpected message from other instance")
                    Else                                                                     ; goodie! it's a command, we'll do something with it...
                      ;
                      ; some sort of push forward code would be great here, but i haven't got a clue how to get
                      ; it working :-(
                      ;
                      x_parsestring(" ")                                                     ; x_parsed = 'FIND'
                      cmd = x_parsed
                      x_parsestring(Chr(34))
                      x_parsenext()                                                          ; x_parsed = 'test.pb' (without the doublequote)
                      par1 = x_parsed
                      x_parsenext()
                      x_parsenext()                                                          ; x_parsed = 'x'
                      par2 = x_parsed
                      ;
                      Select cmd
                          Case "FIND"
                            file = par1
                            search_string = par2
                            search_start()
                            If splitter_max
                              splitter_max = #False
                            EndIf
                            draw()
                            reflect_settings()
                          Case "QUICKHELP"
                            action = #f_quickhelp
                          Case "INFO"
                            file = par1
                            caddyfile = file+".cdy"
                            read_caddyfile()
                            action = #f_display_info                                             ; leave the actual action to the 'action' section below
                          Case "GUI"
                          Case "WAKEUP"
                          Default
                            x_log("*** unknown command from other instance")
                      EndSelect
                      ;
                      If GetForegroundWindow_() <> w_main_h
                        t1 = GetWindowThreadProcessId_(GetForegroundWindow_(),0)
                        t2 = GetWindowThreadProcessId_(w_main_h,0)
                        If t1 <> t2
                          AttachThreadInput_(t1,t2,#True)
                        EndIf
                        SetForegroundWindow_(w_main_h)
                        Sleep_(256)
                        If t1 <> t2
                          AttachThreadInput_(t1,t2,#False)
                        EndIf
                      EndIf
                    EndIf
                  EndIf
                  ;
                  ; -----------------------------------------------------------------------------------------------
                  ;
                  ; MAIN WINDOW STANDARD EVENTS
                  ;
                  ; -----------------------------------------------------------------------------------------------
                  ;
                Case #PB_Event_Menu
                  ;
                  ; handle all events generated by toolbar buttons or menus
                  ;
                  action = event_menu                       ; i use #f... to identify actions which includes menu entries
                  ;
                Case #PB_Event_CloseWindow
                  ;
                  action = #f_file_exit
                  ;
                Case #PB_Event_SizeWindow
                  ;
                  ; pre 5.30 this would trigger a redraw, now the redraw needs to be handled within a callback
                  ;
                  ; draw()
                  ;
                Case #PB_Event_Gadget
                  ;
                  ; -----------------------------------------------------------------------------------------------
                  ;
                  ; MAIN WINDOW GADGETS
                  ;
                  ; -----------------------------------------------------------------------------------------------
                  ;
                  ; handle all buttons or other gadget events
                  ;
                  Select event_gadget
                      Case #g_open_search
                        action = #f_search_window
                      Case #g_search_pause
                        action = #f_search_pause
                      Case #g_filter_categorized
                        action = #f_filter_categorized
                      Case #g_filter_procedure
                        action = #f_filter_procedure
                      Case #g_filter_structure
                        action = #f_filter_structure
                      Case #g_filter_constant
                        action = #f_filter_constant
                      Case #g_filter_variable
                        action = #f_filter_variable
                      Case #g_filter_all
                        action = #f_filter_all
                      Case #g_exit
                        action = #f_file_exit
                      Case #g_show_menu
                        action = #f_show_menu
                      Case #g_splitter_zoom
                        action = #f_splitter_zoom
                      Case #g_splitter
                        ;
                        ; there is no way to discern between splitter events caused by resizing the gadget
                        ; or caused by moving the splitter bar :-(
                        ;
                        ; but... here's the work around... thx to rescator for the inspiration, all mistakes
                        ; below are all mine :-)...
                        ;
                        ; if the size of the splitter gadget did not change the event was caused by dragging
                        ; the splitter bar... now let's hope there are no other events that cause this :-(
                        ;
                        height = GadgetHeight(#g_splitter)
                        width = GadgetWidth(#g_splitter)
                        If old_splitter_height = height And old_splitter_width = width And height > 0
                          splitter_permileage = 1000*GetGadgetState(#g_splitter)/height
                          If splitter_max = #True
                            splitter_max = #False
                            reflect_settings()
                          EndIf
                        EndIf
                        old_splitter_height = height
                        old_splitter_width = width
                        ;
                      Case #g_help
                        action = #f_quickhelp
                      Case #g_open_prefs
                        action = #f_open_prefs
                      Case #g_show_keepontop
                        action = #f_show_keepontop
                      Case #g_listpanel
                        Select event_type
                            Case #PB_EventType_Change                                      ; content change or cursor move
                              update_codepanel(-1)
                            Case #PB_EventType_LeftDoubleClick                             ; double click on a listicon element in the list panel
                              action = #f_splitter_zoom                                    ; will zoom in
                              update_codepanel(-1)
                            Default
                        EndSelect
                      Default
                  EndSelect
                  ;
                Default
            EndSelect
            ;
          Case #w_prefs_nr
            ;
            ; -----------------------------------------------------------------------------------------------
            ;
            ; PREFS WINDOW
            ;
            ; -----------------------------------------------------------------------------------------------
            ;
            ; *** prefs window events ***
            ;
            ;
            Select event
                Case #PB_Event_Menu
                  action = event_menu
                  ;
                Case #PB_Event_CloseWindow
                  show_prefs = #False
                  draw()
                  ;
                Case #PB_Event_Gadget
                  ;
                  Select event_gadget
                      Case #g_prefs_compilerun_autosaveinterval
                      Case #g_prefs_compilerun_savefrequency
                      Case #g_prefs_format_multiline_indent
                      Case #g_prefs_format_procedure_space
                      Case #g_prefs_save_length
                      Case #g_prefs_save_max
                      Case #g_prefs_spacing_buttons
                      Case #g_prefs_spacing_frame
                      Case #g_prefs_codesync_baklimit
                      Case #g_prefs_search_firstnr
                      Case #g_prefs_font
                        ;
                        ; change font
                        ;
                        nearby_dialog()
                        If FontRequester(font_name,font_size,0) > 0
                          prefs_font_name = SelectedFontName()
                          prefs_font_size = SelectedFontSize()
                          SetGadgetText(#g_prefs_font_t,prefs_font_name+" "+Str(prefs_font_size))
                        EndIf
                        ;
                      Case #g_prefs_apply
                        ;
                        ; apply prefs settings
                        ;
                        prefs_set()
                        colorset(show_darkercolors)
                        remember_selected()
                        draw()
                        findback_selected()
                        reflect_settings()
                        If show_keepontop
                          SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
                          SetForegroundWindow_(w_main_h)
                        Else
                          SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
                          SetForegroundWindow_(w_main_h)
                        EndIf
                        ;            ;
                      Case #g_prefs_ok
                        ;
                        ; apply and exit prefs
                        ;
                        action = #f_prefs_ok
                        ;
                      Case #g_prefs_cancel
                        ;
                        show_prefs = #False
                        draw()
                        ;
                      Case #g_prefs_reset
                        ;
                        action = #f_prefs_resetconfig
                        ;
                      Case #g_prefs_save
                        ;
                        prefs_set()
                        colorset(show_darkercolors)
                        remember_selected()
                        findback_selected()
                        reflect_settings()
                        write_config()
                        ;
                      Case #g_prefs_search_basic
                        ;
                        ; keep track of line on which edits take place
                        ;
                        y_basic = SendMessage_(GadgetID(#g_prefs_search_basic),#EM_LINEFROMCHAR,-1,0)
                        ;
                      Case #g_prefs_search_extended
                        ;
                        y_extended = SendMessage_(GadgetID(#g_prefs_search_extended),#EM_LINEFROMCHAR,-1,0)
                        ;
                      Case #g_prefs_search_basic_file
                        ;
                        ; select a file, add selection to editor gadget
                        ;
                        nearby_dialog()
                        s = OpenFileRequester("Include file","","All (*.*)|*.*|PureBasic (*.PB)|*.PB|Text (*.TXT)|*.TXT",0)
                        If s <> ""
                          AddGadgetItem(#g_prefs_search_basic,y_basic,s)
                          SetActiveGadget(#g_prefs_search_basic)
                        EndIf
                        ;
                      Case #g_prefs_search_basic_folder
                        ;
                        ; select a folder, add selection to the editor gadget
                        ;
                        nearby_dialog()
                        s = PathRequester("Include path",GetPathPart(configfile))
                        If s <> ""
                          AddGadgetItem(#g_prefs_search_basic,y_basic,s+"*.PB ++")
                          SetActiveGadget(#g_prefs_search_basic)
                        EndIf
                        ;
                      Case #g_prefs_search_extended_file
                        ;
                        nearby_dialog()
                        s = OpenFileRequester("Include file","","All (*.*)|*.*|PureBasic (*.PB)|*.PB|Text (*.TXT)|*.TXT",0)
                        If s <> ""
                          AddGadgetItem(#g_prefs_search_extended,y_extended,s)
                          SetActiveGadget(#g_prefs_search_extended)
                        EndIf
                        ;
                      Case #g_prefs_search_extended_folder
                        ;
                        ; select a folder, add selection to the editor gadget
                        ;
                        nearby_dialog()
                        s = PathRequester("Include path",GetPathPart(configfile))
                        If s <> ""
                          AddGadgetItem(#g_prefs_search_extended,y_extended,s+"*.PB ++")
                          SetActiveGadget(#g_prefs_search_extended)
                        EndIf
                        ;
                      Case #g_prefs_codesync_select1
                        ;
                        nearby_dialog()
                        s = GetGadgetText(#g_prefs_codesync_folder1)
                        s = PathRequester("Codesync: select folder",s)
                        If s <> ""
                          SetGadgetText(#g_prefs_codesync_folder1,s)
                          SetActiveGadget(#g_prefs_codesync_folder1)
                        EndIf
                        ;
                      Case #g_prefs_codesync_select2
                        ;
                        nearby_dialog()
                        s = GetGadgetText(#g_prefs_codesync_folder2)
                        s = PathRequester("Codesync: select folder",s)
                        If s <> ""
                          SetGadgetText(#g_prefs_codesync_folder2,s)
                          SetActiveGadget(#g_prefs_codesync_folder2)
                        EndIf
                        ;
                      Default
                  EndSelect
                  ;
                Default
            EndSelect
            ;
            ; -----------------------------------------------------------------------------------------------
            ;
            ; OTHER WINDOWS
            ;
            ; -----------------------------------------------------------------------------------------------
            ;
            
          Case x_log_window_nr
            ;
            ; *** log window events ***
            ;
            Select event
                Case #PB_Event_CloseWindow
                  x_log_closewindow()
                  ;
                Case #PB_Event_SizeWindow
                  x_log_window(-1,-1,-1,-1)
                  ;
            EndSelect
            ;
          Case #w_about_nr
            ;
            Select event
                Case #PB_Event_CloseWindow
                  CloseWindow(#w_about_nr)
                  ;
                Case #PB_Event_Gadget
                  ;
                  Select event_gadget
                      Case #g_about_wackoware
                        CloseWindow(#w_about_nr)
                  EndSelect
                  ;
            EndSelect
            ;
          Case #w_flash_nr
            ;
            Select event
                Case #PB_Event_CloseWindow
                  CloseWindow(#w_flash_nr)
            EndSelect
            ;
      EndSelect
      ;
      ; -----------------------------------------------------------------------------------------------
      ;
      ; TAKE 'ACTION'
      ;
      ; -----------------------------------------------------------------------------------------------
      ;
      ; processed all 'windows' events, an event may not have performed the action itself, or
      ; it may have set the action variable which will cause further action(s) starting here
      ;
      ; note that menu's and toolbars generate #PB_Event_Menu events, which are trapped above, and which assign
      ; the button number or menu number to the action variable (see above, action = event_menu), in other words
      ; I was lazy :-/ or smart :-)
      ;
      ; in other words: the moment I trap a button or menu, I won't take immediate action, but set the variable
      ; action.i to a specific value, upon which an action is taken, this way totally different gagdets can
      ; trigger the same and identical reaction
      ;
      Select action
          Case #f_search_window
            ;
            search_window()
            If splitter_max
              splitter_max = #False
              draw()
              reflect_settings()
              update_codepanel(-1)
            EndIf
            ;
          Case #f_search_pause
            ;
            ; halt searching
            ;
            If search_status = #status_paused
              search_status = #status_searching
            ElseIf search_status = #status_searching
              search_status = #status_paused
              If IsStatusBar(#sb_main_nr)
                StatusBarText(#sb_main_nr,1," on hold")
              EndIf
            Else
              search_status = #status_ready
            EndIf
            reflect_settings()
            ;
          Case #f_search_next
            ;
            ; next entry
            ;
            If splitter_max
              If show_unzoom
                splitter_max = #False
                draw()
                reflect_settings()
              EndIf
              SetActiveGadget(#g_codepanel)
            EndIf
            ;
            update_codepanel(list_selected+1)
            ;
          Case #f_search_previous
            ;
            ; previous entry
            ;
            If splitter_max
              If show_unzoom
                splitter_max = #False
                draw()
                reflect_settings()
              EndIf
              SetActiveGadget(#g_codepanel)
            EndIf
            ;
            update_codepanel(list_selected-1)
            ;
          Case #f_search_toggle
            ;
            ; toggle wildcard support and start a search action with the last search parameters
            ;
            search_wildcards = x_not(search_wildcards)
            reflect_settings()
            search_start()
            ;
          Case #f_search_widen
            ;
            ; toggle widened seach (adding * and removing spaces)
            ;
            search_widen = x_not(search_widen)
            reflect_settings()
            ;
          Case #f_search_narrow
            ;
            ; toggle narrowed search (remove +-/* unless listed in pattern)
            ;
            search_narrow = x_not(search_narrow)
            reflect_settings()
            ;
          Case #f_search_beginwith
            ;
            ; toggle search restriction to words starting with search term
            ;
            search_beginwith = x_not(search_beginwith)
            reflect_settings()
            ;
          Case #f_search_included
            ;
            ; include 'include' files in search
            ;
            search_included = x_not(search_included)
            reflect_settings()
            ;
          Case #f_filter_categorized
            ;
            ; only show top picks
            ;
            filter_type = #f_filter_categorized
            splitter_max = #False
            draw()
            reflect_settings()
            SetActiveGadget(#g_listpanel)
            ;
          Case #f_filter_procedure
            ;
            ; only show procedures
            ;
            filter_type = #f_filter_procedure
            splitter_max = #False
            draw()
            reflect_settings()
            SetActiveGadget(#g_listpanel)
            ;
          Case #f_filter_structure
            ;
            ; only show structures
            ;
            filter_type = #f_filter_structure
            splitter_max = #False
            draw()
            reflect_settings()
            SetActiveGadget(#g_listpanel)
            ;
          Case #f_filter_constant
            ;
            ; only show constants
            ;
            filter_type = #f_filter_constant
            splitter_max = #False
            draw()
            reflect_settings()
            SetActiveGadget(#g_listpanel)
            ;
          Case #f_filter_variable
            ;
            ; only show variables
            ;
            filter_type = #f_filter_variable
            splitter_max = #False
            draw()
            reflect_settings()
            SetActiveGadget(#g_listpanel)
            ;
          Case #f_filter_all
            ;
            ; show any matches
            ;
            filter_type = #f_filter_all
            splitter_max = #False
            draw()
            reflect_settings()
            SetActiveGadget(#g_listpanel)
            ;
          Case #f_splitter_zoom
            ;
            ; zoom in / out (splitter maximizing) and load all code, if any
            ;
            splitter_max = x_not(splitter_max)
            draw()
            reflect_settings()
            update_codepanel(-1)
            If splitter_max
              SetActiveGadget(#g_codepanel)
            Else
              SetActiveGadget(#g_listpanel)
            EndIf
            ;
          Case #f_show_menu
            ;
            ; toggle flag: show menu
            ;
            show_menu = x_not(show_menu)
            draw()
            reflect_settings()
            ;
          Case #f_show_toolbar
            ;
            ; toggle flag: show toolbar
            ;
            show_toolbar = x_not(show_toolbar)
            draw()
            reflect_settings()
            ;
          Case #f_show_buttons
            ;
            ; toggle flag: show buttonbar
            ;
            show_buttons = x_not(show_buttons)
            draw()
            reflect_settings()
            ;
          Case #f_show_statusbar
            ;
            ; toggle flag: show statusbar
            ;
            show_statusbar = x_not(show_statusbar)
            draw()
            reflect_settings()
            ;
          Case #f_show_darkercolors
            ;
            ; toggle darker colors
            ;
            show_darkercolors = x_not(show_darkercolors)
            colorset(show_darkercolors)
            remember_selected()
            findback_selected()
            reflect_settings()
            ;
          Case #f_show_keepontop
            ;
            ; toggle flag: keep main window as top window
            ;
            show_keepontop = x_not(show_keepontop)
            draw()
            If show_keepontop
              SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
              SetForegroundWindow_(w_main_h)
            Else
              SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
              SetForegroundWindow_(w_main_h)
            EndIf
            reflect_settings()
            ;
          Case #f_prep_addconstants
            ;
            ; toggle flag: add constants (counters) to file before passing it to the compiler
            ;
            prep_addconstants = x_not(prep_addconstants)
            reflect_settings()
            ;
          Case #f_prep_multiline
            ;
            ; toggle flag: flatten before compiling
            ;
            prep_multiline = x_not(prep_multiline)
            reflect_settings()
            ;
          Case #f_prep_thinbuilds
            ;
            ; toggle flag: remove unused procedures and macros from builds
            ;
            prep_thinbuilds = x_not(prep_thinbuilds)
            reflect_settings()
            ;
          Case #f_log_maintain
            ;
            ; toggle flag: use and maintain logfile
            ;
            log_maintain = x_not(log_maintain)
            x_log_inhibit(x_not(log_maintain))
            reflect_settings()
            ;
          Case #f_log_showoncmd
            ;
            ; toggle flag: always show logfile on a call with command line parameters
            ;
            log_showoncmd = x_not(log_showoncmd)
            reflect_settings()
            ;
          Case #f_log_showonerror
            ;
            ; toggle flag: show log file on error
            ;
            log_showonerror = x_not(log_showonerror)
            reflect_settings()
            ;
          Case #f_open_prefs
            ;
            ; bring up preferences window
            ;
            show_prefs = #True
            draw()
            SetActiveGadget(#g_prefs_panel)
            prefs_get()
            ;
          Case #f_config_savenow
            ;
            ; save current configuration
            ;
            draw()
            write_config()
            ;
          Case #f_config_saveonexit
            ;
            ; automatically save configuration upon exit
            ;
            config_saveonexit = x_not(config_saveonexit)
            reflect_settings()
            ;
          Case #f_format_keywords
            ;
            ; change keywords used for reformatting (brings up prefs window)
            ;
            show_prefs = #True
            draw()
            prefs_get()
            SetGadgetState(#g_prefs_panel,4)
            ;
          Case #f_search_extra
            ;
            ; show / hide additional info (formerly known as 'fluff' :-))
            ;
            remember_selected()
            search_extra = x_not(search_extra)
            findback_selected()
            reflect_settings()
            ;
          Case #f_search_plus
            ;
            ; increase search results for categorized screen
            ;
            remember_selected()
            search_firstnr = x_min(search_firstnr+1,10)
            findback_selected()
            ;
          Case #f_search_min
            ;
            ; decrease search results for categorized screen
            ;
            remember_selected()
            search_firstnr = x_max(search_firstnr-1,1)
            findback_selected()
            ;
          Case #f_search_files
            ;
            ; change files / paths being searched upon a find command
            ;
            show_prefs = #True
            draw()
            prefs_get()
            SetGadgetState(#g_prefs_panel,5)
            SetActiveGadget(#g_prefs_search_basic)
            ;
          Case #f_copy
            ;
            s = ""
            p = x_getlisticonnextselected(#g_codepanel,-1)
            While p > -1
              s = s+GetGadgetItemText(#g_codepanel,p,0)+#CRLF$
              p = x_getlisticonnextselected(#g_codepanel,p)
            Wend
            SetClipboardText(s)
            ;
          Case #f_edit
            ;
            x_log(ProgramFilename())
            x_log(file)
            ;
            RunProgram(GetPathPart(ProgramFilename())+"purebasic.exe",hit_file,"",0)
            ;
          Case #f_quickhelp
            display_quickhelp(0)
          Case #f_license
            display_quickhelp(1)
          Case #f_about
            display_about()
          Case #f_flash
            display_flash()
          Case #f_display_logfile
            display_logfile()
          Case #f_display_info
            display_info()
          Case #f_prefs_resetconfig
            ;
            ; delete codecaddy.cfg file and restore default settings
            ;
            ; save 6208 rebuild for pb4.x dunno if the next line is actually used...
            ;
            ; UseWindow(#w_prefs_nr)
            ;
            nearby_dialog()
            If MessageRequester("Preferences","Restore and save default configuration."+#CRLF$+ "All changes will be lost."+#CRLF$+#CRLF$+"Are you sure?",#MB_YESNO|#MB_ICONWARNING) = #IDYES
              show_prefs = #False
              DeleteFile(configfile)
              read_config()
              FreeMenu(#m_main_nr)
              CloseWindow(#w_main_nr)
              If IsWindow(#w_prefs_nr)
                CloseWindow(#w_prefs_nr)
              EndIf
              If IsWindow(#w_about_nr)
                CloseWindow(#w_about_nr)
              EndIf
              clear_listarray()
              draw()
              reflect_settings()
            EndIf
            ;
          Case #f_prefs_ok
            ;
            ; confirm set config
            ;
            show_prefs = #False
            prefs_set()
            colorset(show_darkercolors)
            remember_selected()
            draw()
            findback_selected()
            reflect_settings()
            If show_keepontop
              SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_SHOWWINDOW|#SWP_NOSIZE)
              SetForegroundWindow_(w_main_h)
            Else
              SetWindowPos_(w_main_h,#HWND_NOTOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
              SetForegroundWindow_(w_main_h)
            EndIf
            ;
          Case #f_tools_format
            ;
            ; format selected file
            ;
            nearby_dialog()
            file = OpenFileRequester("Format: select file","","PureBasic (*.PB)|*.PB|Any (*.*)|*.*",0)
            If file > ""
              If x_not(x_exist(file))
                nearby_dialog()
                MessageRequester("Format","Error! File not found."+#CRLF$+#CRLF$+"file: "+ _
                  file,#MB_OK|#MB_ICONWARNING)
              Else
                format()
                nearby_dialog()
                MessageRequester("Format","The code in source has been reformatted."+ #CRLF$+#CRLF$+ _
                  "source: "+file+#CRLF$+"backup: "+backupfile,#MB_OK|#MB_ICONINFORMATION)
              EndIf
            EndIf
            ;
          Case #f_tools_flatten
            ;
            ; flatten selected file
            ;
            nearby_dialog()
            file = OpenFileRequester("Flatten: select input file (remove multiline constructions)","","PureBasic (*.PB)|*.PB|Any (*.*)|*.*",0)
            If file > ""
              If x_not(x_exist(file))
                nearby_dialog()
                MessageRequester("Flatten","Error! File not found."+#CRLF$+#CRLF$+"file: "+file,#MB_OK|#MB_ICONWARNING)
              Else
                nearby_dialog()
                dest = SaveFileRequester("Flatten: select output file (remove multiline constructions)","", _
                  "PureBasic (*.PB)|*.PB|Any (*.*)|*.*",0)
                If Len(dest) > 0 And FindString(dest,".",1) = 0 And SelectedFilePattern() = 0
                  dest = dest+".pb"
                EndIf
                If file = dest
                  nearby_dialog()
                  MessageRequester("Flatten","Error! Source and destination must be different."+#CRLF$+#CRLF$+ "source: "+ _
                    file+#CRLF$+"destination: "+dest,#MB_OK|#MB_ICONWARNING)
                ElseIf dest > ""
                  x_log("flatten "+Chr(34)+file+" "+Chr(34)+" "+Chr(34)+dest+Chr(34))
                  ReadFile(1,file)
                  CreateFile(2,dest)
                  flatten()
                  CloseFile(1)
                  CloseFile(2)
                  nearby_dialog()
                  MessageRequester("Flatten","The code in source has been flattened to destination." + _
                    #CRLF$+"(All multiline constructions have been removed.)"+ _
                    #CRLF$+#CRLF$+"source: "+file+#CRLF$+"destination: "+dest,#MB_OK|#MB_ICONINFORMATION)
                EndIf
              EndIf
            EndIf
            ;
          Case #f_tools_thinner
            ;
            ; remove unused procedures
            ;
            nearby_dialog()
            file = OpenFileRequester("Thinner: select input file (remove unused procedures, macros and comments)","", _
              "PureBasic (*.PB)|*.PB|Any (*.*)|*.*",0)
            If file > ""
              If x_not(x_exist(file))
                nearby_dialog()
                MessageRequester("Thinner","Error! File not found."+#CRLF$+#CRLF$+"file: "+file,#MB_OK|#MB_ICONWARNING)
              Else
                nearby_dialog()
                dest = SaveFileRequester("Thinner: select output file (remove unused procedures, macros and comments)", _
                  "","PureBasic (*.PB)|*.PB|Any (*.*)|*.*",0)
                If Len(dest) > 0 And FindString(dest,".",1) = 0 And SelectedFilePattern() = 0
                  dest = dest+".pb"
                EndIf
                If file = dest
                  nearby_dialog()
                  MessageRequester("Thinner","Error! Source and destination must be different."+#CRLF$+#CRLF$+ "source: "+ _
                    file+#CRLF$+"destination: "+dest,#MB_OK|#MB_ICONWARNING)
                ElseIf dest > ""
                  x_log("thinner "+Chr(34)+file+" "+Chr(34)+" "+Chr(34)+dest+Chr(34))
                  thinner(file,dest)
                EndIf
              EndIf
            EndIf
            ;
            ; thinner("c:\software\purebasic\_projects\codecaddy\test.pb","c:\software\purebasic\_projects\codecaddy\test_stripped.pb")
            ;
          Case #f_tools_codesync
            ;
            ; synchronize two folders
            ;
            codesync()
            ;
          Case #f_tools_installinpbide
            ;
            ; install shortcuts into pb ide .prefs file
            ;
            install_inpbide()
            ;
          Default
            ;
            ; do nothing :-) ie. not implemented (yet)
            ;
      EndSelect
      ;
    EndIf
    ;
    ; something may have caused a need to update the listpanel, for example an ongoing search :-) or changing the view mode
    ;
    update_listpanel(0)
    ;
  Until action = #f_file_exit
  ;
  ; store window position
  ;
  w_main_maximized = IsZoomed_(w_main_h)
  If w_main_maximized = #False
    w_main_x = WindowX(#w_main_nr)
    w_main_y = WindowY(#w_main_nr)
    w_main_width = WindowWidth(#w_main_nr)
    w_main_height = WindowHeight(#w_main_nr)
  EndIf
  ;
  If config_saveonexit = #True
    write_config()
  EndIf
  ;
  FreeFont(#font_normal)
  FreeFont(#font_bold)
  ;
EndProcedure

Procedure main()                                           ; command line stuff, may lead to main_loop
  Protected x.s, y.s, z.s, p.i, b.i, l.i, m.i, n.i, margin.i, error.i, phrase.s, dest.s, lasterror.i, c.i
  ;
  ; *** main
  ;
  ; get the config file
  ;
  ; when run with compile/run it will use the path of the sourcefile being run, when
  ; run as compiled executable it will use the place where the executable resides
  ;
  CompilerIf #codecaddy_compilerun = #True
    configfile = GetCurrentDirectory()+"codecaddy.cfg"
  CompilerElse
    configfile = GetPathPart(ProgramFilename())+"codecaddy.cfg"
  CompilerEndIf
  ;
  read_config()
  command = Trim(ProgramParameter())
  ;
  ; single instance or not?
  ;
  mutex_name.s = "codecaddy_mutex"
  mutex_h.i = CreateMutex_(0,#True,@mutex_name)            ; create and try to be the owner
  lasterror = GetLastError_()
  If mutex_h = 0                                           ; cannot create the mutex
    first_instance = #False
  ElseIf lasterror = #ERROR_ALREADY_EXISTS                 ; already exists
    ReleaseMutex_(mutex_h)
    first_instance = #False
  Else                                                              ; can create and own
    first_instance = #True                                          ; so we're the host and now need to create the mailslots
    mailslot_command_h = CreateMailslot_(@mailslot_command,0,0,0)   ; mailslot for commands
    mailslot_log_h = CreateMailslot_(@mailslot_log,0,0,0)           ; mailslot for log entries
  EndIf
  ;
  ; we'll need the wakeup message for inter program communications
  ;
  wakeup_message_nr = RegisterWindowMessage_(@wakeup_message)
  ;
  ; open logfile
  ;
  ; what is exactly logged where depends on the way codecaddy was launched
  ;
  ; when run with compile / run it will store the log file in the current path
  ; run as compiled executable it will store the log file with the executable
  ; if NOT the first instance it will NOT write data to disk
  ;
  If first_instance = #True
    CompilerIf #codecaddy_compilerun = #True
      x_log_set(GetCurrentDirectory()+"codecaddy.log",1,1,200000,x_not(log_maintain),1,"","",1,1,1,0)
    CompilerElse
      x_log_set(GetPathPart(ProgramFilename())+"codecaddy.log",1,1,200000,x_not(log_maintain),1,"","",1,1,1,0)
    CompilerEndIf
  Else
    x_log_set("",1,1,200000,1,1,mailslot_log,"LOG ",1,1,1,0)
  EndIf
  ;
  If log_showoncmd = #True And command <> ""
    x_log_window(w_main_x-20,w_main_y-20,w_main_width,w_main_height)
    x_log_hidewindow(0)
  EndIf
  ;
  x_log("")
  x_log("codecaddy "+#codecaddy_version+" "+#codecaddy_copyright)
  x_log("build "+Str(#codecaddy_build_nr)+FormatDate(" %dd.%mm.%yyyy",#codecaddy_build_date)+" save "+Str(#codecaddy_save_nr))
  x_log(ProgramFilename()+" "+x_osname+" "+x_osversion+" "+x_osbuild+" "+x_ospack)
  ;
  ; execute all commands
  ;
  ; the gui only comes up if this is the first instance, and the specified command would require such
  ; first all commands that do not need a gui
  ;
  If command = "save"
    ;
    ; *** save
    ;
    ; syntax: codecaddy save %file
    ;
    ; 1. create a .bak file in japbe style, ie. filename.pb.####.bak
    ; 2. remove old .bak files if there are too many
    ;
    file = Trim(ProgramParameter())
    x_log("save "+Chr(34)+file+Chr(34))
    If x_not(x_exist(file))
      x_log("*** error: file not found")
      error = #True
    Else
      caddyfile = file+".cdy"
      read_caddyfile()
      save_nr = (save_nr+1) % save_wrap
      timestamp = Date()
      write_caddyfile()
      backup_source()
    EndIf
    ;
  ElseIf command = "snapshot"
    ;
    ; *** save
    ;
    ; syntax: codecaddy snapshot %file
    ;
    ; 1. create a snapshot .bak file, ie. filename.pb.####.snapshot###.bak
    ; 2. remove old .bak files if there are too many (snapshot files are never removed)
    ;
    file = Trim(ProgramParameter())
    x_log("snapshot "+Chr(34)+file+Chr(34))
    If x_not(x_exist(file))
      x_log("*** error: file not found")
      error = #True
    Else
      caddyfile = file+".cdy"
      read_caddyfile()
      save_nr = (save_nr+1) % save_wrap
      timestamp = Date()
      write_caddyfile()
      backup_source()
    EndIf
    ;
  ElseIf command = "run" Or command = "build"
    ;
    ; *** run or build
    ;
    ; syntax: codecaddy run %file %compilefile
    ;
    ; 1. create a .bak file in japbe style every 'n' runs, ie. filename.pb.####.bak
    ; 2. remove superfluous .bak files if we already got too many
    ; 3. add constants to temp file just before compiling
    ;
    file = Trim(ProgramParameter())
    compilefile = Trim(ProgramParameter())
    x_log(command+" "+Chr(34)+file+Chr(34)+" "+Chr(34)+compilefile+Chr(34))
    ;
    If x_exist(compilefile) And file = ""
      x_log("unnamed source, bypassing codecaddy")
    Else
      If x_not(x_exist(file)) Or x_not(x_exist(compilefile))
        x_log("*** error: file not found")
        error = #True
      Else
        caddyfile = file+".cdy"
        read_caddyfile()
        save_nr = (save_nr+1) % save_wrap
        If command = "run"
          compilerun = #True
        Else
          compilerun = #False
          build_nr = build_nr+1
        EndIf
        If compilerun = #False Or (Date()-timestamp) > compilerun_autosaveinterval Or compilerun_savefrequency < 2 Or (save_nr % compilerun_savefrequency) = 0
          timestamp = Date()
          If prep_savebackup = #True
            backup_source()
          EndIf
        EndIf
        write_caddyfile()
        preprocess()
      EndIf
    EndIf
    ;
  ElseIf command = "flatten"
    ;
    ; *** turn multiline statements into singleline statements
    ;
    file = Trim(ProgramParameter())
    dest = Trim(ProgramParameter())
    x_log(command+" "+Chr(34)+file+Chr(34)+" "+Chr(34)+dest+Chr(34))
    If x_not(x_exist(file))
      x_log("*** error: file not found")
      error = #True
    ElseIf dest = ""
      x_log("*** error: no destination file")
      error = #True
    ElseIf file = dest
      x_log("*** error: source and destination are the same file")
      error = #True
    Else
      ReadFile(1,file)
      CreateFile(2,dest)
      ;
      flatten()
      ;
      CloseFile(1)
      CloseFile(2)
    EndIf
    ;
  ElseIf command = "thinner"
    ;
    ; *** combine source and all its includes and strip out unused code
    ;
    file = Trim(ProgramParameter())
    dest = Trim(ProgramParameter())
    x_log(command+" "+Chr(34)+file+Chr(34)+" "+Chr(34)+dest+Chr(34))
    If x_not(x_exist(file))
      x_log("*** error: file not found")
      error = #True
    ElseIf dest = ""
      x_log("*** error: no destination file")
      error = #True
    ElseIf file = dest
      x_log("*** error: source and destination are the same file")
      error = #True
    Else
      thinner(file,dest)
    EndIf
    ;
  ElseIf command = "format"
    ;
    ; *** (re)format whole sourcecode
    ;
    ; syntax: codecaddy format_all
    ;
    ; 1. create a backup
    ; 2. format whole source code
    ;
    file = Trim(ProgramParameter())
    x_log(command+" "+Chr(34)+file+Chr(34))
    format()
    ;
  ElseIf command = "codesync"
    ;
    ; *** synchronize two in prefs specified folders
    ;
    x_log("codesync")
    codesync()
    ;
  ElseIf command = "showlog"
    ;
    ; *** show logfile, for debugging purposes
    ;
    x_log("show log file")
    log_showoncmd = #True                    ; don't mind changing, it's not gonna be saved
    ;
  ElseIf command = "error"
    ;
    ; *** simulate an error
    ;
    x_log("simulate error")
    error = #True
    ;
  ElseIf command = "nothing"
    ;
    ; *** do nothing
    ;
    x_log("do nothing")
    log_showoncmd = #False
    ;
  ElseIf command = ""
    ;
    ; *** go to mainloop
    ;
    x_log("no command")
    If first_instance
      command = "quickhelp"
      main_loop()
    Else
      x_mailslot_sendmessage(mailslot_command,"CMD QUICKHELP",#PB_UTF8)
    EndIf
    ;
  ElseIf command = "quickhelp"
    ;
    ; *** bring quickhelp forward
    ;
    x_log(command)
    If first_instance
      main_loop()
    Else
      x_mailslot_sendmessage(mailslot_command,"CMD QUICKHELP",#PB_UTF8)
    EndIf
    ;
  ElseIf command = "info" Or command = "gui"
    ;
    ; *** show info on codecaddy, os and (optional) on file
    ;
    file = Trim(ProgramParameter())
    If file <>""
      x_log(command+" "+Chr(34)+file+Chr(34))
      If x_not(x_exist(file))
        x_log("*** error: file not found")
        error = #True
      Else
        If first_instance
          caddyfile = file+".cdy"
          read_caddyfile()
          main_loop()
        Else
          x_mailslot_sendmessage(mailslot_command,"CMD INFO "+Chr(34)+file+Chr(34),#PB_UTF8)
        EndIf
      EndIf
    Else
      If first_instance
        main_loop()
      Else
        x_mailslot_sendmessage(mailslot_command,"CMD WAKEUP",#PB_UTF8)
      EndIf
    EndIf
    ;
  ElseIf command = "find"
    ;
    ; *** find search expression in specified file
    ;
    file = Trim(ProgramParameter())
    search_string = Trim(ProgramParameter())
    x_log(command+" "+Chr(34)+file+Chr(34)+" "+Chr(34)+search_string+Chr(34))
    If file <>"" And x_not(x_exist(file))
      x_log("*** error: file not found")
      error = #True
    ElseIf search_string = ""
      If first_instance
        command = "info"
        caddyfile = file+".cdy"
        read_caddyfile()
        main_loop()
      Else
        x_mailslot_sendmessage(mailslot_command,"CMD INFO "+Chr(34)+file+Chr(34),#PB_UTF8)
      EndIf
    Else
      If first_instance
        caddyfile = file+".cdy"
        read_caddyfile()
        main_loop()
      Else
        x_mailslot_sendmessage(mailslot_command,"CMD FIND "+Chr(34)+file+Chr(34)+" "+Chr(34)+search_string+Chr(34),#PB_UTF8)
      EndIf
    EndIf
    ;
  ElseIf command = "google"
    ;
    ; *** look for the specified search term on the internet
    ;
    x = Trim(ProgramParameter())
    y = Trim(ProgramParameter())
    z = Trim(ProgramParameter())
    If y = "" And z = ""
      x_log(command+" "+Chr(34)+x+Chr(34))
    Else
      x_log(command+" "+Chr(34)+x+Chr(34)+" "+Chr(34)+y+Chr(34)+" "+Chr(34)+z+Chr(34))
      l = Val(StringField(z,1,"x"))
      c = Val(StringField(z,1,"x"))
      ;
      ; v2.07 hack... look up specific url, first check if it is an url
      ;
      ReadFile(1,y)
      n = 0
      While n < l And Not Eof(1)
        z = ReadString(1)
        n = n+1
      Wend
      While c > 1 And Mid(z,c-1,1) <> " "
        c = c-1
      Wend
      z = StringField(Mid(z,c),1," ")
      CloseFile(1)
    EndIf
    ;
    If Len(z) > 15 And ( Left(z,7) = "http://" Or Left(z,4) = "www." )
      x_log("browse "+z)
      RunProgram(web_browser,z,"")
    Else
      If x = ""
        x = ""
        y = web_empty
      ElseIf Right(x,1) = "_"
        x = x_chop(x,0,1)
        y = web_underscore
      Else
        x = x
        y = web_other
      EndIf
      m = x_parsefield(y,"|",#x_parse_eol|#x_parse_trim)
      n = 0
      While n < m
        n = n+1
        z = x_parse_field(n)
        z = ReplaceString(z,"%keyword%",x)
        RunProgram(web_browser,z,"")
        If n = 1
          Delay(1000)
        Else
          Delay(100)
        EndIf
      Wend
    EndIf
    ;
  ElseIf command <> ""
    ;
    ; *** unknown command
    ;
    x_log("*** error: unknown command "+Chr(34)+command+Chr(34))
    error = #True
    ;
  EndIf
  ;
  If first_instance
    ReleaseMutex_(mutex_h)
    CloseHandle_(mailslot_command_h)
    CloseHandle_(mailslot_log_h)
  EndIf
  ;
  ; display the log window on commandline + log_showoncmd or log_showonerror
  ;
  If error = #True
    x_log("failed")
    x_log("")
  Else
    x_log("done")
  EndIf
  If w_main_h > 0
    CloseWindow(#w_main_nr)
  ElseIf (command <> "" And log_showoncmd = #True) Or (log_showonerror = #True And error = #True)
    x_log_waitwindow()
  EndIf
  ;
  ; we have an instance detection, but under xp and vista it should be / is impossible to 'steal' focus
  ; but there is nothing that blocks the ACTIVE application of giving focus to someone else so that's
  ; what we do
  ;
  If first_instance = #False
    If x_findwindow("Codecaddy v*",#x_parse_anycase)
      If command = "nothing" Or command = "save" Or command = "run" Or command = "build" Or command = "format" Or command = "flatten"
      Else
        SetForegroundWindow_(x_window_h)
        PostMessage_(x_window_h,wakeup_message_nr,0,0)
      EndIf
    EndIf
  EndIf
EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 1589
; FirstLine = 436
; Folding = JMABACA9
; Markers = 1608,3492
; EnableAsm
; EnableUnicode
; EnableXP
; UseIcon = icons\purebasic_purple.ico
; Executable = codecaddy.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; CompileSourceDirectory
; EnableCompileCount = 1956
; EnableBuildCount = 476
; EnableExeConstant